      SUBROUTINE DITOUT(MM, M, N, A1, CLAB, RLAB, TITLE, NX, X, KC, LC,
     *                  OUNIT)
C
C<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
C
C   PURPOSE
C   -------
C
C      PRINTS OUTPUT FROM DITTO ALGORITHM
C
C   INPUT PARAMETERS
C   ----------------
C
C   MM    INTEGER SCALAR (UNCHANGED ON OUTPUT).
C         THE FIRST DIMENSION OF THE MATRIX A1.
C
C   M     INTEGER SCALAR (UNCHANGED ON OUTPUT).
C         THE NUMBER OF CASES.
C
C   N     INTEGER SCALAR (UNCHANGED ON OUTPUT).
C         THE NUMBER OF VARIABLES.
C
C   A1    MATRIX OF 1-CHARACTER VARIABLES WHOSE FIRST DIMENSION MUST BE
C            MM AND WHOSE SECOND DIMENSION MUST BE AT LEAST N
C            (UNCHANGED ON OUTPUT).
C         THE MATRIX OF VALUES FROM DITTO ROUTINE.
C
C   CLAB  VECTOR OF 4-CHARACTER VARIABLES DIMENSIONED AT LEAST N.
C            (UNCHANGED ON OUTPUT).
C         THE LABELS OF THE VARIABLES.
C
C   RLAB  VECTOR OF 4-CHARACTER VARIABLES DIMENSIONED AT LEAST M.
C            (UNCHANGED ON OUTPUT).
C         THE LABELS OF THE CASES.
C
C   TITLE 10-CHARACTER VARIABLE (CHANGED ON OUTPUT).
C         TITLE OF THE DATA SET.
C
C   NX    INTEGER SCALAR (UNCHANGED ON OUTPUT).
C         THE FIRST DIMENSION OF THE MATRIX X.
C
C   X     MATRIX OF 1-CHARACTER VARIABLES WHOSE FIRST DIMENSION MUST BE
C            NX AND WHOSE SECOND DIMENSION MUST BE AT LEAST N (CHANGED
C            OUTPUT).
C         THE MATRIX OF CLUSTER MODES FROM DITTO ROUTINE.  UPDATED WITH
C            DOTS IF NECESSARY.
C
C   KC    INTEGER SCALAR (UNCHANGED ON OUTPUT).
C         MAXIMUM NUMBER OF CLUSTERS.
C
C   LC    INTEGER VECTOR DIMENSIONED AT LEAST M (UNCHANGED ON OUTPUT).
C         LC(I) IS THE CLUSTER FOR CASE I.
C
C   OUNIT INTEGER SCALAR (UNCHANGED ON OUTPUT).
C         UNIT NUMBER FOR OUTPUT.
C
C   REFERENCE
C   ---------
C
C     HARTIGAN, J. A. (1975).  CLUSTERING ALGORITHMS, JOHN WILEY &
C        SONS, INC., NEW YORK.  PAGE 154.
C
C<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
C
      DIMENSION LC(*)
      INTEGER OUNIT
      CHARACTER*4 CLAB(*), RLAB(*)
      CHARACTER*10 TITLE
      CHARACTER*1 AA(120), DOT, A1(MM,*),X(NX,*)
      DATA DOT /'.'/
C
      WRITE(OUNIT,1) TITLE
    1 FORMAT('1 DOT MATRIX OF  ',A10)
      WRITE(OUNIT,2)
    2 FORMAT(
     *' ALL CLUSTER VALUES ARE REPLACED BY ''.'' IF THEY AGREE '/
     *' WITH VALUE OF GRAND MODE.  WITHIN A CLUSTER, VALUES '/
     *' ARE REPLACED BY ''.'' IF THEY AGREE WITH CLUSTER VALUE.')
      DO 10 K=1,5
         IF(K.GT.N) GO TO 20
   10    WRITE(OUNIT,3)(CLAB(J),J=K,N,5)
    3 FORMAT(13X,15A4)
C
   20 WRITE(OUNIT,4) (X(1,J),J=1,N)
    4 FORMAT('0GRAND MODE',2X,100A1)
      DO 60 K=2,KC
         NC=0
         DO 50 I=1,M
            IF(LC(I).EQ.K) THEN
               NC=NC+1
               DO 30 J=1,N
   30             IF(X(K,J).EQ.X(1,J)) X(K,J)=DOT
               IF(NC.EQ.1) WRITE(OUNIT,5) K,(X(K,J),J=1,N)
    5          FORMAT('0CLUSTER',I2,3X,100A1)
               DO 40 J=1,N
                  AA(J)=A1(I,J)
                  IF(X(K,J).EQ.DOT) X(K,J)=X(1,J)
   40             IF(A1(I,J).EQ.X(K,J)) AA(J)= DOT
               WRITE(OUNIT,6) RLAB(I),(AA(J),J=1,N)
    6          FORMAT(5X,A4,4X,120A1)
            ENDIF
   50    CONTINUE
   60 CONTINUE
      RETURN
      END
