      INTEGER FUNCTION KC(A, AMIN, AMAX, NC)
C
C<><><><><><><><><><><><><><><><><>><><><><><><><><><><><><><><><><><><>
C
C   DESCRIPTION
C   -----------
C
C       MAPS A VALUE INTO A SCALED INTERVAL.  THE VALUE IS STORED IN A
C       AND THE SMALLEST POSSIBLE VALUE OF A IS STORED IN AMIN AND THE
C       LARGEST POSSIBLE VALUE OF A IN AMAX.  THE INTERVAL TO BE MAPPED
C       INTO IS THE INTERVAL [1,NC].
C
C   INPUT PARAMETERS
C   ----------------
C
C   A     REAL SCALAR (UNCHANGED ON OUTPUT).
C         THE VALUE TO BE MAPPED.
C
C   AMIN, AMAX  REAL SCALAR (UNCHANGED ON OUTPUT).
C         THE SMALLEST AND LARGEST VALUES FOR THE INTERVAL TO BE MAPPED
C             FROM.
C
C   NC    INTEGER SCALAR (UNCHANGED ON OUTPUT).
C         THE LARGEST VALUE FOR THE INTERVAL TO BE MAPPED INTO.
C
C   OUTPUT PARAMETER
C   ----------------
C
C   KC    INTEGER SCALAR
C         THE MAPPED VALUE.
C
C<><><><><><><><><><><><><><><><><>><><><><><><><><><><><><><><><><><><>
C
      KC=INT((A-AMIN)*NC/(AMAX-AMIN)+1.00001)
      IF(KC.LT.1) KC=1
      IF(KC.GT.NC) KC=NC
      RETURN
      END
