      SUBROUTINE REMOVE(DMCOV, N, COV, I, S)
C
C<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
C
C   PURPOSE
C   -------
C
C      COMPUTES PARTIAL CORRELATIONS ON ARRAY COV, REMOVING VARIABLE I
C
C   INPUT PARAMETERS
C   ----------------
C
C   DMCOV INTEGER SCALAR (UNCHANGED ON OUTPUT).
C         THE FIRST DIMENSION OF THE MATRIX COV.  MUST BE AT LEAST N.
C
C   N     INTEGER SCALAR (UNCHANGED ON OUTPUT).
C         THE NUMBER OF ROWS AND COLUMNS OF MATRIX COV.
C
C   COV   REAL MATRIX WHOSE FIRST DIMENSION MUST BE DMCOV AND WHOSE
C            SECOND DIMENSION MUST BE AT LEAST N. (CHANGED ON OUTPUT).
C         THE COVARIANCE MATRIX.
C
C   I     INTEGER SCALAR (UNCHANGED ON OUTPUT).
C         THE NUMBER OF THE VARIABLE TO BE REMOVED.
C
C   S     REAL VECTOR DIMENSIONED AT LEAST N (UNCHANGED ON OUTPUT).
C         S(J) .NE. 0.  MEANS ROW J WILL BE CONSIDERED IN THE
C            CALCULATION FOR J = 1,...,N.
C         OTHERWISE, ROW J WILL NOT BE CONSIDERED
C
C   REFERENCE
C   ---------
C
C     HARTIGAN, J. A. (1975).  CLUSTERING ALGORITHMS, JOHN WILEY &
C        SONS, INC., NEW YORK.  PAGE 329.
C
C<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
C
      INTEGER DMCOV
      DIMENSION COV(DMCOV,*), S(*)
C
      TH=.0005
      IF (COV(I,I).LT.TH.OR.S(I).EQ.0.) RETURN
      DO 20 J=1,N
         IF (J.NE.I.AND.S(J).NE.0.) THEN
            DO 10 K=1,N
               IF (S(K).NE.0.)
     *            COV(J,K)=COV(J,K)-COV(I,J)*COV(I,K)/COV(I,I)
   10       CONTINUE
         ENDIF
   20 CONTINUE
      RETURN
      END
