      FUNCTION ALI(X)
C***BEGIN PROLOGUE  ALI
C***DATE WRITTEN   770601   (YYMMDD)
C***REVISION DATE  820801   (YYMMDD)
C***CATEGORY NO.  C5
C***KEYWORDS  LOGARITHMIC INTEGRAL,SPECIAL FUNCTION
C***AUTHOR  FULLERTON, W., (LANL)
C***PURPOSE  Computes the logarithmic integral.
C***DESCRIPTION
C
C ALI(X) computes the logarithmic integral; i.e., the
C integral from 0.0 to X of (1.0/ln(t))dt.
C***REFERENCES  (NONE)
C***ROUTINES CALLED  EI,XERROR
C***END PROLOGUE  ALI
C***FIRST EXECUTABLE STATEMENT  ALI
      IF (X.LE.0.0) CALL XERROR (  'ALI     LOG INTEGRAL UNDEFINED FOR X
     1 LE 0', 41, 1, 2)
      IF (X.EQ.1.0) CALL XERROR (  'ALI     LOG INTEGRAL UNDEFINED FOR X
     1 = 1', 40, 2, 2)
C
      ALI = EI (ALOG(X) )
C
      RETURN
      END
