      FUNCTION BETA(A,B)
C***BEGIN PROLOGUE  BETA
C***DATE WRITTEN   770601   (YYMMDD)
C***REVISION DATE  820801   (YYMMDD)
C***CATEGORY NO.  C7B
C***KEYWORDS  BETA FUNCTION,COMPLETE BETA FUNCTION,SPECIAL FUNCTION
C***AUTHOR  FULLERTON, W., (LANL)
C***PURPOSE  Computes the complete Beta function.
C***DESCRIPTION
C
C BETA computes the complete beta function.
C
C Input Parameters:
C       A   real and positive
C       B   real and positive
C***REFERENCES  (NONE)
C***ROUTINES CALLED  ALBETA,GAMLIM,GAMMA,R1MACH,XERROR
C***END PROLOGUE  BETA
      EXTERNAL GAMMA
      DATA XMAX, ALNSML /0., 0./
C***FIRST EXECUTABLE STATEMENT  BETA
      IF (XMAX.NE.0.) GO TO 10
      CALL GAMLIM (XMIN, XMAX)
      ALNSML = ALOG(R1MACH(1))
C
 10   IF (A.LE.0. .OR. B.LE.0.) CALL XERROR ( 'BETA    BOTH ARGUMENTS MU
     1ST BE GT 0', 35, 2, 2)
C
      IF (A+B.LT.XMAX) BETA = GAMMA(A) * GAMMA(B) / GAMMA(A+B)
      IF (A+B.LT.XMAX) RETURN
C
      BETA = ALBETA (A, B)
      IF (BETA.LT.ALNSML) CALL XERROR (  'BETA    A AND/OR B SO BIG BETA
     1 UNDERFLOWS', 41, 1, 2)
C
      BETA = EXP (BETA)
C
      RETURN
      END
