      COMPLEX FUNCTION CCOT(Z)
C***BEGIN PROLOGUE  CCOT
C***DATE WRITTEN   770401   (YYMMDD)
C***REVISION DATE  820801   (YYMMDD)
C***CATEGORY NO.  C4A
C***KEYWORDS  COMPLEX,COTANGENT,ELEMENTARY FUNCTION
C***AUTHOR  FULLERTON, W., (LANL)
C***PURPOSE  Computes the complex Cotangent.
C***DESCRIPTION
C
C CCOT(Z) calculates the comlex trigonometric cotangent of Z.
C***REFERENCES  (NONE)
C***ROUTINES CALLED  R1MACH,XERCLR,XERROR
C***END PROLOGUE  CCOT
      COMPLEX Z
      DATA SQEPS /0./
C***FIRST EXECUTABLE STATEMENT  CCOT
      IF (SQEPS.EQ.0.) SQEPS = SQRT (R1MACH(4))
C
      X2 = 2.0*REAL(Z)
      Y2 = 2.0*AIMAG(Z)
C
      SN2X = SIN (X2)
      CALL XERCLR
C
      DEN = COSH(Y2) - COS(X2)
      IF (DEN.EQ.0.) CALL XERROR (  'CCOT    COT IS SINGULAR FOR INPUT Z
     1 (X IS 0 OR PI AND Y IS 0)'  , 61, 2, 2)
C
      IF (ABS(DEN).GT.AMAX1(ABS(X2),1.)*SQEPS) GO TO 10
      CALL XERCLR
      CALL XERROR ( 'CCOT    ANSWER LT HALF PRECISION, ABS(X) TOO BIG OR
     1 X TOO NEAR 0 OR PI', 70, 1, 1)
C
 10   CCOT = CMPLX (SN2X/DEN, -SINH(Y2)/DEN)
C
      RETURN
      END
