      COMPLEX FUNCTION CTAN(Z)
C***BEGIN PROLOGUE  CTAN
C***DATE WRITTEN   770401   (YYMMDD)
C***REVISION DATE  820801   (YYMMDD)
C***CATEGORY NO.  C4A
C***KEYWORDS  COMPLEX,ELEMENTARY FUNCTION,TANGENT
C***AUTHOR  FULLERTON, W., (LANL)
C***PURPOSE  Computes the complex Tangent.
C***DESCRIPTION
C
C CTAN(Z) calculates the complex trigonometric tangent of complex
C argument Z.  Z is in units of radians.
C***REFERENCES  (NONE)
C***ROUTINES CALLED  R1MACH,XERCLR,XERROR
C***END PROLOGUE  CTAN
      COMPLEX Z
      DATA SQEPS /0./
C***FIRST EXECUTABLE STATEMENT  CTAN
      IF (SQEPS.EQ.0.) SQEPS = SQRT (R1MACH(4))
C
      X2 = 2.0*REAL(Z)
      Y2 = 2.0*AIMAG(Z)
C
      SN2X = SIN (X2)
      CALL XERCLR
C
      DEN = COS(X2) + COSH(Y2)
      IF (DEN.EQ.0.) CALL XERROR (  'CTAN    TAN IS SINGULAR FOR INPUT Z
     1 (X IS PI/2 OR 3*PI/2 AND Y IS 0)', 68, 2, 2)
C
      IF (ABS(DEN).GT.AMAX1(ABS(X2),1.)*SQEPS) GO TO 10
      CALL XERCLR
      CALL XERROR ( 'CTAN    ANSWER LT HALF PRECISION, ABS(X) TOO BIG OR
     1 X TOO NEAR PI/2 OR 3*PI/2', 77, 1, 1)
C
 10   CTAN = CMPLX (SN2X/DEN, SINH(Y2)/DEN)
C
      RETURN
      END
