      DOUBLE PRECISION FUNCTION DACOSH(X)
C***BEGIN PROLOGUE  DACOSH
C***DATE WRITTEN   770601   (YYMMDD)
C***REVISION DATE  820801   (YYMMDD)
C***CATEGORY NO.  C4C
C***KEYWORDS  DOUBLE PRECISION,ELEMENTARY FUNCTION,
C             INVERSE HYPERBOLIC COSINE
C***AUTHOR  FULLERTON, W., (LANL)
C***PURPOSE  Computes the arc hyperbolic Cosine.
C***DESCRIPTION
C
C DACOSH(X) calculates the double precision arc hyperbolic cosine for
C double precision argument X.  THe result is returned on the
C positive branch.
C***REFERENCES  (NONE)
C***ROUTINES CALLED  D1MACH,XERROR
C***END PROLOGUE  DACOSH
      DOUBLE PRECISION X, DLN2, XMAX,  D1MACH
      DATA DLN2 / 0.6931471805 5994530941 7232121458 18 D0 /
      DATA XMAX / 0.D0 /
C***FIRST EXECUTABLE STATEMENT  DACOSH
      IF (XMAX.EQ.0.D0) XMAX = 1.0D0/DSQRT(D1MACH(3))
C
      IF (X.LT.1.D0) CALL XERROR ( 'DACOSH  X LESS THAN 1', 21, 1, 2)
C
      IF (X.LT.XMAX) DACOSH = DLOG (X+DSQRT(X*X-1.0D0))
      IF (X.GE.XMAX) DACOSH = DLN2 + DLOG(X)
C
      RETURN
      END
