      DOUBLE PRECISION FUNCTION DGAMR(X)
C***BEGIN PROLOGUE  DGAMR
C***DATE WRITTEN   770701   (YYMMDD)
C***REVISION DATE  820801   (YYMMDD)
C***CATEGORY NO.  C7A
C***KEYWORDS  DOUBLE PRECISION,GAMMA,GAMMA FUNCTION,
C             RECIPROCAL GAMMA FUNCTION,SPECIAL FUNCTION
C***AUTHOR  FULLERTON, W., (LANL)
C***PURPOSE  Calculates d.p. reciprocal Gamma function.
C***DESCRIPTION
C
C DGAMR(X) calculates the double precision reciprocal of the
C complete gamma function for double precision argument X.
C***REFERENCES  (NONE)
C***ROUTINES CALLED  DGAMMA,DINT,DLGAMS,XERCLR,XGETF,XSETF
C***END PROLOGUE  DGAMR
      EXTERNAL DGAMMA
      DOUBLE PRECISION X, ALNGX, SGNGX, DGAMMA, DINT
C***FIRST EXECUTABLE STATEMENT  DGAMR
      DGAMR = 0.0D0
      IF (X.LE.0.0D0 .AND. DINT(X).EQ.X) RETURN
C
      CALL XGETF (IROLD)
      CALL XSETF (1)
      IF (DABS(X).GT.10.0D0) GO TO 10
      DGAMR = 1.0D0/DGAMMA(X)
      CALL XERCLR
      CALL XSETF (IROLD)
      RETURN
C
 10   CALL DLGAMS (X, ALNGX, SGNGX)
      CALL XERCLR
      CALL XSETF (IROLD)
      DGAMR = SGNGX * DEXP(-ALNGX)
      RETURN
C
      END
