      DOUBLE PRECISION FUNCTION DLI(X)
C***BEGIN PROLOGUE  DLI
C***DATE WRITTEN   770701   (YYMMDD)
C***REVISION DATE  820801   (YYMMDD)
C***CATEGORY NO.  C5
C***KEYWORDS  DOUBLE PRECISION,LOGARITHMIC INTEGRAL,SPECIAL FUNCTION
C***AUTHOR  FULLERTON, W., (LANL)
C***PURPOSE  Computes the d.p. logarithmic integral.
C***DESCRIPTION
C
C DLI(X) calculates the double precision logarithmic integral
C for double precision argument X.
C***REFERENCES  (NONE)
C***ROUTINES CALLED  DEI,XERROR
C***END PROLOGUE  DLI
      DOUBLE PRECISION X, DEI
C***FIRST EXECUTABLE STATEMENT  DLI
      IF (X.LE.0.D0) CALL XERROR ( 'DLI     LOG INTEGRAL UNDEFINED FOR X
     1 LE 0', 41, 1, 2)
      IF (X.EQ.1.D0) CALL XERROR ( 'DLI     LOG INTEGRAL UNDEFINED FOR X
     1 = 0', 40, 2, 2)
C
      DLI = DEI (DLOG(X))
C
      RETURN
      END
