*DXPY
      SUBROUTINE DXPY
     +   (N,M,X,LDX,Y,LDY,XPY,LDXPY)
C***BEGIN PROLOGUE  DXPY
C***REFER TO  DODR,DODRC
C***ROUTINES CALLED  (NONE)
C***DATE WRITTEN   860529   (YYMMDD)
C***REVISION DATE  870204   (YYMMDD)
C***CATEGORY NO.  G2E,I1B1
C***KEYWORDS  ORTHOGONAL DISTANCE REGRESSION,
C             NONLINEAR LEAST SQUARES,
C             ERRORS IN VARIABLES
C***AUTHOR  BOGGS, PAUL T.
C             OPTIMIZATION GROUP/SCIENTIFIC COMPUTING DIVISION
C             NATIONAL BUREAU OF STANDARDS, GAITHERSBURG, MD 20899
C           BYRD, RICHARD H.
C             DEPARTMENT OF COMPUTER SCIENCE
C             UNIVERSITY OF COLORADO, BOULDER, CO 80309
C           DONALDSON, JANET R.
C             OPTIMIZATION GROUP/SCIENTIFIC COMPUTING DIVISION
C             NATIONAL BUREAU OF STANDARDS, BOULDER, CO 80303-3328
C           SCHNABEL, ROBERT B.
C             DEPARTMENT OF COMPUTER SCIENCE
C             UNIVERSITY OF COLORADO, BOULDER, CO 80309
C             AND
C             OPTIMIZATION GROUP/SCIENTIFIC COMPUTING DIVISION
C             NATIONAL BUREAU OF STANDARDS, BOULDER, CO 80303-3328
C***PURPOSE  COMPUTE XPY = X + Y
C***END PROLOGUE  DXPY
C
C  VARIABLE DECLARATIONS (ALPHABETICALLY)
C
      INTEGER I
C        AN INDEXING VARIABLE.
      INTEGER J
C        AN INDEXING VARIABLE.
      INTEGER LDX
C        THE LEADING DIMENSION OF ARRAY X.
      INTEGER LDXPY
C        THE LEADING DIMENSION OF ARRAY XPY.
      INTEGER LDY
C        THE LEADING DIMENSION OF ARRAY Y.
      INTEGER M
C        THE NUMBER OF COLUMNS OF DATA IN ARRAYS X AND Y TO BE ADDED
C        TOGETHER.
      INTEGER N
C        THE NUMBER OF ROWS OF DATA IN ARRAYS X AND Y TO BE ADDED
C        TOGETHER.
      DOUBLE PRECISION X(LDX,M)
C        THE FIRST OF THE TWO ARRAYS TO BE ADDED TOGETHER.
      DOUBLE PRECISION XPY(LDXPY,M)
C        THE SUM OF THE TWO ARRAYS TO BE ADDED TOGETHER.
      DOUBLE PRECISION Y(LDY,M)
C        THE SECOND OF THE TWO ARRAYS TO BE ADDED TOGETHER.
C
C
C***FIRST EXECUTABLE STATEMENT  DXPY
C
C
      DO 20 J=1,M
         DO 10 I=1,N
            XPY(I,J) = X(I,J) + Y(I,J)
   10    CONTINUE
   20 CONTINUE
C
      RETURN
      END
