      SUBROUTINE FUN
     +   (N,NP,M,BETA,XPLUSD,LDXPD,F,IFLAG)
C***BEGIN PROLOGUE  FUN
C***REFER TO  SODR,SODRC
C***ROUTINES CALLED  (NONE)
C***DATE WRITTEN   860529   (YYMMDD)
C***REVISION DATE  861217   (YYMMDD)
C***CATEGORY NO.  G2E,I1B1
C***KEYWORDS  ORTHOGONAL DISTANCE REGRESSION,
C             NONLINEAR LEAST SQUARES,
C             ERRORS IN VARIABLES
C***AUTHOR  BOGGS, PAUL T.
C             OPTIMIZATION GROUP/SCIENTIFIC COMPUTING DIVISION
C             NATIONAL BUREAU OF STANDARDS, GAITHERSBURG, MD 20899
C           BYRD, RICHARD H.
C             DEPARTMENT OF COMPUTER SCIENCE
C             UNIVERSITY OF COLORADO, BOULDER, CO 80309
C           DONALDSON, JANET R.
C             OPTIMIZATION GROUP/SCIENTIFIC COMPUTING DIVISION
C             NATIONAL BUREAU OF STANDARDS, BOULDER, CO 80303-3328
C           SCHNABEL, ROBERT B.
C             DEPARTMENT OF COMPUTER SCIENCE
C             UNIVERSITY OF COLORADO, BOULDER, CO 80309
C             AND
C             OPTIMIZATION GROUP/SCIENTIFIC COMPUTING DIVISION
C             NATIONAL BUREAU OF STANDARDS, BOULDER, CO 80303-3328
C***PURPOSE  DUMMY ROUTINE TO CATCH CASE WHEN USER DOES NOT PROVIDE
C            THE NECESSARY FUNCTION ROUTINE
C***END PROLOGUE  FUN
C
C  VARIABLE DECLARATIONS (ALPHABETICALLY)
C
      REAL BETA(NP)
C        THE FUNCTION PARAMETERS.
C        (FOR DETAILS, SEE PROLOGUE OF SUBROUTINE SODR OR SODRC.)
      REAL F(N)
C        THE (WEIGHTED) ESTIMATED VALUES OF EPSILON.
      INTEGER IFLAG
C        AN INDICATOR VARIABLE, USED PRIMARILY TO DESIGNATE THAT THE
C        USER WISHES THE COMPUTATIONS STOPPED.
      INTEGER LDXPD
C        THE LEADING DIMENSION OF ARRAY XPLUSD.
      INTEGER M
C        THE NUMBER OF COLUMNS OF DATA IN THE INDEPENDENT VARIABLE.
C        (FOR DETAILS, SEE PROLOGUE OF SUBROUTINE SODR OR SODRC.)
      INTEGER N
C        THE NUMBER OF OBSERVATIONS.
C        (FOR DETAILS, SEE PROLOGUE OF SUBROUTINE SODR OR SODRC.)
      INTEGER NP
C        THE NUMBER OF FUNCTION PARAMETERS.
C        (FOR DETAILS, SEE PROLOGUE OF SUBROUTINE SODR OR SODRC.)
      REAL XPLUSD(LDXPD,M)
C        THE ARRAY X + DELTA.
C
C
C***FIRST EXECUTABLE STATEMENT  FUN
C
C
      PRINT *, ' USER SUPPLIED FUNCTION SUBROUTINE HAS NOT BEEN'
      PRINT *, ' SUPPLIED.  COMPUTATIONS HAVE BEEN STOPPED.'
C
      IFLAG = -1
      END
