      SUBROUTINE JAC
     +   (N,NP,M,BETA,XPLUSD,LDXPD,
     +   FJACB,LDFJB,ISODR,FJACX,LDFJX,IFLAG)
C***BEGIN PROLOGUE  JAC
C***REFER TO  SODR,SODRC
C***ROUTINES CALLED  (NONE)
C***DATE WRITTEN   860529   (YYMMDD)
C***REVISION DATE  861217   (YYMMDD)
C***CATEGORY NO.  G2E,I1B1
C***KEYWORDS  ORTHOGONAL DISTANCE REGRESSION,
C             NONLINEAR LEAST SQUARES,
C             ERRORS IN VARIABLES
C***AUTHOR  BOGGS, PAUL T.
C             OPTIMIZATION GROUP/SCIENTIFIC COMPUTING DIVISION
C             NATIONAL BUREAU OF STANDARDS, GAITHERSBURG, MD 20899
C           BYRD, RICHARD H.
C             DEPARTMENT OF COMPUTER SCIENCE
C             UNIVERSITY OF COLORADO, BOULDER, CO 80309
C           DONALDSON, JANET R.
C             OPTIMIZATION GROUP/SCIENTIFIC COMPUTING DIVISION
C             NATIONAL BUREAU OF STANDARDS, BOULDER, CO 80303-3328
C           SCHNABEL, ROBERT B.
C             DEPARTMENT OF COMPUTER SCIENCE
C             UNIVERSITY OF COLORADO, BOULDER, CO 80309
C             AND
C             OPTIMIZATION GROUP/SCIENTIFIC COMPUTING DIVISION
C             NATIONAL BUREAU OF STANDARDS, BOULDER, CO 80303-3328
C***PURPOSE  DUMMY ROUTINE TO CATCH CASE WHEN USER DOES NOT PROVIDE
C            THE NECESSARY JACOBIAN ROUTINE
C***END PROLOGUE  JAC
C
C  VARIABLE DECLARATIONS (ALPHABETICALLY)
C
      REAL BETA(NP)
C        THE FUNCTION PARAMETERS.
C        (FOR DETAILS, SEE PROLOGUE OF SUBROUTINE SODR OR SODRC.)
      REAL FJACB(LDFJB,NP)
C        THE JACOBIAN WITH RESPECT TO BETA.
      REAL FJACX(LDFJX,M)
C        THE JACOBIAN WITH RESPECT TO X.
      INTEGER IFLAG
C        AN INDICATOR VARIABLE, USED PRIMARILY TO DESIGNATE THAT THE
C        USER WISHES THE COMPUTATIONS STOPPED.
      LOGICAL ISODR
C        THE INDICATOR VARIABLE USED TO DESIGNATE WHETHER THE SOLUTION
C        IS TO BE FOUND BY ODR (ISODR=.TRUE.) OR BY OLS (ISODR=.FALSE.).
      INTEGER LDFJB
C        THE LEADING DIMENSION OF ARRAY FJACB.
      INTEGER LDFJX
C        THE LEADING DIMENSION OF ARRAY FJACX.
      INTEGER LDXPD
C        THE LEADING DIMENSION OF ARRAY XPLUSD.
      INTEGER M
C        THE NUMBER OF COLUMNS OF DATA IN THE INDEPENDENT VARIABLE.
C        (FOR DETAILS, SEE PROLOGUE OF SUBROUTINE SODR OR SODRC.)
      INTEGER N
C        THE NUMBER OF OBSERVATIONS.
C        (FOR DETAILS, SEE PROLOGUE OF SUBROUTINE SODR OR SODRC.)
      INTEGER NP
C        THE NUMBER OF FUNCTION PARAMETERS.
C        (FOR DETAILS, SEE PROLOGUE OF SUBROUTINE SODR OR SODRC.)
      REAL XPLUSD(LDXPD,M)
C        THE ARRAY X + DELTA.
C
C
C***FIRST EXECUTABLE STATEMENT  JAC
C
C
      PRINT *, ' USER SUPPLIED JACOBIAN SUBROUTINE HAS NOT BEEN'
      PRINT *, ' SUPPLIED.  COMPUTATIONS HAVE BEEN STOPPED.'
C
      IFLAG = -1
      END
