*SODPCR
      SUBROUTINE SODPCR
     +   (HEAD,IFLAG,IPR,FSTITR,LUNRPT,
     +   ANAJAC,CHKJAC,INITD,RESTRT,ISODR,
     +   MSGB,MSGX,
     +   N,M,NP,NPP,
     +   X,LDX,IFIXX,LDIFX,
     +   DELTA,RHO,LDRHO,TT,LDTT,
     +   Y,W,
     +   BETA,IFIXB,SSF,
     +   JOB,TAUFAC,SSTOL,PARTOL,MAXIT,
     +   RNORM,DELWTD,FWTD,
     +   NJEV,NFEV,ACTRED,PRERED,TAU,PNORM,ALPHA,
     +   F,RCOND,IRANK,INFO)
C***BEGIN PROLOGUE  SODPCR
C***REFER TO  SODR,SODRC
C***ROUTINES CALLED  SODPC1,SODPC2,SODPC3,SODPHD
C***DATE WRITTEN   860529   (YYMMDD)
C***REVISION DATE  870204   (YYMMDD)
C***CATEGORY NO.  G2E,I1B1
C***KEYWORDS  ORTHOGONAL DISTANCE REGRESSION,
C             NONLINEAR LEAST SQUARES,
C             ERRORS IN VARIABLES
C***AUTHOR  BOGGS, PAUL T.
C             OPTIMIZATION GROUP/SCIENTIFIC COMPUTING DIVISION
C             NATIONAL BUREAU OF STANDARDS, GAITHERSBURG, MD 20899
C           BYRD, RICHARD H.
C             DEPARTMENT OF COMPUTER SCIENCE
C             UNIVERSITY OF COLORADO, BOULDER, CO 80309
C           DONALDSON, JANET R.
C             OPTIMIZATION GROUP/SCIENTIFIC COMPUTING DIVISION
C             NATIONAL BUREAU OF STANDARDS, BOULDER, CO 80303-3328
C           SCHNABEL, ROBERT B.
C             DEPARTMENT OF COMPUTER SCIENCE
C             UNIVERSITY OF COLORADO, BOULDER, CO 80309
C             AND
C             OPTIMIZATION GROUP/SCIENTIFIC COMPUTING DIVISION
C             NATIONAL BUREAU OF STANDARDS, BOULDER, CO 80303-3328
C***PURPOSE  GENERATE COMPUTATION REPORTS
C***END PROLOGUE  SODPCR
C
C  VARIABLE DECLARATIONS (ALPHABETICALLY)
C
      REAL ACTRED
C        THE ACTUAL RELATIVE REDUCTION IN THE SUM-OF-SQUARES
C        OF THE WEIGHTED OBSERVATIONAL ERRORS.
      REAL ALPHA
C        THE LEVENBERG-MARQUARDT PARAMETER.
      LOGICAL ANAJAC
C        THE INDICATOR VARIABLE USED TO DESIGNATE WHETHER THE JACOBIANS
C        ARE COMPUTED BY FINITE DIFFERENCES (ANAJAC=.FALSE.) OR NOT
C        (ANAJAC=.TRUE.).
      REAL BETA(NP)
C        THE FUNCTION PARAMETERS.
C        (FOR DETAILS, SEE ODRPACK REFERENCE GUIDE.)
      LOGICAL CHKJAC
C        THE INDICATOR VARIABLE USED TO DESIGNATE WHETHER THE USER-
C        SUPPLIED JACOBIANS ARE TO BE CHECKED (CHKJAC=.TRUE.) OR NOT
C        (CHKJAC=.FALSE.).
      REAL DELTA(N,M)
C        THE ESTIMATED ERRORS IN THE INDEPENDENT VARIABLES.
      REAL DELWTD(N,M)
C        THE WEIGHTED ESTIMATED ERRORS IN THE INDEPENDENT VARIABLES.
      REAL F(N)
C        THE (WEIGHTED) ESTIMATED VALUES OF EPSILON.
      LOGICAL FSTITR
C        THE INDICATOR VARIABLE USED TO DESIGNATE WHETHER THIS IS THE
C        FIRST ITERATION (FSTITR=.TRUE.) OR NOT (FSTITR=.FALSE.).
      REAL FWTD(N)
C        THE WEIGHTED ESTIMATED VALUES OF EPSILON.
      LOGICAL HEAD
C        THE INDICATOR VARIABLE USED TO DESIGNATE WHETHER THE PACKAGE
C        HEADING IS TO BE PRINTED (HEAD=.TRUE.) OR NOT (HEAD=.FALSE.).
      INTEGER IFIXB(NP)
C        THE INDICATOR VALUES USED TO DESIGNATE WHETHER THE INDIVIDUAL
C        ELEMENTS OF BETA ARE FIXED AT THEIR INPUT VALUES OR NOT.
C        (FOR DETAILS, SEE ODRPACK REFERENCE GUIDE.)
      INTEGER IFIXX(LDIFX,M)
C        THE INDICATOR VALUES USED TO DESIGNATE WHETHER THE INDIVIDUAL
C        ELEMENTS OF DELTA ARE FIXED AT THEIR INPUT VALUES OR NOT.
C        (FOR DETAILS, SEE ODRPACK REFERENCE GUIDE.)
      INTEGER IFLAG
C        AN INDICATOR VARIABLE, USED HERE TO DESIGNATE WHICH PART OF
C        THE REPORT IS TO BE PRINTED.
      INTEGER INFO
C        AN INDICATOR VARIABLE, USED PRIMARILY TO DESIGNATE WHY THE
C        COMPUTATIONS WERE STOPPED.
      LOGICAL INITD
C        THE INDICATOR VARIABLE USED TO DESIGNATE WHETHER THE DELTA'S
C        ARE TO BE INITIALIZED TO ZERO (INITD=.TRUE.) OR WHETHER THEY
C        ARE TO BE INITIALIZED TO THE VALUES PASSED VIA THE FIRST N BY M
C        ELEMENTS OF ARRAY WORK (INITD=.FALSE.).
      INTEGER IPR
C        THE VALUE WHICH CONTROLS THE REPORT BEING PRINTED.
      INTEGER IRANK
C        THE RANK DEFICIENCY OF THE JACOBIAN WRT BETA.
      LOGICAL ISODR
C        THE INDICATOR VARIABLE USED TO DESIGNATE WHETHER THE SOLUTION
C        IS TO BE FOUND BY ODR (ISODR=.TRUE.) OR BY OLS (ISODR=.FALSE.).
      INTEGER JOB
C        THE PROBLEM INITIALIZATION AND COMPUTATIONAL
C        METHOD CONTROL VARIABLE.
C        (FOR DETAILS, SEE ODRPACK REFERENCE GUIDE.)
      INTEGER LDIFX
C        THE LEADING DIMENSION OF ARRAY IFIXX.
C        (FOR DETAILS, SEE ODRPACK REFERENCE GUIDE.)
      INTEGER LDRHO
C        THE LEADING DIMENSION OF ARRAY RHO.
C        (FOR DETAILS, SEE ODRPACK REFERENCE GUIDE.)
      INTEGER LDTT
C        THE LEADING DIMENSION OF ARRAY TT.
      INTEGER LDX
C        THE LEADING DIMENSION OF ARRAY X.
C        (FOR DETAILS, SEE ODRPACK REFERENCE GUIDE.)
      INTEGER LUNRPT
C        THE LOGICAL UNIT NUMBER USED FOR COMPUTATION REPORTS.
C        (FOR DETAILS, SEE ODRPACK REFERENCE GUIDE.)
      INTEGER M
C        THE NUMBER OF COLUMNS OF DATA IN THE INDEPENDENT VARIABLE.
C        (FOR DETAILS, SEE ODRPACK REFERENCE GUIDE.)
      INTEGER MAXIT
C        THE MAXIMUM NUMBER OF ITERATIONS ALLOWED.
C        (FOR DETAILS, SEE ODRPACK REFERENCE GUIDE.)
      INTEGER MSGB(NP+1)
C        THE ERROR CHECKING RESULTS FOR THE JACOBIAN WRT BETA.
      INTEGER MSGX(M+1)
C        THE ERROR CHECKING RESULTS FOR THE JACOBIAN WRT X.
      INTEGER N
C        THE NUMBER OF OBSERVATIONS.
C        (FOR DETAILS, SEE ODRPACK REFERENCE GUIDE.)
      INTEGER NFEV
C        THE NUMBER OF FUNCTION EVALUATIONS.
      INTEGER NJEV
C        THE NUMBER OF JACOBIAN EVALUATIONS.
      INTEGER NP
C        THE NUMBER OF FUNCTION PARAMETERS.
C        (FOR DETAILS, SEE ODRPACK REFERENCE GUIDE.)
      INTEGER NPP
C        THE NUMBER OF FUNCTION PARAMETERS ACTUALLY BEING ESTIMATED.
      REAL PARTOL
C        THE PARAMETER CONVERGENCE STOPPING CRITERIA.
C        (FOR DETAILS, SEE ODRPACK REFERENCE GUIDE.)
      REAL PNORM
C        THE NORM OF THE SCALED ESTIMATED PARAMETERS.
      REAL PRERED
C        THE PREDICTED RELATIVE REDUCTION IN THE SUM-OF-SQUARES
C        OF THE WEIGHTED OBSERVATIONAL ERRORS.
      REAL RCOND
C        THE APPROXIMATE RECIPROCAL CONDITION OF TFJACB.
      LOGICAL RESTRT
C        THE INDICATOR VARIABLE USED TO DESIGNATE WHETHER THE CALL IS
C        A RESTART (RESTRT=TRUE) OR NOT (RESTRT=FALSE).
      REAL RHO(LDRHO,M)
C        THE DELTA WEIGHTS.
C        (FOR DETAILS, SEE ODRPACK REFERENCE GUIDE.)
      REAL RNORM
C        THE NORM OF THE WEIGHTED OBSERVATIONAL ERRORS.
      REAL SSF(NP)
C        THE SCALE USED FOR THE BETA'S.
C        (FOR DETAILS, SEE ODRPACK REFERENCE GUIDE.)
      REAL SSTOL
C        THE SUM-OF-SQUARES CONVERGENCE STOPPING CRITERIA.
C        (FOR DETAILS, SEE ODRPACK REFERENCE GUIDE.)
      REAL TAU
C        THE TRUST REGION DIAMETER.
      REAL TAUFAC
C        THE FACTOR USED TO COMPUTE THE INITIAL TRUST REGION DIAMETER.
C        (FOR DETAILS, SEE ODRPACK REFERENCE GUIDE.)
      REAL TT(LDTT,M)
C        THE SCALE USED FOR THE DELTA'S.
C        (FOR DETAILS, SEE ODRPACK REFERENCE GUIDE.)
      CHARACTER*3 TYP
C        THE CHARACTER STRING ODR OR OLS.
      REAL W(N)
C        THE OBSERVATIONAL ERROR WEIGHTS.
C        (FOR DETAILS, SEE ODRPACK REFERENCE GUIDE.)
      REAL X(LDX,M)
C        THE INDEPENDENT VARIABLE.
C        (FOR DETAILS, SEE ODRPACK REFERENCE GUIDE.)
      REAL Y(N)
C        THE DEPENDENT VARIABLE.
C        (FOR DETAILS, SEE ODRPACK REFERENCE GUIDE.)
      REAL ZERO
C          THE VALUE 0.0E0.
C
C
      DATA ZERO/0.0E0/
C
C
C***FIRST EXECUTABLE STATEMENT  SODPCR
C
C
      IF (HEAD) THEN
         CALL SODPHD(HEAD,LUNRPT)
      ELSE IF (IFLAG.NE.2 .OR. FSTITR) THEN
         WRITE (LUNRPT,1000)
      END IF
      IF (ISODR) THEN
         TYP = 'ODR'
      ELSE
         TYP = 'OLS'
      END IF
C
C  PRINT INITIAL SUMMARY
C
      IF (IFLAG.EQ.1) THEN
         IF (RESTRT) THEN
            WRITE (LUNRPT,1100) TYP
         ELSE
            WRITE (LUNRPT,1200) TYP
            CALL SODPC1
     +         (IPR,LUNRPT,
     +         ANAJAC,CHKJAC,INITD,RESTRT,ISODR,
     +         MSGB,MSGX,
     +         N,M,NP,NPP,
     +         X,LDX,IFIXX,LDIFX,DELTA,RHO,LDRHO,TT,LDTT,
     +         Y,W,
     +         BETA,IFIXB,SSF,
     +         JOB,TAUFAC,SSTOL,PARTOL,MAXIT,
     +         RNORM,DELWTD,FWTD)
         END IF
C
C  PRINT ITERATION REPORTS
C
      ELSE IF (IFLAG.EQ.2) THEN
C
         IF (FSTITR) THEN
            WRITE (LUNRPT,1300) TYP
         END IF
         CALL SODPC2
     +      (IPR,FSTITR,LUNRPT,NP,
     +      NJEV,NFEV,RNORM,ACTRED,PRERED,ALPHA,TAU,PNORM,BETA)
C
C  PRINT FINAL SUMMARY
C
      ELSE IF (IFLAG.EQ.3) THEN
C
         WRITE (LUNRPT,1400) TYP
         CALL SODPC3
     +      (IPR,LUNRPT,
     +      N,M,NP,
     +      INFO,NJEV,NFEV,RCOND,IRANK,
     +      RNORM,DELWTD,FWTD,
     +      BETA,F,ISODR,DELTA)
      END IF
C
      RETURN
C
C  FORMAT STATEMENTS
C
 1000 FORMAT(//)
 1100 FORMAT
     +   (////' RESTART OF FIT BY METHOD OF ',A3/
     +     ' ===============================')
 1200 FORMAT
     +   (////' INITIAL SUMMARY FOR FIT BY METHOD OF ',A3/
     +     ' ========================================')
 1300 FORMAT
     +   (//' ITERATION REPORTS FOR FIT BY METHOD OF ',A3/
     +     ' ==========================================')
 1400 FORMAT
     +   (////' FINAL SUMMARY FOR FIT BY METHOD OF ',A3/
     +     ' ======================================')
      END
