*SODPE2
      SUBROUTINE SODPE2
     +   (UNIT,
     +   NP,M,
     +   MSGB,ISODR,MSGX,
     +   XPLUSD,LDXPD,NROW,NETA,NTOL)
C***BEGIN PROLOGUE  SODPE2
C***REFER TO  SODR,SODRC
C***ROUTINES CALLED  (NONE)
C***DATE WRITTEN   860529   (YYMMDD)
C***REVISION DATE  870204   (YYMMDD)
C***CATEGORY NO.  G2E,I1B1
C***KEYWORDS  ORTHOGONAL DISTANCE REGRESSION,
C             NONLINEAR LEAST SQUARES,
C             ERRORS IN VARIABLES
C***AUTHOR  BOGGS, PAUL T.
C             OPTIMIZATION GROUP/SCIENTIFIC COMPUTING DIVISION
C             NATIONAL BUREAU OF STANDARDS, GAITHERSBURG, MD 20899
C           BYRD, RICHARD H.
C             DEPARTMENT OF COMPUTER SCIENCE
C             UNIVERSITY OF COLORADO, BOULDER, CO 80309
C           DONALDSON, JANET R.
C             OPTIMIZATION GROUP/SCIENTIFIC COMPUTING DIVISION
C             NATIONAL BUREAU OF STANDARDS, BOULDER, CO 80303-3328
C           SCHNABEL, ROBERT B.
C             DEPARTMENT OF COMPUTER SCIENCE
C             UNIVERSITY OF COLORADO, BOULDER, CO 80309
C             AND
C             OPTIMIZATION GROUP/SCIENTIFIC COMPUTING DIVISION
C             NATIONAL BUREAU OF STANDARDS, BOULDER, CO 80303-3328
C***PURPOSE  GENERATE THE DERIVATIVE CHECKING REPORT
C            (THIS ROUTINE IS MODELED AFTER STARPAC SUBROUTINE DCKZRO)
C***END PROLOGUE  SODPE2
C
C  VARIABLE DECLARATIONS (ALPHABETICALLY)
C
      LOGICAL FTNOTE(6)
C        THE ARRAY WHICH CONTROLS PRINTING OF FOOTNOTES.
      INTEGER I
C        AN INDEX VARIABLE.
      LOGICAL ISODR
C        THE INDICATOR VARIABLE USED TO DESIGNATE WHETHER THE SOLUTION
C        IS TO BE FOUND BY ODR (ISODR=.TRUE.) OR BY OLS (ISODR=.FALSE.).
      INTEGER J
C        AN INDEX VARIABLE.
      INTEGER K
C        AN INDEX VARIABLE.
      INTEGER LDXPD
C        THE LEADING DIMENSION OF ARRAY XPLUSD.
      INTEGER M
C        THE NUMBER OF COLUMNS OF DATA IN THE INDEPENDENT VARIABLE.
C        (FOR DETAILS, SEE ODRPACK REFERENCE GUIDE.)
      INTEGER MSGB(NP+1)
C        THE ERROR CHECKING RESULTS FOR THE JACOBIAN WRT BETA.
      INTEGER MSGX(M+1)
C        THE ERROR CHECKING RESULTS FOR THE JACOBIAN WRT X.
      INTEGER NETA
C        THE NUMBER OF RELIABLE DIGITS IN THE MODEL.
      INTEGER NP
C        THE NUMBER OF FUNCTION PARAMETERS.
C        (FOR DETAILS, SEE ODRPACK REFERENCE GUIDE.)
      INTEGER NROW
C        THE NUMBER OF THE ROW OF THE INDEPENDENT VARIABLE ARRAY AT
C        WHICH THE DERIVATIVE IS TO BE CHECKED.
      INTEGER NTOL
C        THE NUMBER OF DIGITS OF AGREEMENT REQUIRED BETWEEN THE
C        FINITE DIFFERENCE AND THE USER-SUPPLIED DERIVATIVES.
      CHARACTER*3 TYP
C        THE SOLUTION TYPE, ODR OR OLS.
      INTEGER UNIT
C        THE LOGICAL UNIT NUMBER USED FOR ERROR MESSAGES.
      REAL XPLUSD(LDXPD,M)
C        THE ARRAY X + DELTA.
C
C
C***FIRST EXECUTABLE STATEMENT  SODPE2
C
C
C  SET UP FOR FOOTNOTES
C
      DO 10 I=1,6
         FTNOTE(I) = .FALSE.
   10 CONTINUE
C
      IF (MSGB(1).GE.1) THEN
         DO 20 I=1,NP
            IF (MSGB(I+1).GE.2) THEN
               FTNOTE(1) = .TRUE.
               FTNOTE(MSGB(I+1)) = .TRUE.
            END IF
   20    CONTINUE
      END IF
C
      IF (MSGX(1).GE.1) THEN
         DO 30 I=1,M
            IF (MSGX(I+1).GE.2) THEN
               FTNOTE(1) = .TRUE.
               FTNOTE(MSGX(I+1)) = .TRUE.
            END IF
   30    CONTINUE
      END IF
C
C     PRINT REPORT
C
      IF (ISODR) THEN
         TYP = 'ODR'
      ELSE
         TYP = 'OLS'
      END IF
      WRITE (UNIT,1000) TYP
      IF (FTNOTE(1)) WRITE (UNIT,2100)
      WRITE (UNIT,2200)
C
C
      DO 40 I=1,NP
         K = MSGB(I+1) - 1
         IF (K.EQ.(-1)) WRITE (UNIT,3100) I
         IF (K.EQ.0) WRITE (UNIT,3200) I
         IF (K.GE.1) WRITE (UNIT,3300) I, K
   40 CONTINUE
      IF (ISODR) THEN
         DO 50 I=1,M
            K = MSGX(I+1) - 1
            IF (K.EQ.(-1)) WRITE (UNIT,4100) NROW,I
            IF (K.EQ.0) WRITE (UNIT,4200) NROW,I
            IF (K.GE.1) WRITE (UNIT,4300) NROW,I,K
   50    CONTINUE
      END IF
C
C     PRINT FOOTNOTES
C
      IF (FTNOTE(1)) THEN
C
         WRITE (UNIT,5100)
         IF (FTNOTE(2)) WRITE (UNIT,5200)
         IF (FTNOTE(3)) WRITE (UNIT,5300)
         IF (FTNOTE(4)) WRITE (UNIT,5400)
         IF (FTNOTE(5)) WRITE (UNIT,5500)
         IF (FTNOTE(6)) WRITE (UNIT,5600)
      END IF
C
      WRITE (UNIT,6000) NETA
      WRITE (UNIT,7000) NTOL
C
C  PRINT OUT ROW OF INDEPENDENT VARIABLE WHICH WAS CHECKED.
C
      WRITE (UNIT,8100) NROW
C
      DO 60 J=1,M
         WRITE (UNIT,8110) NROW,J,XPLUSD(NROW,J)
   60 CONTINUE
C
      RETURN
C
C     FORMAT STATEMENTS
C
 1000 FORMAT
     +   (//' DERIVATIVE CHECKING REPORT FOR FIT BY METHOD OF ',A3/
     +     ' ==================================================='/)
 2100 FORMAT ('                                    *')
 2200 FORMAT ('                          DERIVATIVE '/
     +        '       DERIVATIVE WRT     ASSESSMENT '/)
 3100 FORMAT ('            BETA(',I3,')         OK     ')
 3200 FORMAT ('            BETA(',I3,')      INCORRECT  ')
 3300 FORMAT ('            BETA(',I3,')    QUESTIONABLE (',I1,')')
 4100 FORMAT ('             X(',I2,',',I2,')         OK     ')
 4200 FORMAT ('             X(',I2,',',I2,')      INCORRECT  ')
 4300 FORMAT ('             X(',I2,',',I2,')    QUESTIONABLE (',I1,')')
 5100 FORMAT
     +   (/' *'/
     +     '  NUMBERS IN PARENTHESES REFER TO THE FOLLOWING NOTES.')
 5200 FORMAT
     +   (/'  (1) USER-SUPPLIED AND FINITE DIFFERENCE DERIVATIVES'/
     +     '      AGREE, BUT RESULTS ARE QUESTIONABLE BECAUSE BOTH'/
     +     '      ARE ZERO.')
 5300 FORMAT
     +   (/'  (2) USER-SUPPLIED AND FINITE DIFFERENCE DERIVATIVES'/
     +     '      AGREE, BUT RESULTS ARE QUESTIONABLE BECAUSE USER-'/
     +     '      SUPPLIED DERIVATIVE IS IDENTICALLY ZERO AND FINITE '/
     +     '      DIFFERENCE DERIVATIVE IS ONLY APPROXIMATELY ZERO.')
 5400 FORMAT
     +   (/'  (3) USER-SUPPLIED AND FINITE DIFFERENCE DERIVATIVES'/
     +     '      DISAGREE, BUT RESULTS ARE QUESTIONABLE BECAUSE'/
     +     '      USER-SUPPLIED DERIVATIVE IS IDENTICALLY ZERO.')
 5500 FORMAT
     +   (/'  (4) USER-SUPPLIED AND FINITE DIFFERENCE DERIVATIVES'/
     +     '      DISAGREE, BUT FINITE DIFFERENCE DERIVATIVE IS'/
     +     '      QUESTIONABLE BECAUSE EITHER THE RATIO OF RELATIVE'/
     +     '      CURVATURE TO RELATIVE SLOPE IS TOO HIGH OR THE SCALE'/
     +     '      IS WRONG.')
 5600 FORMAT
     +   (/'  (5) USER-SUPPLIED AND FINITE DIFFERENCE DERIVATIVES'/
     +     '      DISAGREE, BUT FINITE DIFFERENCE DERIVATIVE IS'/
     +     '      QUESTIONABLE BECAUSE THE RATIO OF RELATIVE CURVATURE'/
     +     '      TO RELATIVE SLOPE IS TOO HIGH.')
 6000 FORMAT
     *   (/' NUMBER OF RELIABLE DIGITS IN FUNCTION RESULTS       ',I5)
 7000 FORMAT
     +   (/' NUMBER OF DIGITS OF AGREEMENT REQUIRED BETWEEN      '/
     +     ' USER-SUPPLIED AND FINITE DIFFERENCE DERIVATIVE FOR  '/
     +     ' USER-SUPPLIED DERIVATIVE TO BE CONSIDERED CORRECT   ',I5)
 8100 FORMAT
     +   (/' ROW NUMBER AT WHICH DERIVATIVES WERE CHECKED        ',I5//
     +     '   -VALUES OF THE INDEPENDENT VARIABLES AT THIS ROW'/)
 8110 FORMAT
     +   (6X,'X(',I2,',',I2,')',1X,3E16.8)
      END
