      SUBROUTINE SBBLOK ( BLOKS, INTEGS, NBLOKS, IPIVOT, B, X )
CALLS SUBROUTINES  S U B F O R  AND  S U B B A K .
C
C  SUPERVISES THE SOLUTION (BY FORWARD AND BACKWARD SUBSTITUTION) OF
C  THE LINEAR SYSTEM  A*X = B  FOR X, WITH THE PLU FACTORIZATION OF  A
C  ALREADY GENERATED IN  F C B L O K .  INDIVIDUAL BLOCKS OF EQUATIONS
C  ARE SOLVED VIA  S U B F O R  AND  S U B B A K .
C
C***REVISION HISTORY  (YYMMDD)
C   000330  Modified array declarations.  (JEC)
C
C PARAMETERS
C    BLOKS, INTEGS, NBLOKS, IPIVOT    ARE AS ON RETURN FROM FCBLOK.
C    B       THE RIGHT SIDE, STORED CORRESPONDING TO THE STORAGE OF
C            THE EQUATIONS. SEE COMMENTS IN  S L V B L K  FOR DETAILS.
C    X       SOLUTION VECTOR
C
      INTEGER INTEGS(3,NBLOKS),IPIVOT(*), I,INDEX,INDEXB,INDEXX,J,LAST,
     *        NBP1,NCOL,NROW
      REAL BLOKS(*),B(*),X(*)
C
C      FORWARD SUBSTITUTION PASS
C
      INDEX = 1
      INDEXB = 1
      INDEXX = 1
      DO 20 I=1,NBLOKS
         NROW = INTEGS(1,I)
         LAST = INTEGS(3,I)
         CALL SUBFOR(BLOKS(INDEX),IPIVOT(INDEXB),NROW,LAST,B(INDEXB),
     *               X(INDEXX))
         INDEX = NROW*INTEGS(2,I) + INDEX
         INDEXB = INDEXB + NROW
   20    INDEXX = INDEXX + LAST
C
C     BACK SUBSTITUTION PASS
C
      NBP1 = NBLOKS + 1
      DO 30 J=1,NBLOKS
         I = NBP1 - J
         NROW = INTEGS(1,I)
         NCOL = INTEGS(2,I)
         LAST = INTEGS(3,I)
         INDEX = INDEX - NROW*NCOL
         INDEXB = INDEXB - NROW
         INDEXX = INDEXX - LAST
   30    CALL SUBBAK(BLOKS(INDEX),IPIVOT(INDEXB),NROW,NCOL,LAST,
     *               X(INDEXX))
                                        RETURN
      END
