      SUBROUTINE SUBBAK ( W, IPIVOT, NROW, NCOL, LAST, X )
C  CARRIES OUT BACKSUBSTITUTION FOR CURRENT BLOCK.
C
C PARAMETERS
C    W, IPIVOT, NROW, NCOL, LAST  ARE AS ON RETURN FROM FACTRB.
C    X(1),...,X(NCOL)  CONTAINS, ON INPUT, THE RIGHT SIDE FOR THE
C            EQUATIONS IN THIS BLOCK AFTER BACKSUBSTITUTION HAS BEEN
C            CARRIED UP TO BUT NOT INCLUDING EQUATION IPIVOT(LAST).
C            MEANS THAT X(J) CONTAINS THE RIGHT SIDE OF EQUATION IPI-
C            VOT(J) AS MODIFIED DURING ELIMINATION, J=1,...,LAST, WHILE
C            FOR J .GT. LAST, X(J) IS ALREADY A COMPONENT OF THE SOLUT-
C            ION VECTOR.
C    X(1),...,X(NCOL) CONTAINS, ON OUTPUT, THE COMPONENTS OF THE SOLUT-
C            ION CORRESPONDING TO THE PRESENT BLOCK.
C
      INTEGER IPIVOT(NROW),LAST,  IP,J,K,KP1
      REAL W(NROW,NCOL),X(NCOL), SUM
      K = LAST
      IP = IPIVOT(K)
      SUM = 0.
      IF (K .EQ. NCOL)                  GO TO 4
      KP1 = K+1
    2    DO 3 J=KP1,NCOL
    3       SUM = W(IP,J)*X(J) + SUM
    4    X(K) = (X(K) - SUM)/W(IP,K)
         IF (K .EQ. 1)                  RETURN
         KP1 = K
         K = K-1
         IP = IPIVOT(K)
         SUM = 0.
                                        GO TO 2
      END
