      INTEGER FUNCTION IPLOC(LOC,SX,IX)
C***BEGIN PROLOGUE  IPLOC
C***REFER TO  SPLP
C     RELATIVE ADDRESS DETERMINATION FUNCTION.
C     REVISED 810306-0800
C     REVISED YYMMDD-HHMM
C     AUTHORS  JOHN A. WISNIEWSKI AND R.J. HANSON
C
C
C     GIVEN A VIRTUAL LOCATION, FUNCTION IPLOC() RETURNS THE RELATIVE
C     WORKING MEMORY ADDRESS OF THE VECTOR COMPONENT STORED IN SX(*),
C     IX(*). ANY NECESSARY PAGE SWAPS ARE PERFORMED AUTOMATICALLY
C     FOR THE USER IN THIS FUNCTION SUBPROGRAM.
C
C
C     LOC       IS THE VIRTUAL ADDRESS OF THE DATA TO BE RETRIEVED.
C   SX(*),IX(*) REPRESENT THE MATRIX WHERE THE DATA IS STORED.
C
C     EXTERNAL REFERENCES   PRWPGE,XERROR
C
C***ROUTINES CALLED  PRWPGE,XERROR
C***END PROLOGUE  IPLOC
      DIMENSION IX(*)
      REAL SX(*),ONE,ZERO
      DATA ONE,ZERO /1.E0,0.E0/
C***FIRST EXECUTABLE STATEMENT  IPLOC
      IF (.NOT.(LOC.LE.0)) GO TO 20002
      IOPT=1
      NERR=55
      CALL XERROR(  '0IN IPLOC() A VALUE OF LOC(FIRST ARGUMENT) .LE. ZER
     *O WAS ENCOUNTERED',68,NERR,IOPT)
C
C     TWO CASES EXIST:  1.LE.LOC.LE.K.OR.LOC.GT.K.
C
20002 K = IX(3) + 4
      LMX = IX(1)
      LMXM1 = LMX - 1
      IF (.NOT.(LOC.LE.K)) GO TO 20005
      IPLOC = LOC
      GO TO 20006
C
C     COMPUTE LENGTH OF THE PAGE, STARTING ADDRESS OF THE PAGE, PAGE
C     NUMBER AND RELATIVE WORKING MEMORY ADDRESS.
C
20005 LPG = LMX-K
      ITEMP = LOC - K - 1
      IPAGE = ITEMP/LPG + 1
      IPLOC = MOD(ITEMP,LPG) + K + 1
      NP = IABS(IX(LMXM1))
C
C     DETERMINE IF A PAGE FAULT HAS OCCURRED. IF SO, WRITE PAGE NP AND
C     READ PAGE IPAGE. WRITE THE PAGE ONLY IF IT HAS BEEN MODIFIED.
C
      IF (.NOT.(IPAGE.NE.NP)) GO TO 20008
      IF (.NOT.(SX(LMX).EQ.ONE)) GO TO 20011
      SX(LMX) = ZERO
      KEY = 2
      CALL PRWPGE(KEY,NP,LPG,SX,IX)
20011 KEY = 1
      CALL PRWPGE(KEY,IPAGE,LPG,SX,IX)
20008 CONTINUE
20006 RETURN
      END
