      SUBROUTINE PRWPGE(KEY,IPAGE,LPG,SX,IX)
C***BEGIN PROLOGUE  PRWPGE
C***REFER TO  SPLP
C     THIS SUBROUTINE IS A MODIFICATION OF THE SUBROUTINE LRWPGE,
C     SANDIA LABS. REPT. SAND78-0785.
C     PRWPGE LIMITS THE TYPE OF STORAGE TO A SEQUENTIAL SCHEME.
C     MODIFICATIONS BY K.L. HIEBERT AND R.J. HANSON
C     REVISED 811130-1000
C     REVISED YYMMDD-HHMM
C     VIRTUAL MEMORY PAGE READ/WRITE SUBROUTINE.
C     AUTHORS  J. A. WISNIEWSKI AND R.J. HANSON
C
C
C     DEPENDING ON THE VALUE OF KEY, SUBROUTINE PRWPGE() PERFORMS A PAGE
C     READ OR WRITE OF PAGE IPAGE. THE PAGE HAS LENGTH LPG.
C
C     KEY       IS A FLAG INDICATING WHETHER A PAGE READ OR WRITE IS
C               TO BE PERFORMED.
C               IF KEY = 1 DATA IS READ.
C               IF KEY = 2 DATA IS WRITTEN.
C     IPAGE     IS THE PAGE NUMBER OF THE MATRIX TO BE ACCESSED.
C     LPG       IS THE LENGTH OF THE PAGE OF THE MATRIX TO BE ACCESSED.
C   SX(*),IX(*) IS THE MATRIX TO BE ACCESSED.
C
C     EXTERNAL REFERENCES   XERROR,PRWVIR
C
C***ROUTINES CALLED  PRWVIR,XERROR
C***END PROLOGUE  PRWPGE
      REAL SX(*)
      DIMENSION IX(*)
C***FIRST EXECUTABLE STATEMENT  PRWPGE
      IOPT=1
C
C     CHECK IF IPAGE IS IN RANGE.
C
      IF (.NOT.(IPAGE.LT.1)) GO TO 20002
      CALL XERROR(  '0IN PRWPGE() THE VALUE OF IPAGE(PAGE NUMBER) WAS NO
     *T IN THE RANGE 1.LE.IPAGE.LE.MAXPGE.',87,NERR,IOPT)
C
C     CHECK IF LPG IS POSITIVE.
C
20002 IF (.NOT.(LPG.LE.0)) GO TO 20005
      NERR=55
      CALL XERROR(  '0IN PRWPGE() THE VALUE OF LPG(PAGE LENGTH) WAS NONP
     *OSITIVE.',59,NERR,IOPT)
C
C     DECIDE IF WE ARE READING OR WRITING.
C
20005 IF (.NOT.(KEY.EQ.1)) GO TO 20008
C
C     CODE TO DO A PAGE READ.
C
      CALL PRWVIR(KEY,IPAGE,LPG,SX,IX)
      GO TO 20009
20008 IF (.NOT.(KEY.EQ.2)) GO TO 10001
C
C     CODE TO DO A PAGE WRITE.
C
      CALL PRWVIR(KEY,IPAGE,LPG,SX,IX)
      GO TO 20009
10001 NERR=55
      CALL XERROR(  '0IN PRWPGE() THE VALUE OF KEY (READ-WRITE FLAG) WAS
     *NOT 0,1 OR 2.',66,NERR,IOPT)
20009 RETURN
      END
