      SUBROUTINE SPLPDM(
     *MRELAS,NVARS,LMX,LBM,NREDC,INFO,IOPT,
     *IBASIS,IMAT,IBRC,IPR,IWR,IND,IBB,
     *ANORM,EPS,UU,GG,
     *AMAT,BASMAT,CSC,WR,
     *SINGLR,REDBAS)
C***BEGIN PROLOGUE  SPLPDM
C***REFER TO  SPLP
C     THE EDITING REQUIRED TO CONVERT THIS SUBROUTINE FROM SINGLE TO
C     DOUBLE PRECISION INVOLVES THE FOLLOWING CHARACTER STRING CHANGES.
C
C     USE AN EDITING COMMAND (CHANGE) /STRING-1/(TO)STRING-2/.
C     /REAL (12 BLANKS)/DOUBLE PRECISION/.
C
C     THIS SUBPROGRAM IS FROM THE SPLP( ) PACKAGE.  IT PERFORMS THE
C     TASK OF DEFINING THE ENTRIES OF THE BASIS MATRIX AND
C     DECOMPOSING IT USING THE LA05 PACKAGE.
C     IT IS THE MAIN PART OF THE PROCEDURE (DECOMPOSE BASIS MATRIX).
C
C     REVISED 811123-1500
C     REVISED YYMMDD-HHMM
C***ROUTINES CALLED  LA05AS,PNNZRS,SASUM,XERROR,XERRWV
C***COMMON BLOCKS    LA05DS
C***END PROLOGUE  SPLPDM
      INTEGER IBASIS(*),IMAT(*),IBRC(LBM,2),IPR(*),IWR(*),IND(*),IBB(*)
      REAL             AMAT(*),BASMAT(*),CSC(*),WR(*),ANORM,EPS,GG,
     * ONE,SMALL,UU,ZERO
      LOGICAL SINGLR,REDBAS
C
C     COMMON BLOCK USED BY LA05 () PACKAGE..
      COMMON/LA05DS/SMALL,LP,LENL,LENU,NCP,LROW,LCOL
C
C***FIRST EXECUTABLE STATEMENT  SPLPDM
      ZERO=0.E0
      ONE=1.E0
      LPG=LMX-(NVARS+4)
C
C     DEFINE BASIS MATRIX BY COLUMNS FOR SPARSE MATRIX EQUATION SOLVER.
C     THE LA05AS() SUBPROGRAM REQUIRES THE NONZERO ENTRIES OF THE MATRIX
C     TOGETHER WITH THE ROW AND COLUMN INDICES.
      NZBM=0
C
C     DEFINE DEPENDENT VARIABLE COLUMNS. THESE ARE
C     COLS. OF THE IDENTITY MATRIX AND IMPLICITLY GENERATED.
      K=1
      N20002=MRELAS
      GO TO 20003
20002 K=K+1
20003 IF ((N20002-K).LT.0) GO TO 20004
      J = IBASIS(K)
      IF (.NOT.(J.GT.NVARS)) GO TO 20006
      NZBM=NZBM+1
      IF (.NOT.(IND(J).EQ.2)) GO TO 20009
      BASMAT(NZBM)=ONE
      GO TO 20010
20009 BASMAT(NZBM)=-ONE
20010 IBRC(NZBM,1)=J-NVARS
      IBRC(NZBM,2)=K
      GO TO 20007
C
C     DEFINE THE INDEP. VARIABLE COLS.  THIS REQUIRES RETRIEVING
C     THE COLS. FROM THE SPARSE MATRIX DATA STRUCTURE.
20006 I=0
20012 CALL PNNZRS(I,AIJ,IPLACE,AMAT,IMAT,J)
      IF (.NOT.(I.LE.0)) GO TO 20014
      GO TO 20013
20014 CONTINUE
20015 NZBM=NZBM+1
      BASMAT(NZBM)=AIJ*CSC(J)
      IBRC(NZBM,1)=I
      IBRC(NZBM,2)=K
      GO TO 20012
20013 CONTINUE
20007 GO TO 20002
C
20004 SINGLR = .FALSE.
C
C     RECOMPUTE MATRIX NORM USING CRUDE NORM = SUM OF MAGNITUDES.
      ANORM=SASUM(NZBM,BASMAT,1)
      SMALL = EPS*ANORM
C
C     GET AN L-U FACTORIZATION OF THE BASIS MATRIX.
      NREDC=NREDC+1
      REDBAS=.TRUE.
      CALL LA05AS(BASMAT,IBRC,NZBM,LBM,MRELAS,IPR,IWR,WR,GG,UU)
C
C     CHECK RETURN VALUE OF ERROR FLAG, GG.
      IF (.NOT.(GG.LT.ZERO)) GO TO 20017
      IF (.NOT.(GG.EQ.(-7.))) GO TO 20020
      NERR=28
      CALL XERROR(    'SPLP( ). SHORT ON STORAGE FOR LA05*( ) PACKAGE. U
     *E PRGOPT(*) TO GIVE MORE.',075,NERR,IOPT)
      INFO=-NERR
      RETURN
20020 IF (.NOT.(GG.EQ.(-5.))) GO TO 10001
      SINGLR = .TRUE.
      GO TO 20021
10001 NERR=27
      CALL XERRWV('SPLP( ). LA05A( ) RETURNED ERROR FLAG (R1) BELOW.',
     *49,NERR,IOPT,
     * 0,I1,I2,1,GG,R2)
      INFO=-NERR
      RETURN
20021 CONTINUE
C
20017 RETURN
      END
