      SUBROUTINE HPBLD(NMAX,NWDS,DATA,N,T,HPFUN)
C
C   PURPOSE
C          BUILDS A HEAP, IN  T , FROM AN ARRAY OF  N  ELEMENTS
C            IN DATA, WHICH ARE SPACED NWDS APART.
C            AT CONCLUSION OF CALCULATION  THE TOP SATISFIES
C            HPFUN(TOP,SON) = .TRUE. FOR ANY SON.
C          USES SUBROUTINE HPGRO BY FEEDING IT ONE ELEMENT OF
C          THE ARRAY AT A TIME.
C
C   INPUT
C         NMAX = MAXIMUN NUMBER OF NODES ALLOWED BY USER.
C         NWDS = NUMBER OF WORDS PER NODE.
C         DATA = WORK AREA IN WHICH THE NODES ARE STORED.
C         N = CURRENT NUMBER OF NODES.
C         T = INTEGER ARRAY OF POINTERS TO HEAP NODES.
C         HPFUN = NAME OF USER WRITTEN FUNCTION TO DETERMINE TOP NODE.
C   OUTPUT
C         DATA = WORK AREA IN WHICH THE NODES ARE STORED.
C         T = INTEGER ARRAY OF POINTERS TO HEAP NODES.
C              IN PARTICULAR T(1) POINTS TO THE TOP.
C
C***REVISION HISTORY  (YYMMDD)
C   000330  Modified array declarations.  (JEC)
C
      EXTERNAL HPFUN
      LOGICAL HPFUN
      REAL DATA(*)
      INTEGER T(*)
      IF(NMAX .LT. N) RETURN
      INDEX = N/2
    1 CONTINUE
      IF( INDEX .EQ. 0) RETURN
         CALL HPGRO(NMAX,NWDS,DATA,N,T,HPFUN,INDEX)
         INDEX = INDEX-1
         GO TO 1
      END
