      SUBROUTINE PS3DI1(L,LP,M,MP,C1,N,NP,C2,A,B,C,CFY,CFZ,
     1                  FCTRD,WSAVEY,WSAVEZ)
C
C     PACKAGE PSTG3D, VERSION 1, AUGUST 1985
C
      DIMENSION A(L),B(L),C(L),CFY(4*M),CFZ(4*N),FCTRD(M,L,N),
     1          WSAVEY(M+15),WSAVEZ(N+15)
      IF (LP.NE.1) GO TO 30
      LH=(L+1)/2
      LODD=1
      IF (2*LH.EQ.L) LODD=2
      C(LH-1)=0.
      A(LH)=0.
      C(LH)=2.*C(LH)
      GO TO (10,20), LODD
   10 B(LH-1)=B(LH-1)-A(LH-1)
      B(L)=B(L)+A(L)
      GO TO 30
   20 A(L)=C(LH)
   30 CONTINUE
C
C     COMPUTE TRANSFORM ROOTS
C
      PI=PIMACH(1.0)
      DEL=PI/(2*M)
      GO TO (100,102,104,106,104),MP
  100 CONTINUE
      CFY(1)=0.
      CFY(M)=-4.*C1
      DO 101 J=2,M-1,2
      CFY(J)=-4.*C1*SIN(J*DEL)**2
  101 CFY(J+1)=CFY(J)
      GO TO 111
  102 DO 103 J=1,M
  103 CFY(J)=-4.*C1*SIN(J*DEL)**2
      GO TO 111
  104 DO 105 J=1,M
  105 CFY(J)=-4.*C1*SIN((J-.5)*DEL)**2
      GO TO 111
  106 DO 110 J=1,M
  110 CFY(J)=-4.*C1*SIN((J-1)*DEL)**2
  111 CONTINUE
      DEL=PI/(2*N)
      GO TO (113,115,117,119,117),NP
  113 CONTINUE
      CFZ(1)=0.
      CFZ(N)=-4.*C2
      DO 114 K=2,N-1,2
      CFZ(K)=-4.*C2*SIN(K*DEL)**2
  114 CFZ(K+1)=CFZ(K)
      GO TO 122
  115 DO 116 K=1,N
  116 CFZ(K)=-4.*C2*SIN(K*DEL)**2
      GO TO 122
  117 DO 118 K=1,N
  118 CFZ(K)=-4.*C2*SIN((K-.5)*DEL)**2
      GO TO 122
  119 DO 120 K=1,N
  120 CFZ(K)=-4.*C2*SIN((K-1)*DEL)**2
  122 CONTINUE
C
C     FACTOR M*N TRIDIAGONAL SYSTEMS.  FIRST, DO THE POSSIBLY SINGULAR
C     CASE CORRESPONDING TO J = K = 1.
C
C     NOTE THAT FCTRD IS DIMENSIONED AS F(M,L,N)
C
      FCTRD(1,1,1)=1./(B(1)+CFY(1)+CFZ(1))
      DO 130 I=2,L-1
  130 FCTRD(1,I,1)=1./(B(I)+CFY(1)+CFZ(1)-A(I)*C(I-1)*FCTRD(1,I-1,1))
C
C     IF TRIDIAGONAL SYSTEM (...,A(I),B(I),C(I),...) IS SINGULAR THEN
C     FCTRD(1,L,1) IS 1./0.  IF DENOMINATOR IS EXACTLY ZERO, SET
C     FCTRD(1,L,1)=1.
C
      DEN=B(L)+CFY(1)+CFZ(1)-A(L)*C(L-1)*FCTRD(1,L-1,1)
      IF (DEN .EQ. 0.) DEN =1.
      FCTRD(1,L,1)=1./DEN
C
C     FACTOR CASES J=1, K=2,...,N.
C
       DO 142 K=2,N
  142 FCTRD(1,1,K)=1./(B(1)+CFY(1)+CFZ(K))
      DO 144 I=2,L
      DO 144 K=2,N
  144 FCTRD(1,I,K)=1./(B(I)+CFY(1)+CFZ(K)-A(I)*C(I-1)*FCTRD(1,I-1,K))
C
C     FACTOR CASES K=1, J=2,...,M.
C
      DO 146 J=2,M
  146 FCTRD(J,1,1)=1./(B(1)+CFY(J)+CFZ(1))
      DO 148 I=2,L
      DO 148 J=2,M
  148 FCTRD(J,I,1)=1./(B(I)+CFY(J)+CFZ(1)-A(I)*C(I-1)*FCTRD(J,I-1,1))
C
C     FACTOR REMAINING CASES.
C
      DO 150 K=2,N
      DO 150 J=2,M
  150 FCTRD(J,1,K)=1./(B(1)+CFY(J)+CFZ(K))
      DO 152 I=2,L
      DO 152 K=2,N
      DO 152 J=2,M
  152 FCTRD(J,I,K)=1./(B(I)+CFY(J)+CFZ(K)-A(I)*C(I-1)*FCTRD(J,I-1,K))
C
C     INITIALIZE FFT TRANSFORMS AND PRE-PROCESSING COEFFICIENTS IN Y
C
      GO TO (210,220,230,240,250),MP
  210 CALL VSRFTI(M,WSAVEY)
      GO TO 300
  220 CALL VSSINI(M,CFY(1),CFY(M+1),WSAVEY)
      GO TO 300
  230 CALL VSSNQI(M,CFY(1),CFY(M+1),CFY(2*M+1),CFY(3*M+1),WSAVEY)
      GO TO 300
  240 CALL VSCOSI(M,CFY(1),CFY(M+1),WSAVEY)
      GO TO 300
  250 CALL VSCSQI(M,CFY(1),CFY(M+1),CFY(2*M+1),CFY(3*M+1),WSAVEY)
  300 CONTINUE
C
C     INITIALIZE FFT TRANSFORMS AND PRE-PROCESSING COEFFICIENTS IN Z
C
      GO TO (310,320,330,340,350),NP
  310 CALL VSRFTI(N,WSAVEZ)
      GO TO 400
  320 CALL VSSINI(N,CFZ(1),CFZ(N+1),WSAVEZ)
      GO TO 400
  330 CALL VSSNQI(N,CFZ(1),CFZ(N+1),CFZ(2*N+1),CFZ(3*N+1),WSAVEZ)
      GO TO 400
  340 CALL VSCOSI(N,CFZ(1),CFZ(N+1),WSAVEZ)
      GO TO 400
  350 CALL VSCSQI(N,CFZ(1),CFZ(N+1),CFZ(2*N+1),CFZ(3*N+1),WSAVEZ)
  400 CONTINUE
      RETURN
      END
