C
C   DRIVER FOR TESTING CMLIB ROUTINES
C      SINGLE PRECISION FULLERTON ROUTINES
C
C    ONE INPUT DATA CARD IS REQUIRED
C         READ(LIN,1) KPRINT,TIMES
C    1    FORMAT(I1,E10.0)
C
C     KPRINT = 0   NO PRINTING
C              1   NO PRINTING FOR PASSED TESTS, SHORT MESSAGE
C                  FOR FAILED TESTS
C              2   PRINT SHORT MESSAGE FOR PASSED TESTS, FULLER
C                  INFORMATION FOR FAILED TESTS
C              3   PRINT COMPLETE QUICK-CHECK RESULTS
C
C                ***IMPORTANT NOTE***
C         ALL QUICK CHECKS USE ROUTINES R2MACH AND D2MACH
C         TO SET THE ERROR TOLERANCES.
C     TIMES IS A CONSTANT MULTIPLIER THAT CAN BE USED TO SCALE THE
C     VALUES OF R1MACH AND D1MACH SO THAT
C               R2MACH(I) = R1MACH(I) * TIMES   FOR I=3,4,5
C               D2MACH(I) = D1MACH(I) * TIMES   FOR I=3,4,5
C     THIS MAKES IT EASILY POSSIBLE TO CHANGE THE ERROR TOLERANCES
C     USED IN THE QUICK CHECKS.
C     IF TIMES .LE. 0.0 THEN TIMES IS DEFAULTED TO 1.0
C
C              ***END NOTE***
C
      COMMON/UNIT/LUN
      COMMON/MSG/ICNT,JTEST(38)
      COMMON/XXMULT/TIMES
      LUN=I1MACH(2)
      LIN=I1MACH(1)
      ITEST=1
C
C     READ KPRINT,TIMES PARAMETERS FROM DATA CARD..
C
C              ***END NOTE***
      READ(LIN,1) KPRINT,TIMES
1     FORMAT(I1,E10.0)
      IF(TIMES.LE.0.) TIMES=1.
      CALL XSETUN(LUN)
      CALL XERMAX(1000)
      CALL XSETF(0)
C   TEST FULLERTON ROUTINES
      CALL SFNCK(LUN,KPRINT,IPASS)
      ITEST=ITEST*IPASS
C
      IF(KPRINT.GE.1.AND.ITEST.NE.1) WRITE(LUN,2)
2     FORMAT(/' ***** WARNING -- AT LEAST ONE TEST FOR FNLIB(SINGLE),
     1 HAS FAILED ***** ')
      IF(KPRINT.GE.1.AND.ITEST.EQ.1) WRITE(LUN,3)
3     FORMAT(/' ----- FNLIB (SINGLE) PASSED ALL TESTS ----- ')
      END
      SUBROUTINE SFNCK(ID,KPRINT,IPASS)
C***
C***
C***  WRITTEN BY J. CHOW, C3, LASL, SEPT. 1980
C***
C***  THIS PROGRAM DOES A QUICK CHECK FOR NEARLY ALL THE
C***  SINGLE PRECISION ROUTINES IN THE FULLERTON SPECIAL
C***  FUNCTION LIBRARY.
C***
C***
C***  PARAMETER LIST-
C***
C***  ID -- INPUT INTEGER VALUE VARIABLE TO DESIGNATE THE
C***        EXTERNAL DEVICE UNIT FOR MESSAGE OUTPUT
C***
C***
      INTEGER I,ID,KPRINT,IPASS
      REAL R2MACH
      REAL Y(87),V(87),ERRMAX,ERRTOL,ABSERR,RELERR
      REAL CBRT,EXPREL,ALNREL,ASINH,ACOSH,ATANH,E1,FAC,BINOM
      REAL GAMMA,GAMR,GAMI,GAMIC,GAMIT,PSI,POCH,POCH1,BETA
      REAL BETAI,ERF,DAWS,BESJ0,BESJ1,BESY0,BESY1,BESI0,BESI1
      REAL BESK0,BESK1,BESI0E,BESI1E,BESK0E,BESK1E,AI,BI,AIE
      REAL BIE,CHU
C
      EXTERNAL GAMMA
C
CORRECT VALUES THROUGH DIFFERENT CALCULATIONS ARE STORED IN V(.)
C
      DATA V( 1)/-.2000000000 0000000000 0000000000 E+01/
      DATA V( 2)/ .9983407900 0000000000 0000000000 E+02/
      DATA V( 3)/ .1001251042 3180339898 4880296644 E+01/
      DATA V( 4)/ .9950166250 8319464260 9402280122 E+00/
      DATA V( 5)/ .1371498381 4723363824 3285631505 E+00/
      DATA V( 6)/-.1000000500 0003333335 8333416027 E-05/
      DATA V( 7)/ .9983407900 0000000000 0000000000 E-01/
      DATA V( 8)/-.1194763217 0000000000 0000000000 E+01/
      DATA V( 9)/ .1111122222 3333344444 0000000000 E+00/
      DATA V(10)/ .3141592653 5900000000 0000000000 E+01/
      DATA V(11)/-.1111122222 3333344444 0000000000 E+00/
      DATA V(12)/ .2646652412 0000000000 0000000000 E+01/
      DATA V(13)/ .5597735947 7616081174 6795939295 E+00/
      DATA V(14)/ .1000195824 0663265190 1909339800 E+00/
      DATA V(15)/ .1307674368 0000000000 0000000000 E+13/
      DATA V(16)/ .8222838654 1779228177 2556288000 E+34/
      DATA V(17)/ .8344518000 0000000000 0000000000 E+09/
      DATA V(18)/ .2250829575 1200000000 0000000000 E+13/
      DATA V(19)/ .8862269254 5275801364 9083741687 E+00/
      DATA V(20)/-.3141592653 5897932384 6264338328 E+01/
      DATA V(21)/ .3183098861 8379067153 7767526733 E+00/
      DATA V(22)/ .8823957200 2038009055 0940262394 E-06/
      DATA V(23)/ .9998566182 6372370688 5830759463 E+00/
      DATA V(24)/ .8882907071 8395673587 8281870759 E+00/
      DATA V(25)/ .1353352832 3661269189 3999494971 E+00/
      DATA V(26)/ .3469303062 9580145617 0933128256 E-03/
      DATA V(27)/ .7869386805 7473315279 2400930048 E+00/
      DATA V(28)/ .6316733917 7525812329 1222663623 E-01/
      DATA V(29)/ .4227843350 9846713939 3487909918 E+00/
      DATA V(30)/ .2303001034 2976863752 7259355045 E+01/
      DATA V(31)/-.2820947917 7387814347 4039725759 E+00/
      DATA V(32)/ .1875000000 0000000000 0000000000 E+01/
      DATA V(33)/ .5135166683 8205029558 4635612122 E-01/
      DATA V(34)/ .5987500000 0000000000 0000000000 E+02/
      DATA V(35)/ .1570796326 7948966192 3132169164 E+01/
      DATA V(36)/ .7550061690 3746404275 1871235437 E-03/
      DATA V(37)/ .3812815664 6177091614 9261183171 E+00/
      DATA V(38)/ .2656250000 0000000000 0000000000 E+00/
      DATA V(39)/ .5204998778 1304653768 2746653770 E+00/
      DATA V(40)/ .8883882317 0170776406 9578446749 E+00/
      DATA V(41)/ .4244363835 0202229593 4042352455 E+00/
      DATA V(42)/ .3370006597 4209342338 3019719632 E+00/
      DATA V(43)/-.1775967713 1433830434 7397013056 E+00/
      DATA V(44)/ .2238907791 4123566805 1827454628 E+00/
      DATA V(45)/-.3275791375 9146522203 7734321812 E+00/
      DATA V(46)/ .5767248077 5687338720 2448242187 E+00/
      DATA V(47)/ .5103756726 4974511959 6606592612 E+00/
      DATA V(48)/-.3085176252 4903378007 3648984210 E+00/
      DATA V(49)/ .1478631433 9122684480 1050675510 E+00/
      DATA V(50)/-.1070324315 4093754688 8370772230 E+00/
      DATA V(51)/ .2279585302 3360672674 3720444020 E+01/
      DATA V(52)/ .2723987182 3604446894 5442320700 E+02/
      DATA V(53)/ .1590636854 6373290633 8225442450 E+01/
      DATA V(54)/ .2433564214 2450527199 1430504400 E+02/
      DATA V(55)/ .1138938727 4953343565 2719574910 E+00/
      DATA V(56)/ .3691098334 0425942747 3526100740 E-02/
      DATA V(57)/ .1398658818 1652242728 4598806997 E+00/
      DATA V(58)/ .4044613445 4521642083 6502183700 E-02/
      DATA V(59)/ .3085083225 5367103953 3384319255 E+00/
      DATA V(60)/ .1835408126 0932835307 3650751820 E+00/
      DATA V(61)/ .1639722669 4454235692 6122903850 E+00/
      DATA V(62)/ .2152692892 4893765915 8505143243 E+00/
      DATA V(63)/ .8415682150 7077141791 9124867127 E+00/
      DATA V(64)/ .5478075643 1351898686 8201568700 E+00/
      DATA V(65)/ .6002738587 8831258293 6045656600 E+00/
      DATA V(66)/ .1033476847 0686885731 7535710603 E+01/
      DATA V(67)/ .8862269254 5275801364 9083741000 E+00/
      DATA V(68)/ .1329340388 1791370204 7362561200 E+01/
      DATA V(69)/ .2880237507 7214635443 5952215970 E+01/
      DATA V(70)/ .5604991216 3979286993 1128243359 E+00/
      DATA V(71)/ .6725989459 6775144391 7353892000 E+00/
      DATA V(72)/ .9640584892 2044373628 1540578570 E+00/
      DATA V(73)/ .2316936064 8083348976 9125254500 E+00/
      DATA V(74)/ .1572592338 0470489995 2660465400 E-01/
      DATA V(75)/ .8542770431 0315549330 0048798776 E+00/
      DATA V(76)/ .1878941503 7478950009 0933504950 E+01/
      DATA V(77)/ .2932771591 2994736245 0897433147 E+00/
      DATA V(78)/ .2193222051 2871206086 2850888400 E+00/
      DATA V(79)/ .6748924111 1563021286 5414309867 E+00/
      DATA V(80)/ .4647504801 9609251501 9775411670 E+00/
      DATA V(81)/ .2499999999 9999999999 9999999880 E+00/
      DATA V(82)/ .7350086093 0037774536 9706799000 E+00/
      DATA V(83)/ .4069617876 5067297974 2685260000 E+00/
      DATA V(84)/ .4482566692 9158295391 6931735480 E+00/
      DATA V(85)/ .5963473623 2319407434 1078499290 E+00/
      DATA V(86)/ .7573420861 2217595345 4414369190 E+00/
      DATA V(87)/ .7578721561 4131210604 3351240000 E+00/
C
COMPUTE FUNCTIONAL VALUES
C
      Y( 1)=CBRT(-8.E0)
      Y( 2)=CBRT(.9950306243 6570396447 5039000000 E6)
      Y( 3)=EXPREL(.25E-2)
      Y( 4)=EXPREL(-.1E-1)
      Y( 5)=ALNREL(.147E0)
      Y( 6)=ALNREL(-.1E-5)
      Y( 7)=ASINH(.1000000001 0129514521 1538706587 E0)
      Y( 8)=ASINH(-.1499999999 4824063412 4264852207 E1)
      Y( 9)=ACOSH(.1006179316 4909482374 7218929626 E1)
      Y(10)=ACOSH(.1159195327 5523908462 8557897777 E2)
      Y(11)=ATANH(-.1106572080 4138399806 6515207788 E0)
      Y(12)=ATANH(.9899999999 9279130066 3084082410 E0)
      Y(13)=E1(.5E0)
      Y(14)=E1(1.5E0)
      Y(15)=FAC(15)
      Y(16)=FAC(31)
      Y(17)=BINOM(35,12)
      Y(18)=BINOM(50,15)
      Y(19)=GAMMA(1.5E0)
      Y(20)=GAMMA(-.5E0)*GAMMA(1.5E0)
      Y(21)=GAMR(-1.5E0)*GAMR(2.5E0)
      Y(22)=GAMR(10.5E0)
      Y(23)=GAMI(1.E0,8.85E0)
      Y(24)=GAMI(2.E0,3.75E0)
      Y(25)=GAMIC(1.E0,2.E0)
      Y(26)=GAMIC(2.E0,10.4E0)
      Y(27)=GAMIT(1.E0,.5E0)
      Y(28)=GAMIT(2.E0,3.75E0)
      Y(29)=PSI(2.E0)
      Y(30)=PSI(10.5E0)
      Y(31)=POCH(-.5E0,1.5E0)
      Y(32)=POCH(.5E0,3.E0)
      Y(33)=POCH1(.5E0,2.5E0)
      Y(34)=POCH1(10.5E0,2.E0)
      Y(35)=BETA(.5E0,1.5E0)
      Y(36)=BETA(5.5E0,5.5E0)
      Y(37)=BETAI(.5E0,2.E0,1.5E0)
      Y(38)=BETAI(.25E0,1.5E0,2.E0)
      Y(39)=ERF(.5E0)
      Y(40)=ERF(1.125E0)
      Y(41)=DAWS(.5E0)
      Y(42)=DAWS(1.84E0)
      Y(43)=BESJ0(5.E0)
      Y(44)=BESJ0(2.E0)
      Y(45)=BESJ1(5.E0)
      Y(46)=BESJ1(2.E0)
      Y(47)=BESY0(2.E0)
      Y(48)=BESY0(5.E0)
      Y(49)=BESY1(5.E0)
      Y(50)=BESY1(2.E0)
      Y(51)=BESI0(2.E0)
      Y(52)=BESI0(5.E0)
      Y(53)=BESI1(2.E0)
      Y(54)=BESI1(5.E0)
      Y(55)=BESK0(2.E0)
      Y(56)=BESK0(5.E0)
      Y(57)=BESK1(2.E0)
      Y(58)=BESK1(5.E0)
      Y(59)=BESI0E(2.E0)
      Y(60)=BESI0E(5.E0)
      Y(61)=BESI1E(5.E0)
      Y(62)=BESI1E(2.E0)
      Y(63)=BESK0E(2.E0)
      Y(64)=BESK0E(5.E0)
      Y(65)=BESK1E(5.E0)
      Y(66)=BESK1E(2.E0)
      CALL BESKES(.5E0,2.E0,3,Y(67))
      CALL BESKES(.5E0,5.E0,3,Y(70))
      Y(73)=AI(.5E0)
      Y(74)=AI(2.5E0)
      Y(75)=BI(.5E0)
      Y(76)=BI(1.5E0)
      Y(77)=AIE(.5E0)
      Y(78)=AIE(2.5E0)
      Y(79)=BIE(.5E0)
      Y(80)=BIE(2.5E0)
      Y(81)=CHU(1.E0,2.E0,4.E0)
      Y(82)=CHU(5.E0/6.E0,5.E0/3.E0,4.E0/3.E0)
      Y(83)=CHU(.75E0,.75E0,2.5E0)
      Y(84)=CHU(1.E0,1.E0,1.5E0)
      Y(85)=CHU(1.E0,1.E0,1.E0)
      Y(86)=CHU(1.E0,1.E0,-ALOG(.5E0))
      Y(87)=CHU(.5E0,.5E0,1.E0)
C
CHECK FOR POSSIBLE ERRORS
C
      ERRMAX=R2MACH(4)
      ERRTOL=SQRT(ERRMAX)
      DO 10 I=1,87
        ABSERR=ABS(V(I)-Y(I))
        RELERR=ABSERR/ABS(V(I))
        ERRMAX=AMAX1(RELERR,ERRMAX)
        IF (RELERR.GT.ERRTOL.AND.KPRINT.NE.0)
     1 WRITE (ID,620) I,RELERR,ABSERR
   10 CONTINUE
      IPASS=0
      IF (ERRMAX.LE.ERRTOL) IPASS=1
      IF(IPASS.NE.0.AND.KPRINT.GE.2)WRITE (ID,610)
  610 FORMAT('SINGLE PRECISION SPECIAL FUNCTION ROUTINES O.K.')
  620 FORMAT('FOR  I =',I3,' TEST FAILS WITH  RELERR =',
     .       E23.15,'  AND  ABSERR =',E23.15)
                                        RETURN
      END
      DOUBLE PRECISION FUNCTION D2MACH(I)
      DOUBLE PRECISION D1MACH
      COMMON/XXMULT/TIMES
      D2MACH=D1MACH(I)
      IF(I.EQ.1.OR. I.EQ.2) RETURN
      D2MACH = D2MACH * DBLE(TIMES)
      RETURN
      END
      REAL FUNCTION R2MACH(I)
      COMMON/XXMULT/TIMES
      R2MACH=R1MACH(I)
      IF(I.EQ.1.OR. I.EQ.2) RETURN
      R2MACH = R2MACH * TIMES
      RETURN
      END
