C
C   DRIVER FOR TESTING CMLIB ROUTINES
C      CGECO   CGEDI   CGEFA   CGESL
C      CGBCO   CGBDI   CGBFA   CGBSL
C      CPOCO   CPODI   CPOFA   CPOSL
C      CPPCO   CPPDI   CPPFA   CPPSL
C      CPBCO   CPBDI   CPBFA   CPBSL
C      CSICO   CSIDI   CSIFA   CSISL
C      CSPCO   CSPDI   CSPFA   CSPSL
C      CHICO   CHIDI   CHIFA   CHISL
C      CHPCO   CHPDI   CHPFA   CHPSL
C      CTRCO   CTRDI     -     CTRSL
C      CGTSL
C      CPTSL
C      CCHDC
C      CQRDC   CQRSL
C      CSVDC
C
C    ONE INPUT DATA CARD IS REQUIRED
C         READ(LIN,1) KPRINT,TIMES
C    1    FORMAT(I1,E10.0)
C
C     KPRINT = 0   NO PRINTING
C              1   NO PRINTING FOR PASSED TESTS, SHORT MESSAGE
C                  FOR FAILED TESTS
C              2   PRINT SHORT MESSAGE FOR PASSED TESTS, FULLER
C                  INFORMATION FOR FAILED TESTS
C              3   PRINT COMPLETE QUICK-CHECK RESULTS
C
C                ***IMPORTANT NOTE***
C         ALL QUICK CHECKS USE ROUTINES R2MACH AND D2MACH
C         TO SET THE ERROR TOLERANCES.
C     TIMES IS A CONSTANT MULTIPLIER THAT CAN BE USED TO SCALE THE
C     VALUES OF R1MACH AND D1MACH SO THAT
C               R2MACH(I) = R1MACH(I) * TIMES   FOR I=3,4,5
C               D2MACH(I) = D1MACH(I) * TIMES   FOR I=3,4,5
C     THIS MAKES IT EASILY POSSIBLE TO CHANGE THE ERROR TOLERANCES
C     USED IN THE QUICK CHECKS.
C     IF TIMES .LE. 0.0 THEN TIMES IS DEFAULTED TO 1.0
C
C              ***END NOTE***
C
      INTEGER NERR,TERR
      COMMON/UNIT/LUN
      COMMON/MSG/ICNT,JTEST(38)
      COMMON/XXMULT/TIMES
      LUN=I1MACH(2)
      LIN=I1MACH(1)
      ITEST=1
C
C     READ KPRINT,TIMES PARAMETERS FROM DATA CARD..
C
      READ(LIN,1) KPRINT,TIMES
1     FORMAT(I1,E10.0)
      IF(TIMES.LE.0.) TIMES=1.
      CALL XSETUN(LUN)
      CALL XERMAX(1000)
      CALL XSETF(0)
      TERR = 0
      IF(KPRINT.EQ.3)WRITE(LUN,998)
      CALL CGECK(NERR,KPRINT,LUN)
      TERR = TERR + NERR
      CALL CGBQC(NERR,KPRINT,LUN)
      TERR = TERR + NERR
      CALL CPOQC(NERR,KPRINT,LUN)
      TERR = TERR + NERR
      CALL CPPQC(NERR,KPRINT,LUN)
      TERR = TERR + NERR
      CALL CPBQC(NERR,KPRINT,LUN)
      TERR = TERR + NERR
      CALL CSIQC(NERR,KPRINT,LUN)
      TERR = TERR + NERR
      CALL CSPQC(NERR,KPRINT,LUN)
      TERR = TERR + NERR
      CALL CHIQC(NERR,KPRINT,LUN)
      TERR = TERR + NERR
      CALL CHPQC(NERR,KPRINT,LUN)
      TERR = TERR + NERR
      CALL CTRQC(NERR,KPRINT,LUN)
      TERR = TERR + NERR
      CALL CGTQC(NERR,KPRINT,LUN)
      TERR = TERR + NERR
      CALL CPTQC(NERR,KPRINT,LUN)
      TERR = TERR + NERR
      CALL CCHQC(NERR,KPRINT,LUN)
      TERR = TERR + NERR
      CALL CQRQC(NERR,KPRINT,LUN)
      TERR = TERR + NERR
      CALL CSVQC(NERR,KPRINT,LUN)
      TERR = TERR + NERR
      IF(KPRINT.GE.2)WRITE(LUN,999) TERR
C
      IF(TERR.NE.0) ITEST=0
C
      IF(KPRINT.GE.1.AND.ITEST.NE.1) WRITE(LUN,2)
2     FORMAT(/' ***** WARNING -- AT LEAST ONE TEST FOR LINPACKC HAS,
     1 FAILED ***** ')
      IF(KPRINT.GE.1.AND.ITEST.EQ.1) WRITE(LUN,3)
3     FORMAT(/' ----- LINPACKC PASSED ALL TESTS ----- ')
  998 FORMAT(/,'*****  QUICK CHECK PROGRAM LINQC  *****',//)
  999 FORMAT(/,' ***** LINQC DETECTED A TOTAL OF ',I3,' ERRORS *****',/)
      END
      SUBROUTINE CGBQC(NERR,KPRINT,LUN)
C
C    QUICK CHECK FOR LINPACK SUBROUTINES CGBFA, CGBCO, CGBSL AND CGBDI.
C
C    LET  A*X=B  BE A COMPLEX LINEAR SYSTEM WHERE THE MATRIX  A  IS
C    OF THE PROPER TYPE FOR THE LINPACK SUBROUTINES BEING TESTED.
C    THE VALUES OF  A  AND  B  AND THE PRE-COMPUTED VALUES OF  C
C    (THE SOLUTION VECTOR),  DC  (DETERMINANT OF  A ), AND
C    RCND  (RCOND) ARE ENTERED WITH DATA STATEMENTS.
C
C    THE COMPUTED TEST RESULTS FOR  X ,  RCOND  AND THE DETER-
C    MINANT ARE COMPARED TO THE STORED PRE-COMPUTED VALUES.
C    FAILURE OF THE TEST OCCURS WHEN AGREEMENT TO 3 SIGNIFICANT
C    DIGITS IS NOT ACHIEVED AND AN ERROR MESSAGE INDICATING WHICH
C    LINPACK SUBROUTINE FAILED AND WHICH QUANTITY WAS INVOLVED IS
C    PRINTED.  A SUMMARY LINE IS ALWAYS PRINTED.
C
C    NO INPUT ARGUMENTS ARE REQUIRED.
C    ON RETURN,  NERR  (INTEGER TYPE) CONTAINS THE TOTAL COUNT OF
C    ALL FAILURES DETECTED BY CGBQC.
C
C    THE LINPACK ROUTINES LISTED ABOVE ARE CALLED.  (LINPACK ROUTINES
C    CALL BLAS ROUTINES.)
C
C    MESSAGE STATEMENTS ASSUME THAT 4 CHARACTERS MAY BE ACCOMMODATED
C    BY A SINGLE MACHINE WORD.
C
C    OCTOBER 15, 1980             E. A. VOORHEES, GROUP C-3
C                                 LOS ALAMOS SCIENTIFIC LABORATORY
C                                 LOS ALAMOS, NM   87545
C
C
      COMPLEX ABD(6,4),AT(7,4),B(4),BT(4),C(4),DET(2),DC(2),
     1 Z(4),XA,XB
      REAL R,RCOND,RCND,DELX
      INTEGER LDA,N,IPVT(4),INFO,I,J,INDX,KPROG(4),KFAIL(15),NERR
      INTEGER ML,MU
      DATA ABD/(0.E0,0.E0),(0.E0,0.E0),(0.E0,0.E0),(0.E0,0.E0),
     1 (2.E0,0.E0),(0.E0,1.E0),(0.E0,0.E0),(0.E0,0.E0),
     2 (0.E0,0.E0),(0.E0,-1.E0),(2.E0,0.E0),(0.E0,0.E0),
     3 (0.E0,0.E0),(0.E0,0.E0),(0.E0,0.E0),(0.E0,0.E0),
     4 (3.E0,0.E0),(0.E0,1.E0),(0.E0,0.E0),(0.E0,0.E0),
     5 (0.E0,0.E0),(0.E0,-1.E0),(4.E0,0.E0),(0.E0,0.E0)/
      DATA B/(3.E0,2.E0),(-1.E0,3.E0),(0.E0,-4.E0),(5.E0,0.E0)/
      DATA C/(1.E0,1.E0),(0.E0,1.E0),(0.E0,-1.E0),(1.E0,0.E0)/
      DATA DC/(3.3E0,0.E0),(1.0E0,0.E0)/
      DATA KPROG/4HGBFA,4HGBCO,4HGBSL,4HGBDI/
      DATA KFAIL/4HINFO,4H    ,4H    ,4HRCON,4HD   ,4H    ,4HSOLU,
     1 4HTION,4H    ,4HDETE,4HRMIN,4HANT ,4HINVE,4HRSE ,4H    /
      DATA RCND/.24099E0/
C
      DELX(XA,XB)=ABS(REAL(XA-XB))+ABS(AIMAG(XA-XB))
      LDA = 7
      N = 4
      ML = 1
      MU = 3
      NERR = 0
C
C     FORM AT FOR CGBFA AND BT FOR CGBSL, TEST CGBFA
      DO 20 J=1,N
        BT(J) = B(J)
        DO 10 I=1,6
          AT(I,J) = ABD(I,J)
   10   CONTINUE
   20 CONTINUE
      CALL CGBFA(AT,LDA,N,ML,MU,IPVT,INFO)
      IF(INFO .EQ. 0)GO TO 30
      WRITE(LUN,201)KPROG(1),(KFAIL(I),I=1,3)
      NERR = NERR + 1
C
   30 CONTINUE
C     TEST CGBSL FOR JOB=0
      CALL CGBSL(AT,LDA,N,ML,MU,IPVT,BT,0)
      INDX = 0
      DO 40 I=1,N
        IF(DELX(C(I),BT(I)) .GT. .0001) INDX=INDX+1
   40 CONTINUE
      IF(INDX .EQ. 0) GO TO 50
      WRITE(LUN,201)KPROG(3),(KFAIL(I),I=7,9)
      NERR = NERR + 1
C
   50 CONTINUE
C     FORM AT FOR CGBCO AND BT FOR CGBSL, TEST CGBCO
      DO 70 J=1,N
        BT(J) = B(J)
        DO 60 I=1,6
          AT(I,J) = ABD(I,J)
   60   CONTINUE
   70 CONTINUE
      CALL CGBCO(AT,LDA,N,ML,MU,IPVT,RCOND,Z)
      R = ABS(RCND-RCOND)
      IF(R .LT. .0001)GO TO 80
      WRITE(LUN,201)KPROG(2),(KFAIL(I),I=4,6)
      NERR = NERR + 1
C
   80 CONTINUE
C     TEST CGBSL FOR JOB NOT EQUAL TO 0
      CALL CGBSL(AT,LDA,N,ML,MU,IPVT,BT,1)
      INDX = 0
      DO 90 I=1,N
        IF(DELX(C(I),BT(I)) .GT. .0001) INDX=INDX+1
   90 CONTINUE
      IF(INDX .EQ. 0) GO TO 100
      WRITE(LUN,201)KPROG(3),(KFAIL(I),I=7,9)
      NERR = NERR + 1
C
  100 CONTINUE
C     TEST CGBDI
      CALL CGBDI(AT,LDA,N,ML,MU,IPVT,DET)
      INDX = 0
      DO 110 I=1,2
        IF(DELX(DC(I),DET(I)) .GT. .0001) INDX=INDX+1
  110 CONTINUE
      IF(INDX .EQ. 0) GO TO 120
      WRITE(LUN,201)KPROG(4),(KFAIL(I),I=10,12)
      NERR = NERR + 1
  120 CONTINUE
      IF(KPRINT.GE.2.OR.NERR.NE.0)WRITE(LUN,200) NERR
  200 FORMAT(/,'* CGBQC - TEST FOR CGBFA, CGBCO, CGBSL AND CGBDI FOUND',
     1  I1,' ERRORS. ',/)
  201 FORMAT(/,' *** C',A4,'  FAILURE-  ERROR IN ',3A4)
      RETURN
      END
      SUBROUTINE CGECK(NERR,KPRINT,LUN)
C
C    QUICK CHECK FOR LINPACK SUBROUTINES CGEFA, CGECO, CGESL AND CGEDI.
C
C    LET  A*X=B  BE A COMPLEX LINEAR SYSTEM WHERE THE MATRIX  A  IS
C    OF THE PROPER TYPE FOR THE LINPACK SUBROUTINES BEING TESTED.
C    THE VALUES OF  A  AND  B  AND THE PRE-COMPUTED VALUES OF  C
C    (THE SOLUTION VECTOR),  AINV  (INVERSE OF MATRIX  A ),  DC
C    (DETERMINANT OF  A ), AND  RCND  ( RCOND ) ARE ENTERED
C    WITH DATA STATEMENTS.
C
C    THE COMPUTED TEST RESULTS FOR  X, RCOND, THE DETERMINANT, AND
C    THE INVERSE ARE COMPARED TO THE STORED PRE-COMPUTED VALUES.
C    FAILURE OF THE TEST OCCURS WHEN AGREEMENT TO 3 SIGNIFICANT
C    DIGITS IS NOT ACHIEVED AND AN ERROR MESSAGE INDICATING WHICH
C    LINPACK SUBROUTINE FAILED AND WHICH QUANTITY WAS INVOLVED IS
C    PRINTED.  A SUMMARY LINE IS ALWAYS PRINTED.
C
C    NO INPUT ARGUMENTS ARE REQUIRED.
C    ON RETURN,  NERR  (INTEGER TYPE) CONTAINS THE TOTAL COUNT OF
C    ALL FAILURES DETECTED BY CGECK.
C
C    THE LINPACK ROUTINES LISTED ABOVE ARE CALLED.  (LINPACK ROUTINES
C    CALL BLAS ROUTINES.)
C
C    MESSAGE STATEMENTS ASSUME THAT 4 CHARACTERS MAY BE ACCOMMODATED
C    BY A SINGLE MACHINE WORD.
C
C    OCTOBER 14, 1980             E. A. VOORHEES, GROUP C-3
C                                 LOS ALAMOS SCIENTIFIC LABORATORY
C                                 LOS ALAMOS, NM   87545
C
C
      COMPLEX A(4,4),AT(5,4),B(4),BT(4),C(4),AINV(4,4),DET(2),DC(2),
     1 Z(4),XA,XB
      REAL R,RCOND,RCND,DELX
      INTEGER LDA,N,IPVT(4),INFO,I,J,INDX,KPROG(4),KFAIL(15),NERR
      DATA A/(2.E0,0.E0),(0.E0,1.E0),(0.E0,0.E0),(0.E0,0.E0),
     1 (0.E0,-1.E0),(2.E0,0.E0),(0.E0,0.E0),(0.E0,0.E0),
     2 (0.E0,0.E0),(0.E0,0.E0),(3.E0,0.E0),(0.E0,1.E0),
     3 (0.E0,0.E0),(0.E0,0.E0),(0.E0,-1.E0),(4.E0,0.E0)/
      DATA B/(3.E0,2.E0),(-1.E0,3.E0),(0.E0,-4.E0),(5.E0,0.E0)/
      DATA C/(1.E0,1.E0),(0.E0,1.E0),(0.E0,-1.E0),(1.E0,0.E0)/
      DATA AINV/(.66667E0,0.E0),(0.E0,-.33333E0),(0.E0,0.E0),(0.E0,
     1 0.E0),
     2 (0.E0,.33333E0),(.66667E0,0.E0),(0.E0,0.E0),(0.E0,0.E0),
     3 (0.E0,0.E0),(0.E0,0.E0),(.36364E0,0.E0),(0.E0,-.09091E0),
     4 (0.E0,0.E0),(0.E0,0.E0),(0.E0,.09091E0),(.27273E0,0.E0)/
      DATA DC/(3.3E0,0.E0),(1.0E0,0.E0)/
      DATA KPROG/4HGEFA,4HGECO,4HGESL,4HGEDI/
      DATA KFAIL/4HINFO,4H    ,4H    ,4HRCON,4HD   ,4H    ,4HSOLU,
     1 4HTION,4H    ,4HDETE,4HRMIN,4HANT ,4HINVE,4HRSE ,4H    /
      DATA RCND/.24099E0/
C
      DELX(XA,XB)=ABS(REAL(XA-XB))+ABS(AIMAG(XA-XB))
      LDA = 5
      N = 4
      NERR = 0
C
C     FORM AT FOR CGEFA AND BT FOR CGESL, TEST CGEFA
      DO 20 J=1,N
        BT(J) = B(J)
        DO 10 I=1,N
          AT(I,J) = A(I,J)
   10   CONTINUE
   20 CONTINUE
      CALL CGEFA(AT,LDA,N,IPVT,INFO)
      IF(INFO .EQ. 0)GO TO 30
      WRITE(LUN,201)KPROG(1),(KFAIL(I),I=1,3)
      NERR = NERR + 1
C
   30 CONTINUE
C     TEST CGESL FOR JOB=0
      CALL CGESL(AT,LDA,N,IPVT,BT,0)
      INDX = 0
      DO 40 I=1,N
        IF(DELX(C(I),BT(I)) .GT. .0001) INDX=INDX+1
   40 CONTINUE
      IF(INDX .EQ. 0) GO TO 50
      WRITE(LUN,201)KPROG(3),(KFAIL(I),I=7,9)
      NERR = NERR + 1
C
   50 CONTINUE
C     FORM AT FOR CGECO AND BT FOR CGESL, TEST CGECO
      DO 70 J=1,N
        BT(J) = B(J)
        DO 60 I=1,N
          AT(I,J) = A(I,J)
   60   CONTINUE
   70 CONTINUE
      CALL CGECO(AT,LDA,N,IPVT,RCOND,Z)
      R = ABS(RCND-RCOND)
      IF(R .LT. .0001)GO TO 80
      WRITE(LUN,201)KPROG(2),(KFAIL(I),I=4,6)
      NERR = NERR + 1
C
   80 CONTINUE
C     TEST CGESL FOR JOB NOT EQUAL TO 0
      CALL CGESL(AT,LDA,N,IPVT,BT,1)
      INDX = 0
      DO 90 I=1,N
        IF(DELX(C(I),BT(I)) .GT. .0001) INDX=INDX+1
   90 CONTINUE
      IF(INDX .EQ. 0) GO TO 100
      WRITE(LUN,201)KPROG(3),(KFAIL(I),I=7,9)
      NERR = NERR + 1
C
  100 CONTINUE
C     TEST CGEDI FOR JOB=11
      CALL CGEDI(AT,LDA,N,IPVT,DET,Z,11)
      INDX = 0
      DO 110 I=1,2
        IF(DELX(DC(I),DET(I)) .GT. .0001) INDX=INDX+1
  110 CONTINUE
      IF(INDX .EQ. 0) GO TO 120
      WRITE(LUN,201)KPROG(4),(KFAIL(I),I=10,12)
      NERR = NERR + 1
  120 CONTINUE
      INDX = 0
      DO 140 I=1,N
        DO 130 J=1,N
          IF(DELX(AINV(I,J),AT(I,J)) .GT. .0001) INDX=INDX+1
  130   CONTINUE
  140 CONTINUE
      IF(INDX .EQ. 0) GO TO 150
      WRITE(LUN,201)KPROG(4),(KFAIL(I),I=13,15)
      NERR = NERR + 1
  150 CONTINUE
      IF(KPRINT.GE.2.OR.NERR.NE.0)WRITE(LUN,200) NERR
  200 FORMAT(/,'* CGECK - TEST FOR CGEFA, CGECO, CGESL AND CGEDI FOUND',
     1  I1,' ERRORS. ',/)
  201 FORMAT(/,' *** C',A4,'  FAILURE-  ERROR IN ',3A4)
      RETURN
      END
      SUBROUTINE CPBQC(NERR,KPRINT,LUN)
C
C    QUICK CHECK FOR LINPACK SUBROUTINES CPBFA, CPBCO, CPBSL AND CPBDI.
C
C    LET  A*X=B  BE A COMPLEX LINEAR SYSTEM WHERE THE MATRIX  A  IS
C    OF THE PROPER TYPE FOR THE LINPACK SUBROUTINES BEING TESTED.
C    THE VALUES OF  A  AND  B  AND THE PRE-COMPUTED VALUES OF  C
C    (THE SOLUTION VECTOR),  DC  (DETERMINANT OF  A ), AND
C    RCND  (RCOND) ARE ENTERED WITH DATA STATEMENTS.
C
C    THE COMPUTED TEST RESULTS FOR  X ,  RCOND  AND THE DETER-
C    MINANT ARE COMPARED TO THE STORED PRE-COMPUTED VALUES.
C    FAILURE OF THE TEST OCCURS WHEN AGREEMENT TO 3 SIGNIFICANT
C    DIGITS IS NOT ACHIEVED AND AN ERROR MESSAGE INDICATING WHICH
C    LINPACK SUBROUTINE FAILED AND WHICH QUANTITY WAS INVOLVED IS
C    PRINTED.  A SUMMARY LINE IS ALWAYS PRINTED.
C
C    NO INPUT ARGUMENTS ARE REQUIRED.
C    ON RETURN,  NERR  (INTEGER TYPE) CONTAINS THE TOTAL COUNT OF
C    ALL FAILURES DETECTED BY CPBQC.
C
C    THE LINPACK ROUTINES LISTED ABOVE ARE CALLED.  (LINPACK ROUTINES
C    CALL BLAS ROUTINES.)
C
C    MESSAGE STATEMENTS ASSUME THAT 4 CHARACTERS MAY BE ACCOMMODATED
C    BY A SINGLE MACHINE WORD.
C
C    OCTOBER 20, 1980             E. A. VOORHEES, GROUP C-3
C                                 LOS ALAMOS SCIENTIFIC LABORATORY
C                                 LOS ALAMOS, NM   87545
C
C
      COMPLEX ABD(2,4),AT(3,4),B(4),BT(4),C(4),
     1 Z(4),XA,XB
      REAL R,RCOND,RCND,DELX,DET(2),DC(2)
      INTEGER LDA,N,INFO,I,J,INDX,KPROG(4),KFAIL(15),NERR
      INTEGER M
      DATA ABD/(0.E0,0.E0),(2.E0,0.E0),(0.E0,-1.E0),(2.E0,0.E0),
     1 (0.E0,0.E0),(3.E0,0.E0),(0.E0,-1.E0),(4.E0,0.E0)/
      DATA B/(3.E0,2.E0),(-1.E0,3.E0),(0.E0,-4.E0),(5.E0,0.E0)/
      DATA C/(1.E0,1.E0),(0.E0,1.E0),(0.E0,-1.E0),(1.E0,0.E0)/
      DATA DC/3.3E0,1.0E0/
      DATA KPROG/4HPBFA,4HPBCO,4HPBSL,4HPBDI/
      DATA KFAIL/4HINFO,4H    ,4H    ,4HRCON,4HD   ,4H    ,4HSOLU,
     1 4HTION,4H    ,4HDETE,4HRMIN,4HANT ,4HINVE,4HRSE ,4H    /
      DATA RCND/.24099E0/
C
      DELX(XA,XB)=ABS(REAL(XA-XB))+ABS(AIMAG(XA-XB))
      LDA = 3
      N = 4
      M = 1
      NERR = 0
C
C     FORM AT FOR CPBFA AND BT FOR CPBSL, TEST CPBFA
      DO 20 J=1,N
        BT(J) = B(J)
        DO 10 I=1,2
          AT(I,J) = ABD(I,J)
   10   CONTINUE
   20 CONTINUE
      CALL CPBFA(AT,LDA,N,M,INFO)
      IF(INFO .EQ. 0)GO TO 30
      WRITE(LUN,201)KPROG(1),(KFAIL(I),I=1,3)
      NERR = NERR + 1
C
   30 CONTINUE
C     TEST CPBSL
      CALL CPBSL(AT,LDA,N,M,BT)
      INDX = 0
      DO 40 I=1,N
        IF(DELX(C(I),BT(I)) .GT. .0001) INDX=INDX+1
   40 CONTINUE
      IF(INDX .EQ. 0) GO TO 50
      WRITE(LUN,201)KPROG(3),(KFAIL(I),I=7,9)
      NERR = NERR + 1
C
   50 CONTINUE
C     FORM AT FOR CPBCO, TEST CPBCO
      DO 70 J=1,N
        DO 60 I=1,2
          AT(I,J) = ABD(I,J)
   60   CONTINUE
   70 CONTINUE
      CALL CPBCO(AT,LDA,N,M,RCOND,Z,INFO)
      R = ABS(RCND-RCOND)
      IF(R .LT. .0001)GO TO 80
      WRITE(LUN,201)KPROG(2),(KFAIL(I),I=4,6)
      NERR = NERR + 1
C
   80 CONTINUE
      IF(INFO .EQ. 0) GO TO 100
      WRITE(LUN,201)KPROG(2),(KFAIL(I),I=1,3)
      NERR = NERR + 1
C
  100 CONTINUE
C     TEST CPBDI
      CALL CPBDI(AT,LDA,N,M,DET)
      INDX = 0
      DO 110 I=1,2
        IF(ABS(DC(I)-DET(I)) .GT. .0001) INDX=INDX+1
  110 CONTINUE
      IF(INDX .EQ. 0) GO TO 120
      WRITE(LUN,201)KPROG(4),(KFAIL(I),I=10,12)
      NERR = NERR + 1
  120 CONTINUE
      IF(KPRINT.GE.2.OR.NERR.NE.0)WRITE(LUN,200) NERR
  200 FORMAT(/,'* CPBQC - TEST FOR CPBFA, CPBCO, CPBSL AND CPBDI FOUND',
     1  I1,' ERRORS.',/)
  201 FORMAT(/,'*** C',A4,' FAILURE- ERROR IN ',3A4)
      RETURN
      END
      SUBROUTINE CPOQC(NERR,KPRINT,LUN)
C
C    QUICK CHECK FOR LINPACK SUBROUTINES CPOFA, CPOCO, CPOSL AND CPODI.
C
C    LET  A*X=B  BE A COMPLEX LINEAR SYSTEM WHERE THE MATRIX  A  IS
C    OF THE PROPER TYPE FOR THE LINPACK SUBROUTINES BEING TESTED.
C    THE VALUES OF  A  AND  B  AND THE PRE-COMPUTED VALUES OF  C
C    (THE SOLUTION VECTOR),  AINV  (INVERSE OF MATRIX  A ),  DC
C    (DETERMINANT OF  A ), AND  RCND  ( RCOND ) ARE ENTERED
C    WITH DATA STATEMENTS.
C
C    THE COMPUTED TEST RESULTS FOR  X, RCOND, THE DETERMINANT, AND
C    THE INVERSE ARE COMPARED TO THE STORED PRE-COMPUTED VALUES.
C    FAILURE OF THE TEST OCCURS WHEN AGREEMENT TO 3 SIGNIFICANT
C    DIGITS IS NOT ACHIEVED AND AN ERROR MESSAGE INDICATING WHICH
C    LINPACK SUBROUTINE FAILED AND WHICH QUANTITY WAS INVOLVED IS
C    PRINTED.  A SUMMARY LINE IS ALWAYS PRINTED.
C
C    NO INPUT ARGUMENTS ARE REQUIRED.
C    ON RETURN,  NERR  (INTEGER TYPE) CONTAINS THE TOTAL COUNT OF
C    ALL FAILURES DETECTED BY CPOQC.
C
C    THE LINPACK ROUTINES LISTED ABOVE ARE CALLED.  (LINPACK ROUTINES
C    CALL BLAS ROUTINES.)
C
C    MESSAGE STATEMENTS ASSUME THAT 4 CHARACTERS MAY BE ACCOMMODATED
C    BY A SINGLE MACHINE WORD.
C
C    OCTOBER 16, 1980             E. A. VOORHEES, GROUP C-3
C                                 LOS ALAMOS SCIENTIFIC LABORATORY
C                                 LOS ALAMOS, NM   87545
C
C
      COMPLEX A(4,4),AT(5,4),B(4),BT(4),C(4),AINV(4,4),
     1 Z(4),XA,XB
      REAL R,RCOND,RCND,DELX,DET(2),DC(2)
      INTEGER LDA,N,INFO,I,J,INDX,KPROG(4),KFAIL(15),NERR
      DATA A/(2.E0,0.E0),(0.E0,1.E0),(0.E0,0.E0),(0.E0,0.E0),
     1 (0.E0,-1.E0),(2.E0,0.E0),(0.E0,0.E0),(0.E0,0.E0),
     2 (0.E0,0.E0),(0.E0,0.E0),(3.E0,0.E0),(0.E0,1.E0),
     3 (0.E0,0.E0),(0.E0,0.E0),(0.E0,-1.E0),(4.E0,0.E0)/
      DATA B/(3.E0,2.E0),(-1.E0,3.E0),(0.E0,-4.E0),(5.E0,0.E0)/
      DATA C/(1.E0,1.E0),(0.E0,1.E0),(0.E0,-1.E0),(1.E0,0.E0)/
      DATA AINV/(.66667E0,0.E0),(0.E0,1.E0),(0.E0,0.E0),(0.E0,
     1 0.E0),
     2 (0.E0,.33333E0),(.66667E0,0.E0),(0.E0,0.E0),(0.E0,0.E0),
     3 (0.E0,0.E0),(0.E0,0.E0),(.36364E0,0.E0),(0.E0,1.E0),
     4 (0.E0,0.E0),(0.E0,0.E0),(0.E0,.09091E0),(.27273E0,0.E0)/
      DATA DC/3.3E0,1.0E0/
      DATA KPROG/4HPOFA,4HPOCO,4HPOSL,4HPODI/
      DATA KFAIL/4HINFO,4H    ,4H    ,4HRCON,4HD   ,4H    ,4HSOLU,
     1 4HTION,4H    ,4HDETE,4HRMIN,4HANT ,4HINVE,4HRSE ,4H    /
      DATA RCND/.24099E0/
C
      DELX(XA,XB)=ABS(REAL(XA-XB))+ABS(AIMAG(XA-XB))
      LDA = 5
      N = 4
      NERR = 0
C
C     FORM AT FOR CPOFA AND BT FOR CPOSL, TEST CPOFA
      DO 20 J=1,N
        BT(J) = B(J)
        DO 10 I=1,N
          AT(I,J) = A(I,J)
   10   CONTINUE
   20 CONTINUE
      CALL CPOFA(AT,LDA,N,INFO)
      IF(INFO .EQ. 0)GO TO 30
      WRITE(LUN,201)KPROG(1),(KFAIL(I),I=1,3)
      NERR = NERR + 1
C
   30 CONTINUE
C     TEST CPOSL
      CALL CPOSL(AT,LDA,N,BT)
      INDX = 0
      DO 40 I=1,N
        IF(DELX(C(I),BT(I)) .GT. .0001) INDX=INDX+1
   40 CONTINUE
      IF(INDX .EQ. 0) GO TO 50
      WRITE(LUN,201)KPROG(3),(KFAIL(I),I=7,9)
      NERR = NERR + 1
C
   50 CONTINUE
C     FORM AT FOR CPOCO, TEST CPOCO
      DO 70 J=1,N
        DO 60 I=1,N
          AT(I,J) = A(I,J)
   60   CONTINUE
   70 CONTINUE
      CALL CPOCO(AT,LDA,N,RCOND,Z,INFO)
      R = ABS(RCND-RCOND)
      IF(R .LT. .0001)GO TO 80
      WRITE(LUN,201)KPROG(2),(KFAIL(I),I=4,6)
      NERR = NERR + 1
C
   80 CONTINUE
      IF(INFO .EQ. 0) GO TO 100
      WRITE(LUN,201)KPROG(2),(KFAIL(I),I=1,3)
      NERR = NERR + 1
C
  100 CONTINUE
C     TEST CPODI FOR JOB=11
      CALL CPODI(AT,LDA,N,DET,11)
      INDX = 0
      DO 110 I=1,2
        IF(ABS(DC(I)-DET(I)) .GT. .0001) INDX=INDX+1
  110 CONTINUE
      IF(INDX .EQ. 0) GO TO 120
      WRITE(LUN,201)KPROG(4),(KFAIL(I),I=10,12)
      NERR = NERR + 1
  120 CONTINUE
      INDX = 0
      DO 140 I=1,N
        DO 130 J=1,N
          IF(DELX(AINV(I,J),AT(I,J)) .GT. .0001) INDX=INDX+1
  130   CONTINUE
  140 CONTINUE
      IF(INDX .EQ. 0) GO TO 150
      WRITE(LUN,201)KPROG(4),(KFAIL(I),I=13,15)
      NERR = NERR + 1
  150 CONTINUE
      IF(KPRINT.GE.2.OR.NERR.NE.0)WRITE(LUN,200) NERR
  200 FORMAT(/,'* CPOQC - TEST FOR CPOFA, CPOCO, CPOSL AND CPODI FOUND',
     1  I1,' ERRORS.',/)
  201 FORMAT(/,'*** C',A4,' FAILURE-  ERROR IN ',3A4)
      RETURN
      END
      SUBROUTINE CPPQC(NERR,KPRINT,LUN)
C
C    QUICK CHECK FOR LINPACK SUBROUTINES CPPFA, CPPCO, CPPSL AND CPPDI.
C
C    LET  A*X=B  BE A COMPLEX LINEAR SYSTEM WHERE THE MATRIX  A  IS
C    OF THE PROPER TYPE FOR THE LINPACK SUBROUTINES BEING TESTED.
C    THE VALUES OF  A  AND  B  AND THE PRE-COMPUTED VALUES OF  C
C    (THE SOLUTION VECTOR),  AINV  (INVERSE OF MATRIX  A ),  DC
C    (DETERMINANT OF  A ), AND  RCND  ( RCOND ) ARE ENTERED
C    WITH DATA STATEMENTS.
C
C    THE COMPUTED TEST RESULTS FOR  X, RCOND, THE DETERMINANT, AND
C    THE INVERSE ARE COMPARED TO THE STORED PRE-COMPUTED VALUES.
C    FAILURE OF THE TEST OCCURS WHEN AGREEMENT TO 3 SIGNIFICANT
C    DIGITS IS NOT ACHIEVED AND AN ERROR MESSAGE INDICATING WHICH
C    LINPACK SUBROUTINE FAILED AND WHICH QUANTITY WAS INVOLVED IS
C    PRINTED.  A SUMMARY LINE IS ALWAYS PRINTED.
C
C    NO INPUT ARGUMENTS ARE REQUIRED.
C    ON RETURN,  NERR  (INTEGER TYPE) CONTAINS THE TOTAL COUNT OF
C    ALL FAILURES DETECTED BY CPPQC.
C
C    THE LINPACK ROUTINES LISTED ABOVE ARE CALLED.  (LINPACK ROUTINES
C    CALL BLAS ROUTINES.)
C
C    MESSAGE STATEMENTS ASSUME THAT 4 CHARACTERS MAY BE ACCOMMODATED
C    BY A SINGLE MACHINE WORD.
C
C    OCTOBER 16, 1980             E. A. VOORHEES, GROUP C-3
C                                 LOS ALAMOS SCIENTIFIC LABORATORY
C                                 LOS ALAMOS, NM   87545
C
C
      COMPLEX AP(10),AT(10),B(4),BT(4),C(4),AINV(10),
     1 Z(4),XA,XB
      REAL R,RCOND,RCND,DELX,DET(2),DC(2)
      INTEGER N,INFO,I,J,INDX,KPROG(4),KFAIL(15),NERR
      DATA AP/(2.E0,0.E0),(0.E0,-1.E0),(2.E0,0.E0),(0.E0,0.E0),
     1 (0.E0,0.E0),(3.E0,0.E0),(0.E0,0.E0),(0.E0,0.E0),
     2 (0.E0,-1.E0),(4.E0,0.E0)/
      DATA B/(3.E0,2.E0),(-1.E0,3.E0),(0.E0,-4.E0),(5.E0,0.E0)/
      DATA C/(1.E0,1.E0),(0.E0,1.E0),(0.E0,-1.E0),(1.E0,0.E0)/
      DATA AINV/(.66667E0,0.E0),(0.E0,.33333E0),(.66667E0,0.E0),(0.E0,0.
     1E0),
     2 (0.E0,0.E0),(.36364E0,0.E0),(0.E0,0.E0),(0.E0,0.E0),
     3 (0.E0,.09091E0),(.27273E0,0.E0)/
      DATA DC/3.3E0,1.0E0/
      DATA KPROG/4HPPFA,4HPPCO,4HPPSL,4HPPDI/
      DATA KFAIL/4HINFO,4H    ,4H    ,4HRCON,4HD   ,4H    ,4HSOLU,
     1 4HTION,4H    ,4HDETE,4HRMIN,4HANT ,4HINVE,4HRSE ,4H    /
      DATA RCND/.24099E0/
C
      DELX(XA,XB)=ABS(REAL(XA-XB))+ABS(AIMAG(XA-XB))
      N = 4
      NERR = 0
C
C     FORM AT FOR CPPFA AND BT FOR CPPSL, TEST CPPFA
      DO 10 J=1,N
        BT(J) = B(J)
   10 CONTINUE
      DO 20 I=1,10
        AT(I) = AP(I)
   20 CONTINUE
      CALL CPPFA(AT,N,INFO)
      IF(INFO .EQ. 0)GO TO 30
      WRITE(LUN,201)KPROG(1),(KFAIL(I),I=1,3)
      NERR = NERR + 1
C
   30 CONTINUE
C     TEST CPPSL
      CALL CPPSL(AT,N,BT)
      INDX = 0
      DO 40 I=1,N
        IF(DELX(C(I),BT(I)) .GT. .0001) INDX=INDX+1
   40 CONTINUE
      IF(INDX .EQ. 0) GO TO 50
      WRITE(LUN,201)KPROG(3),(KFAIL(I),I=7,9)
      NERR = NERR + 1
C
   50 CONTINUE
C     FORM AT FOR CPPCO, TEST CPPCO
      DO 60 I=1,10
        AT(I) = AP(I)
   60 CONTINUE
      CALL CPPCO(AT,N,RCOND,Z,INFO)
      R = ABS(RCND-RCOND)
      IF(R .LT. .0001)GO TO 80
      WRITE(LUN,201)KPROG(2),(KFAIL(I),I=4,6)
      NERR = NERR + 1
C
   80 CONTINUE
      IF(INFO .EQ. 0) GO TO 100
      WRITE(LUN,201)KPROG(2),(KFAIL(I),I=1,3)
      NERR = NERR + 1
C
  100 CONTINUE
C     TEST CPPDI FOR JOB=11
      CALL CPPDI(AT,N,DET,11)
      INDX = 0
      DO 110 I=1,2
        IF(ABS(DC(I)-DET(I)) .GT. .0001) INDX=INDX+1
  110 CONTINUE
      IF(INDX .EQ. 0) GO TO 120
      WRITE(LUN,201)KPROG(4),(KFAIL(I),I=10,12)
      NERR = NERR + 1
  120 CONTINUE
      INDX = 0
      DO 140 I=1,10
        IF(DELX(AINV(I),AT(I)) .GT. .0001) INDX=INDX+1
  140 CONTINUE
      IF(INDX .EQ. 0) GO TO 150
      WRITE(LUN,201)KPROG(4),(KFAIL(I),I=13,15)
      NERR = NERR + 1
  150 CONTINUE
      IF(KPRINT.GE.2.OR.NERR.NE.0)WRITE(LUN,200) NERR
  200 FORMAT(/,'* CPPQC - TEST FOR CPPFA, CPPCO, CPPSL AND CPPDI FOUND',
     1  I1,' ERRORS.',/)
  201 FORMAT(/,'*** C',A4,' FAILURE-  ERROR IN ',3A4)
      RETURN
      END
      SUBROUTINE CSIQC(NERR,KPRINT,LUN)
C
C    QUICK CHECK FOR LINPACK SUBROUTINES CSIFA, CSICO, CSISL AND CSIDI.
C
C    LET  A*X=B  BE A COMPLEX LINEAR SYSTEM WHERE THE MATRIX  A  IS
C    OF THE PROPER TYPE FOR THE LINPACK SUBROUTINES BEING TESTED.
C    THE VALUES OF  A  AND  B  AND THE PRE-COMPUTED VALUES OF  C
C    (THE SOLUTION VECTOR),  AINV  (INVERSE OF MATRIX  A ),  DC
C    (DETERMINANT OF  A ), AND  RCND  ( RCOND ) ARE ENTERED
C    WITH DATA STATEMENTS.
C
C    THE COMPUTED TEST RESULTS FOR  X, RCOND, THE DETERMINANT, AND
C    THE INVERSE ARE COMPARED TO THE STORED PRE-COMPUTED VALUES.
C    FAILURE OF THE TEST OCCURS WHEN AGREEMENT TO 3 SIGNIFICANT
C    DIGITS IS NOT ACHIEVED AND AN ERROR MESSAGE INDICATING WHICH
C    LINPACK SUBROUTINE FAILED AND WHICH QUANTITY WAS INVOLVED IS
C    PRINTED.  A SUMMARY LINE IS ALWAYS PRINTED.
C
C    NO INPUT ARGUMENTS ARE REQUIRED.
C    ON RETURN,  NERR  (INTEGER TYPE) CONTAINS THE TOTAL COUNT OF
C    ALL FAILURES DETECTED BY CSIQC.
C
C    THE LINPACK ROUTINES LISTED ABOVE ARE CALLED.  (LINPACK ROUTINES
C    CALL BLAS ROUTINES.)
C
C    MESSAGE STATEMENTS ASSUME THAT 4 CHARACTERS MAY BE ACCOMMODATED
C    BY A SINGLE MACHINE WORD.
C
C    OCTOBER 21, 1980             E. A. VOORHEES, GROUP C-3
C                                 LOS ALAMOS SCIENTIFIC LABORATORY
C                                 LOS ALAMOS, NM   87545
C
C
      COMPLEX A(4,4),AT(5,4),B(4),BT(4),C(4),AINV(4,4),DET(2),DC(2),
     1 Z(4),XA,XB
      REAL R,RCOND,RCND,DELX
      INTEGER LDA,N,IPVT(4),INFO,I,J,INDX,KPROG(4),KFAIL(15),NERR
      DATA A/(2.E0,0.E0),(0.E0,1.E0),(0.E0,0.E0),(0.E0,0.E0),
     1 (0.E0,-1.E0),(2.E0,0.E0),(0.E0,0.E0),(0.E0,0.E0),
     2 (0.E0,0.E0),(0.E0,0.E0),(3.E0,0.E0),(0.E0,1.E0),
     3 (0.E0,0.E0),(0.E0,0.E0),(0.E0,-1.E0),(4.E0,0.E0)/
      DATA B/(3.E0,2.E0),(1.E0,1.E0),(0.E0,-4.E0),(3.E0,0.E0)/
      DATA C/(1.E0,1.E0),(0.E0,1.E0),(0.E0,-1.E0),(1.E0,0.E0)/
      DATA AINV/(.40000E0,0.E0),(0.E0,1.E0),(0.E0,0.E0),(0.E0,
     1 0.E0),
     2 (0.E0,.20000E0),(.40000E0,0.E0),(0.E0,0.E0),(0.E0,0.E0),
     3 (0.E0,0.E0),(0.E0,0.E0),(.30769E0,0.E0),(0.E0,1.E0),
     4 (0.E0,0.E0),(0.E0,0.E0),(0.E0,.07692E0),(.23077E0,0.E0)/
      DATA DC/(6.5E0,0.E0),(1.0E0,0.E0)/
      DATA KPROG/4HSIFA,4HSICO,4HSISL,4HSIDI/
      DATA KFAIL/4HINFO,4H    ,4H    ,4HRCON,4HD   ,4H    ,4HSOLU,
     1 4HTION,4H    ,4HDETE,4HRMIN,4HANT ,4HINVE,4HRSE ,4H    /
      DATA RCND/.58692E0/
C
      DELX(XA,XB)=ABS(REAL(XA-XB))+ABS(AIMAG(XA-XB))
      LDA = 5
      N = 4
      NERR = 0
C
C     FORM AT FOR CSIFA AND BT FOR CSISL, TEST CSIFA
      DO 20 J=1,N
        BT(J) = B(J)
        DO 10 I=1,N
          AT(I,J) = A(I,J)
   10   CONTINUE
   20 CONTINUE
      CALL CSIFA(AT,LDA,N,IPVT,INFO)
      IF(INFO .EQ. 0)GO TO 30
      WRITE(LUN,201)KPROG(1),(KFAIL(I),I=1,3)
      NERR = NERR + 1
C
   30 CONTINUE
C     TEST CSISL
      CALL CSISL(AT,LDA,N,IPVT,BT)
      INDX = 0
      DO 40 I=1,N
        IF(DELX(C(I),BT(I)) .GT. .0001) INDX=INDX+1
   40 CONTINUE
      IF(INDX .EQ. 0) GO TO 50
      WRITE(LUN,201)KPROG(3),(KFAIL(I),I=7,9)
      NERR = NERR + 1
C
   50 CONTINUE
C     FORM AT FOR CSICO, TEST CSICO
      DO 70 J=1,N
        DO 60 I=1,N
          AT(I,J) = A(I,J)
   60   CONTINUE
   70 CONTINUE
      CALL CSICO(AT,LDA,N,IPVT,RCOND,Z)
      R = ABS(RCND-RCOND)
      IF(R .LT. .0001)GO TO 80
      WRITE(LUN,201)KPROG(2),(KFAIL(I),I=4,6)
      NERR = NERR + 1
C
   80 CONTINUE
C     TEST CSIDI FOR JOB=11
      CALL CSIDI(AT,LDA,N,IPVT,DET,Z,11)
      INDX = 0
      DO 110 I=1,2
        IF(DELX(DC(I),DET(I)) .GT. .0001) INDX=INDX+1
  110 CONTINUE
      IF(INDX .EQ. 0) GO TO 120
      WRITE(LUN,201)KPROG(4),(KFAIL(I),I=10,12)
      NERR = NERR + 1
  120 CONTINUE
      INDX = 0
      DO 140 I=1,N
        DO 130 J=1,N
          IF(DELX(AINV(I,J),AT(I,J)) .GT. .0001) INDX=INDX+1
  130   CONTINUE
  140 CONTINUE
      IF(INDX .EQ. 0) GO TO 150
      WRITE(LUN,201)KPROG(4),(KFAIL(I),I=13,15)
      NERR = NERR + 1
  150 CONTINUE
      IF(KPRINT.GE.2.OR.NERR.NE.0)WRITE(LUN,200) NERR
  200 FORMAT(/,'* CSIQC - TEST FOR CSIFA, CSICO, CSISL AND CSIDI FOUND',
     1  I1,' ERRORS.',/)
  201 FORMAT(/,'*** C',A4,' FAILURE-  ERROR IN ',3A4)
      RETURN
      END
      SUBROUTINE CCHQC(NERR,KPRINT,LUN)
C
C    QUICK CHECK FOR LINPACK SUBROUTINE CCHDC.
C
C    THE CHOLESKY FACTORIZATION OF MATRIX  A  IS COMPARED TO
C    THE STORED PRE-COMPUTED FACTORIZATION OF  A  (ENTERED
C    WITH A DATA STATEMENT).  FAILURE OF THE TEST OCCURS WHEN
C    AGREEMENT TO 3 SIGNIFICANT DIGITS IS NOT ACHIEVED AND AN
C    ERROR MESSAGE IS PRINTED.
C
C    THE INTEGER VALUES OF JPVT AND INFO ARE SIMILARLY TESTED.
C    LACK OF AGREEMENT RESULTS IN AN ERROR MESSAGE.  A SUMMARY
C    LINE IS ALWAYS PRINTED.
C
C    NO INPUT ARGUMENTS ARE REQUIRED.  ON RETURN, NERR (INTEGER
C    TYPE) CONTAINS THE TOTAL COUNT OF ALL FAILURES DETECTED.
C
C    LINPACK SUBROUTINE  CCHDC  IS CALLED.  (LINPACK SUBROUTINES
C    CALL  BLAS  ROUTINES.)
C
C    MESSAGE STATEMENTS ASSUME THAT 4 CHARACTERS MAY BE ACCOMMO-
C    DATED BY A SINGLE MACHINE WORD.
C
C    OCTOBER 27, 1980               E. A. VOORHEES, GROUP C-3
C                                   LOS ALAMOS SCIENTIFIC LABORATORY
C                                   LOS ALAMOS,  NM   87545
C
C
      COMPLEX A(4,4),WORK(4),AT(5,4),AF(4,4)
      INTEGER LDA,P,JPVT(4),JOB,INFO,JPVTT(4),I,J,INFOC,JPVTC(4)
      INTEGER KFAIL(9),INDX
      REAL DELX
      DATA A/(2.E0,0.E0),(0.E0,1.E0),(0.E0,0.E0),(0.E0,0.E0),
     1 (0.E0,-1.E0),(2.E0,0.E0),(0.E0,0.E0),(0.E0,0.E0),
     2 (0.E0,0.E0),(0.E0,0.E0),(3.E0,0.E0),(0.E0,1.E0),
     3 (0.E0,0.E0),(0.E0,0.E0),(0.E0,-1.E0),(4.E0,0.E0)/
      DATA JPVT/0,-1,1,0/
      DATA AF/(1.73205E0,0.E0),(0.E0,1.E0),(0.E0,0.E0),(0.E0,0.E0),
     1 (0.E0,-.57735E0),(1.91485E0,0.E0),(0.E0,0.E0),(0.E0,0.E0),
     2 (0.E0,0.E0),(0.E0,0.E0),(1.41421E0,0.E0),(0.E0,1.E0),
     3 (0.E0,0.E0),(0.E0,0.E0),(0.E0,-.70711E0),(1.22475E0,0.E0)/
      DATA INFOC/4/
      DATA JPVTC/3,4,1,2/
      DATA KFAIL/4HFACT,4HORIN,4HG   ,4HJPVT,4H    ,4H    ,
     1 4HINFO,4H    ,4H    /
C
      JOB = 1
      LDA = 5
      P = 4
      NERR = 0
C
C     FORM AT AND JPVTT.
      DO 20 J=1,P
        JPVTT(J) = JPVT(J)
        DO 10 I=1,P
          AT(I,J) = A(I,J)
   10   CONTINUE
   20 CONTINUE
C
C     TEST CCHDC.
      CALL CCHDC(AT,LDA,P,WORK,JPVTT,JOB,INFO)
      INDX = 0
      DO 40 J=1,P
        DO 30 I=1,P
          DELX = ABS(REAL(AT(I,J)-AF(I,J)))+ABS(AIMAG(AT(I,J)-AF(I,J)))
          IF(DELX .GT. .0001) INDX=INDX+1
   30   CONTINUE
   40 CONTINUE
      IF(INDX .EQ. 0) GO TO 50
      WRITE(LUN,201) (KFAIL(I),I=1,3)
      NERR = NERR + 1
C
   50 CONTINUE
      INDX = 0
      DO 60 I=1,P
        IF(JPVTT(I) .NE. JPVTC(I)) INDX=INDX+1
   60 CONTINUE
      IF(INDX .EQ. 0) GO TO 70
      WRITE(LUN,201) (KFAIL(I),I=4,6)
      NERR = NERR + 1
C
   70 CONTINUE
      IF(INFO  .EQ. INFOC) GO TO 80
      WRITE(LUN,201) (KFAIL(I),I=7,9)
      NERR = NERR + 1
C
   80 CONTINUE
      IF(KPRINT.GE.2.OR.NERR.NE.0)WRITE(LUN,200)NERR
  200 FORMAT(/,'* CCHQC - TEST FOR CCHDC FOUND ',I1,' ERRORS.',/,
     1 6X,'(NO TEST FOR CCHUD, CCHDD OR CCHEX)',/)
  201 FORMAT(/,'*** CCHDC FAILURE-  ERROR IN ',3A4)
      RETURN
      END
      SUBROUTINE CGTQC(NERR,KPRINT,LUN)
C
C    QUICK CHECK FOR LINPACK SUBROUTINE CGTSL.
C
C    LET  A*X=B  BE A COMPLEX LINEAR SYSTEM WHERE THE MATRIX  A  IS
C    OF THE PROPER TYPE FOR THE LINPACK SUBROUTINE BEING TESTED.
C    THE VALUES OF  A  AND  B  AND THE PRE-COMPUTED VALUES OF  CX
C    (THE SOLUTION VECTOR) ARE ENTERED WITH DATA STATEMENTS.
C
C    THE COMPUTED VALUES OF  X  ARE COMPARED TO THE STORED
C    PRE-COMPUTED VALUES OF CX.  FAILURE OF THE TEST OCCURS WHEN
C    AGREEMENT TO 3 SIGNIFICANT DIGITS IS NOT ACHIEVED AND AN
C    ERROR MESSAGE IS PRINTED.  A SUMMARY LINE IS ALWAYS PRINTED.
C
C    NO INPUT ARGUMENTS ARE REQUIRED.
C    ON RETURN,  NERR  (INTEGER TYPE) CONTAINS THE TOTAL COUNT
C    OF ALL FAILURES DETECTED BY CGTQC.
C
C    THE LINPACK ROUTINE LISTED ABOVE IS CALLED.  (LINPACK ROUTINES
C    CALL BLAS ROUTINES.)
C
C    MESSAGE STATEMENTS ASSUME THAT 4 CHARACTERS MAY BE ACCOMMODATED
C    BY A SINGLE MACHINE WORD.
C
C    OCTOBER 24, 1980             E. A. VOORHEES, GROUP C-3
C                                 LOS ALAMOS SCIENTIFIC LABORATORY
C                                 LOS ALAMOS, NM   87545
C
C
      COMPLEX C(4),D(4),E(4),B(4),CX(4),CT(4),DT(4),ET(4),BT(4)
      INTEGER N,INFO,KFAIL(4),I,INDX,NERR
      REAL DELX
      DATA C/(0.E0,0.E0),(0.E0,1.E0),(0.E0,0.E0),(0.E0,1.E0)/
      DATA D/(2.E0,0.E0),(2.E0,0.E0),(3.E0,0.E0),(4.E0,0.E0)/
      DATA E/(0.E0,-1.E0),(0.E0,0.E0),(0.E0,-1.E0),(0.E0,0.E0)/
      DATA B/(3.E0,2.E0),(-1.E0,3.E0),(0.E0,-4.E0),(5.E0,0.E0)/
      DATA CX/(1.E0,1.E0),(0.E0,1.E0),(0.E0,-1.E0),(1.E0,0.E0)/
      DATA KFAIL/4HINFO,4H    ,4HSOLU,4HTION/
      N = 4
      NERR = 0
      DO 10 I=1,N
        CT(I) = C(I)
        DT(I) = D(I)
        ET(I) = E(I)
        BT(I) = B(I)
   10 CONTINUE
      CALL CGTSL(N,CT,DT,ET,BT,INFO)
      IF(INFO .EQ. 0) GO TO 20
      WRITE(LUN,200)(KFAIL(I),I=1,2)
      NERR = NERR + 1
   20 CONTINUE
      INDX = 0
      DO 30 I=1,N
        DELX = ABS(REAL(BT(I)-CX(I)))+ABS(AIMAG(BT(I)-CX(I)))
        IF(DELX .GT. .0001) INDX=INDX+1
   30 CONTINUE
      IF(INDX .EQ. 0) GO TO 40
      WRITE(LUN,201)(KFAIL(I),I=3,4)
      NERR = NERR + 1
   40 CONTINUE
      IF(KPRINT.GE.2.OR.NERR.NE.0) WRITE(LUN,200) NERR
  200 FORMAT(/,'* CGTQC - TEST FOR CGTSL FOUND ',I1,' ERRORS.',/)
  201 FORMAT(/,'*** CGTSL FAILURE-  ERROR IN ',2A4)
      RETURN
      END
      SUBROUTINE CHIQC(NERR,KPRINT,LUN)
C
C    QUICK CHECK FOR LINPACK SUBROUTINES CHIFA, CHICO, CHISL AND CHIDI.
C
C    LET  A*X=B  BE A COMPLEX LINEAR SYSTEM WHERE THE MATRIX  A  IS
C    OF THE PROPER TYPE FOR THE LINPACK SUBROUTINES BEING TESTED.
C    THE VALUES OF  A  AND  B  AND THE PRE-COMPUTED VALUES OF  C
C    (THE SOLUTION VECTOR),  AINV  (INVERSE OF MATRIX  A ),  DC
C    (DETERMINANT OF  A ), AND  RCND  ( RCOND ) ARE ENTERED
C    WITH DATA STATEMENTS.
C
C    THE COMPUTED TEST RESULTS FOR  X, RCOND, THE DETERMINANT, AND
C    THE INVERSE ARE COMPARED TO THE STORED PRE-COMPUTED VALUES.
C    FAILURE OF THE TEST OCCURS WHEN AGREEMENT TO 3 SIGNIFICANT
C    DIGITS IS NOT ACHIEVED AND AN ERROR MESSAGE INDICATING WHICH
C    LINPACK SUBROUTINE FAILED AND WHICH QUANTITY WAS INVOLVED IS
C    PRINTED.  A SUMMARY LINE IS ALWAYS PRINTED.
C
C    NO INPUT ARGUMENTS ARE REQUIRED.
C    ON RETURN,  NERR  (INTEGER TYPE) CONTAINS THE TOTAL COUNT OF
C    ALL FAILURES DETECTED BY CHIQC.
C
C    THE LINPACK ROUTINES LISTED ABOVE ARE CALLED.  (LINPACK ROUTINES
C    CALL BLAS ROUTINES.)
C
C    MESSAGE STATEMENTS ASSUME THAT 4 CHARACTERS MAY BE ACCOMMODATED
C    BY A SINGLE MACHINE WORD.
C
C    OCTOBER 22, 1980             E. A. VOORHEES, GROUP C-3
C                                 LOS ALAMOS SCIENTIFIC LABORATORY
C                                 LOS ALAMOS, NM   87545
C
C
      COMPLEX A(4,4),AT(5,4),B(4),BT(4),C(4),AINV(4,4),
     1 Z(4),XA,XB
      REAL R,RCOND,RCND,DELX,DET(2),DC(2)
      INTEGER LDA,N,IPVT(4),INFO,I,J,INDX,KPROG(4),KFAIL(18),NERR
      INTEGER INERT(3),IRT(3)
      DATA A/(2.E0,0.E0),(0.E0,1.E0),(0.E0,0.E0),(0.E0,0.E0),
     1 (0.E0,-1.E0),(2.E0,0.E0),(0.E0,0.E0),(0.E0,0.E0),
     2 (0.E0,0.E0),(0.E0,0.E0),(3.E0,0.E0),(0.E0,1.E0),
     3 (0.E0,0.E0),(0.E0,0.E0),(0.E0,-1.E0),(4.E0,0.E0)/
      DATA B/(3.E0,2.E0),(-1.E0,3.E0),(0.E0,-4.E0),(5.E0,0.E0)/
      DATA C/(1.E0,1.E0),(0.E0,1.E0),(0.E0,-1.E0),(1.E0,0.E0)/
      DATA AINV/(.66667E0,0.E0),(0.E0,1.E0),(0.E0,0.E0),(0.E0,
     1 0.E0),
     2 (0.E0,.33333E0),(.66667E0,0.E0),(0.E0,0.E0),(0.E0,0.E0),
     3 (0.E0,0.E0),(0.E0,0.E0),(.36364E0,0.E0),(0.E0,1.E0),
     4 (0.E0,0.E0),(0.E0,0.E0),(0.E0,.09091E0),(.27273E0,0.E0)/
      DATA DC/3.3E0,1.0E0/
      DATA KPROG/4HHIFA,4HHICO,4HHISL,4HHIDI/
      DATA KFAIL/4HINFO,4H    ,4H    ,4HRCON,4HD   ,4H    ,4HSOLU,
     1 4HTION,4H    ,4HDETE,4HRMIN,4HANT ,4HINVE,4HRSE ,4H    ,
     2 4HINER,4HTIA ,4H    /
      DATA RCND/.24099E0/
      DATA IRT/4,0,0/
C
      DELX(XA,XB)=ABS(REAL(XA-XB))+ABS(AIMAG(XA-XB))
      LDA = 5
      N = 4
      NERR = 0
C
C     FORM AT FOR CHIFA AND BT FOR CHISL, TEST CHIFA
      DO 20 J=1,N
        BT(J) = B(J)
        DO 10 I=1,N
          AT(I,J) = A(I,J)
   10   CONTINUE
   20 CONTINUE
      CALL CHIFA(AT,LDA,N,IPVT,INFO)
      IF(INFO .EQ. 0)GO TO 30
      WRITE(LUN,201)KPROG(1),(KFAIL(I),I=1,3)
      NERR = NERR + 1
C
   30 CONTINUE
C     TEST CHISL
      CALL CHISL(AT,LDA,N,IPVT,BT)
      INDX = 0
      DO 40 I=1,N
        IF(DELX(C(I),BT(I)) .GT. .0001) INDX=INDX+1
   40 CONTINUE
      IF(INDX .EQ. 0) GO TO 50
      WRITE(LUN,201)KPROG(3),(KFAIL(I),I=7,9)
      NERR = NERR + 1
C
   50 CONTINUE
C     FORM AT FOR CHICO, TEST CHICO
      DO 70 J=1,N
        DO 60 I=1,N
          AT(I,J) = A(I,J)
   60   CONTINUE
   70 CONTINUE
      CALL CHICO(AT,LDA,N,IPVT,RCOND,Z)
      R = ABS(RCND-RCOND)
      IF(R .LT. .0001)GO TO 80
      WRITE(LUN,201)KPROG(2),(KFAIL(I),I=4,6)
      NERR = NERR + 1
C
   80 CONTINUE
C     TEST CHIDI FOR JOB=111
      CALL CHIDI(AT,LDA,N,IPVT,DET,INERT,Z,111)
      INDX = 0
      DO 110 I=1,2
        IF(ABS(DC(I)-DET(I)) .GT. .0001) INDX=INDX+1
  110 CONTINUE
      IF(INDX .EQ. 0) GO TO 120
      WRITE(LUN,201)KPROG(4),(KFAIL(I),I=10,12)
      NERR = NERR + 1
  120 CONTINUE
      INDX = 0
      DO 140 I=1,N
        DO 130 J=1,N
          IF(DELX(AINV(I,J),AT(I,J)) .GT. .0001) INDX=INDX+1
  130   CONTINUE
  140 CONTINUE
      IF(INDX .EQ. 0) GO TO 150
      WRITE(LUN,201)KPROG(4),(KFAIL(I),I=13,15)
      NERR = NERR + 1
  150 CONTINUE
      INDX = 0
      DO 160 I=1,3
        IF((INERT(I)-IRT(I)) .NE. 0) INDX=INDX+1
  160 CONTINUE
      IF(INDX .EQ. 0) GO TO 170
      WRITE(LUN,201)KPROG(4),(KFAIL(I),I=16,18)
      NERR = NERR + 1
  170 CONTINUE
      IF(KPRINT.GE.2.OR.NERR.NE.0)WRITE(LUN,200) NERR
  200 FORMAT(/,'* CHIQC - TEST FOR CHIFA, CHICO, CHISL AND CHIDI FOUND',
     1  I1,' ERRORS.',/)
  201 FORMAT(/,'*** C',A4,' FAILURE-  ERROR IN ',3A4)
      RETURN
      END
      SUBROUTINE CHPQC(NERR,KPRINT,LUN)
C
C    QUICK CHECK FOR LINPACK SUBROUTINES CHPFA, CHPCO, CHPSL AND CHPDI.
C
C    LET  A*X=B  BE A COMPLEX LINEAR SYSTEM WHERE THE MATRIX  A  IS
C    OF THE PROPER TYPE FOR THE LINPACK SUBROUTINES BEING TESTED.
C    THE VALUES OF  A  AND  B  AND THE PRE-COMPUTED VALUES OF  C
C    (THE SOLUTION VECTOR),  AINV  (INVERSE OF MATRIX  A ),  DC
C    (DETERMINANT OF  A ), AND  RCND  ( RCOND ) ARE ENTERED
C    WITH DATA STATEMENTS.
C
C    THE COMPUTED TEST RESULTS FOR  X, RCOND, THE DETERMINANT, AND
C    THE INVERSE ARE COMPARED TO THE STORED PRE-COMPUTED VALUES.
C    FAILURE OF THE TEST OCCURS WHEN AGREEMENT TO 3 SIGNIFICANT
C    DIGITS IS NOT ACHPEVED AND AN ERROR MESSAGE INDICATING WHICH
C    LINPACK SUBROUTINE FAILED AND WHICH QUANTITY WAS INVOLVED IS
C    PRINTED.  A SUMMARY LINE IS ALWAYS PRINTED.
C
C    NO INPUT ARGUMENTS ARE REQUIRED.
C    ON RETURN,  NERR  (INTEGER TYPE) CONTAINS THE TOTAL COUNT OF
C    ALL FAILURES DETECTED BY CHPQC.
C
C    THE LINPACK ROUTINES LISTED ABOVE ARE CALLED.  (LINPACK ROUTINES
C    CALL BLAS ROUTINES.)
C
C    MESSAGE STATEMENTS ASSUME THAT 4 CHARACTERS MAY BE ACCOMMODATED
C    BY A SINGLE MACHPNE WORD.
C
C    OCTOBER 22, 1980             E. A. VOORHEES, GROUP C-3
C                                 LOS ALAMOS SCIENTIFIC LABORATORY
C                                 LOS ALAMOS, NM   87545
C
C
      COMPLEX AP(10),AT(10),B(4),BT(4),C(4),AINV(10),
     1 Z(4),XA,XB
      REAL R,RCOND,RCND,DELX,DET(2),DC(2)
      INTEGER N,IPVT(4),INFO,I,J,INDX,KPROG(4),KFAIL(18),NERR
      INTEGER INERT(3),IRT(3)
      DATA AP/(2.E0,0.E0),(0.E0,-1.E0),(2.E0,0.E0),(0.E0,0.E0),
     1 (0.E0,0.E0),(3.E0,0.E0),(0.E0,0.E0),(0.E0,0.E0),
     2 (0.E0,-1.E0),(4.E0,0.E0)/
      DATA B/(3.E0,2.E0),(-1.E0,3.E0),(0.E0,-4.E0),(5.E0,0.E0)/
      DATA C/(1.E0,1.E0),(0.E0,1.E0),(0.E0,-1.E0),(1.E0,0.E0)/
      DATA AINV/(.66667E0,0.E0),(0.E0,.33333E0),(.66667E0,0.E0),
     1 (0.E0,0.E0),
     2 (0.E0,0.E0),(.36364E0,0.E0),(0.E0,0.E0),(0.E0,0.E0),
     3 (0.E0,.09091E0),(.27273E0,0.E0)/
      DATA DC/3.3E0,1.0E0/
      DATA KPROG/4HHPFA,4HHPCO,4HHPSL,4HHPDI/
      DATA KFAIL/4HINFO,4H    ,4H    ,4HRCON,4HD   ,4H    ,4HSOLU,
     1 4HTION,4H    ,4HDETE,4HRMIN,4HANT ,4HINVE,4HRSE ,4H    ,
     2 4HINER,4HTIA ,4H    /
      DATA RCND/.24099E0/
      DATA IRT/4,0,0/
C
      DELX(XA,XB)=ABS(REAL(XA-XB))+ABS(AIMAG(XA-XB))
      N = 4
      NERR = 0
C
C     FORM AT FOR CHPFA AND BT FOR CHPSL, TEST CHPFA
      DO 10 J=1,N
        BT(J) = B(J)
   10 CONTINUE
      DO 20 I=1,10
        AT(I) = AP(I)
   20 CONTINUE
      CALL CHPFA(AT,N,IPVT,INFO)
      IF(INFO .EQ. 0)GO TO 30
      WRITE(LUN,201)KPROG(1),(KFAIL(I),I=1,3)
      NERR = NERR + 1
C
   30 CONTINUE
C     TEST CHPSL
      CALL CHPSL(AT,N,IPVT,BT)
      INDX = 0
      DO 40 I=1,N
        IF(DELX(C(I),BT(I)) .GT. .0001) INDX=INDX+1
   40 CONTINUE
      IF(INDX .EQ. 0) GO TO 50
      WRITE(LUN,201)KPROG(3),(KFAIL(I),I=7,9)
      NERR = NERR + 1
C
   50 CONTINUE
C     FORM AT FOR CHPCO, TEST CHPCO
      DO 70 I=1,10
        AT(I) = AP(I)
   70 CONTINUE
      CALL CHPCO(AT,N,IPVT,RCOND,Z)
      R = ABS(RCND-RCOND)
      IF(R .LT. .0001)GO TO 80
      WRITE(LUN,201)KPROG(2),(KFAIL(I),I=4,6)
      NERR = NERR + 1
C
   80 CONTINUE
C     TEST CHPDI FOR JOB=111
      CALL CHPDI(AT,N,IPVT,DET,INERT,Z,111)
      INDX = 0
      DO 110 I=1,2
        IF(ABS(DC(I)-DET(I)) .GT. .0001) INDX=INDX+1
  110 CONTINUE
      IF(INDX .EQ. 0) GO TO 120
      WRITE(LUN,201)KPROG(4),(KFAIL(I),I=10,12)
      NERR = NERR + 1
  120 CONTINUE
      INDX = 0
      DO 140 I=1,10
        IF(DELX(AINV(I),AT(I)) .GT. .0001) INDX=INDX+1
  140 CONTINUE
      IF(INDX .EQ. 0) GO TO 150
      WRITE(LUN,201)KPROG(4),(KFAIL(I),I=13,15)
      NERR = NERR + 1
  150 CONTINUE
      INDX = 0
      DO 160 I=1,3
        IF((INERT(I)-IRT(I)) .NE. 0) INDX=INDX+1
  160 CONTINUE
      IF(INDX .EQ. 0) GO TO 170
      WRITE(LUN,201)KPROG(4),(KFAIL(I),I=16,18)
      NERR = NERR + 1
  170 CONTINUE
      IF(KPRINT.GE.2.OR.NERR.NE.0)WRITE(LUN,200) NERR
  200 FORMAT(/,'* CHPQC - TEST FOR CHPFA, CHPCO, CHPSL AND CHPDI FOUND',
     1  I1,' ERRORS.',/)
  201 FORMAT(/,'*** C',A4,' FAILURE-  ERROR IN ',3A4)
      RETURN
      END
      SUBROUTINE CPTQC(NERR,KPRINT,LUN)
C
C    QUICK CHECK FOR LINPACK SUBROUTINE CPTSL.
C
C    LET  A*X=B  BE A COMPLEX LINEAR SYSTEM WHERE THE MATRIX  A  IS
C    OF THE PROPER TYPE FOR THE LINPACK SUBROUTINE BEING TESTED.
C    THE VALUES OF  A  AND  B  AND THE PRE-COMPUTED VALUES OF  CX
C    (THE SOLUTION VECTOR) ARE ENTERED WITH DATA STATEMENTS.
C
C    THE COMPUTED VALUES OF  X  ARE COMPARED TO THE STORED
C    PRE-COMPUTED VALUES OF CX.  FAILURE OF THE TEST OCCURS WHEN
C    AGREEMENT TO 3 SIGNIFICANT DIGITS IS NOT ACHIEVED AND AN
C    ERROR MESSAGE IS PRINTED.  A SUMMARY LINE IS ALWAYS PRINTED.
C
C    NO INPUT ARGUMENTS ARE REQUIRED.
C    ON RETURN,  NERR  (INTEGER TYPE) CONTAINS THE TOTAL COUNT
C    OF ALL FAILURES DETECTED BY CPTQC.
C
C    THE LINPACK ROUTINE LISTED ABOVE IS CALLED.  (LINPACK ROUTINES
C    CALL BLAS ROUTINES.)
C
C    MESSAGE STATEMENTS ASSUME THAT 4 CHARACTERS MAY BE ACCOMMODATED
C    BY A SINGLE MACHINE WORD.
C
C    OCTOBER 24, 1980             E. A. VOORHEES, GROUP C-3
C                                 LOS ALAMOS SCIENTIFIC LABORATORY
C                                 LOS ALAMOS, NM   87545
C
C
      COMPLEX D(4),E(4),B(4),CX(4),DT(4),ET(4),BT(4)
      INTEGER N,I,INDX,NERR
      REAL DELX
      DATA D/(2.E0,0.E0),(2.E0,0.E0),(3.E0,0.E0),(4.E0,0.E0)/
      DATA E/(0.E0,-1.E0),(0.E0,0.E0),(0.E0,-1.E0),(0.E0,0.E0)/
      DATA B/(3.E0,2.E0),(-1.E0,3.E0),(0.E0,-4.E0),(5.E0,0.E0)/
      DATA CX/(1.E0,1.E0),(0.E0,1.E0),(0.E0,-1.E0),(1.E0,0.E0)/
      N = 4
      NERR = 0
      DO 10 I=1,N
        DT(I) = D(I)
        ET(I) = E(I)
        BT(I) = B(I)
   10 CONTINUE
      CALL CPTSL(N,DT,ET,BT)
      INDX = 0
      DO 30 I=1,N
        DELX = ABS(REAL(BT(I)-CX(I)))+ABS(AIMAG(BT(I)-CX(I)))
        IF(DELX .GT. .0001) INDX=INDX+1
   30 CONTINUE
      IF(INDX .EQ. 0) GO TO 40
      WRITE(LUN,201)
      NERR = NERR + 1
   40 CONTINUE
      IF(KPRINT.GE.2.OR.NERR.NE.0)WRITE(LUN,200) NERR
  200 FORMAT(/,'* CPTQC - TEST FOR CPTSL FOUND ',I1,' ERRORS.',/)
  201 FORMAT(/,'*** CPTSL FAILURE-  ERROR IN SOLUTION')
      RETURN
      END
      SUBROUTINE CSPQC(NERR,KPRINT,LUN)
C
C    QUICK CHECK FOR LINPACK SUBROUTINES CSPFA, CSPCO, CSPSL AND CSPDI.
C
C    LET  A*X=B  BE A COMPLEX LINEAR SYSTEM WHERE THE MATRIX  A  IS
C    OF THE PROPER TYPE FOR THE LINPACK SUBROUTINES BEING TESTED.
C    THE VALUES OF  A  AND  B  AND THE PRE-COMPUTED VALUES OF  C
C    (THE SOLUTION VECTOR),  AINV  (INVERSE OF MATRIX  A ),  DC
C    (DETERMINANT OF  A ), AND  RCND  ( RCOND ) ARE ENTERED
C    WITH DATA STATEMENTS.
C
C    THE COMPUTED TEST RESULTS FOR  X, RCOND, THE DETERMINANT, AND
C    THE INVERSE ARE COMPARED TO THE STORED PRE-COMPUTED VALUES.
C    FAILURE OF THE TEST OCCURS WHEN AGREEMENT TO 3 SIGNIFICANT
C    DIGITS IS NOT ACHIEVED AND AN ERROR MESSAGE INDICATING WHICH
C    LINPACK SUBROUTINE FAILED AND WHICH QUANTITY WAS INVOLVED IS
C    PRINTED.  A SUMMARY LINE IS ALWAYS PRINTED.
C
C    NO INPUT ARGUMENTS ARE REQUIRED.
C    ON RETURN,  NERR  (INTEGER TYPE) CONTAINS THE TOTAL COUNT OF
C    ALL FAILURES DETECTED BY CSPQC.
C
C    THE LINPACK ROUTINES LISTED ABOVE ARE CALLED.  (LINPACK ROUTINES
C    CALL BLAS ROUTINES.)
C
C    MESSAGE STATEMENTS ASSUME THAT 4 CHARACTERS MAY BE ACCOMMODATED
C    BY A SINGLE MACHINE WORD.
C
C    OCTOBER 21, 1980             E. A. VOORHEES, GROUP C-3
C                                 LOS ALAMOS SCIENTIFIC LABORATORY
C                                 LOS ALAMOS, NM   87545
C
C
      COMPLEX AP(10),AT(10),B(4),BT(4),C(4),AINV(10),DET(2),DC(2),
     1 Z(4),XA,XB
      REAL R,RCOND,RCND,DELX
      INTEGER N,IPVT(4),INFO,I,J,INDX,KPROG(4),KFAIL(15),NERR
      DATA AP/(2.E0,0.E0),(0.E0,-1.E0),(2.E0,0.E0),(0.E0,0.E0),
     1 (0.E0,0.E0),(3.E0,0.E0),(0.E0,0.E0),(0.E0,0.E0),
     2 (0.E0,-1.E0),(4.E0,0.E0)/
      DATA B/(3.E0,2.E0),(1.E0,1.E0),(0.E0,-4.E0),(3.E0,0.E0)/
      DATA C/(1.E0,1.E0),(0.E0,1.E0),(0.E0,-1.E0),(1.E0,0.E0)/
      DATA AINV/(.4E0,0.E0),(0.E0,.2E0),(.4E0,0.E0),(0.E0,0.E0),
     1 (0.E0,0.E0),(.30769E0,0.E0),(0.E0,0.E0),(0.E0,0.E0),
     2 (0.E0,.07692E0),(.23077E0,0.E0)/
      DATA DC/(6.5E0,0.E0),(1.0E0,0.E0)/
      DATA KPROG/4HSPFA,4HSPCO,4HSPSL,4HSPDI/
      DATA KFAIL/4HINFO,4H    ,4H    ,4HRCON,4HD   ,4H    ,4HSOLU,
     1 4HTION,4H    ,4HDETE,4HRMIN,4HANT ,4HINVE,4HRSE ,4H    /
      DATA RCND/.58692E0/
C
      DELX(XA,XB)=ABS(REAL(XA-XB))+ABS(AIMAG(XA-XB))
      N = 4
      NERR = 0
C
C     FORM AT FOR CSPFA AND BT FOR CSPSL, TEST CSPFA
      DO 10 J=1,N
        BT(J) = B(J)
   10 CONTINUE
      DO 20 I=1,10
        AT(I) = AP(I)
   20 CONTINUE
      CALL CSPFA(AT,N,IPVT,INFO)
      IF(INFO .EQ. 0)GO TO 30
      WRITE(LUN,201)KPROG(1),(KFAIL(I),I=1,3)
      NERR = NERR + 1
C
   30 CONTINUE
C     TEST CSPSL
      CALL CSPSL(AT,N,IPVT,BT)
      INDX = 0
      DO 40 I=1,N
        IF(DELX(C(I),BT(I)) .GT. .0001) INDX=INDX+1
   40 CONTINUE
      IF(INDX .EQ. 0) GO TO 50
      WRITE(LUN,201)KPROG(3),(KFAIL(I),I=7,9)
      NERR = NERR + 1
C
   50 CONTINUE
C     FORM AT FOR CSPCO, TEST CSPCO
      DO 60 I=1,10
        AT(I) = AP(I)
   60 CONTINUE
      CALL CSPCO(AT,N,IPVT,RCOND,Z)
      R = ABS(RCND-RCOND)
      IF(R .LT. .0001)GO TO 80
      WRITE(LUN,201)KPROG(2),(KFAIL(I),I=4,6)
      NERR = NERR + 1
C
   80 CONTINUE
C     TEST CSPDI FOR JOB=11
      CALL CSPDI(AT,N,IPVT,DET,Z,11)
      INDX = 0
      DO 110 I=1,2
        IF(DELX(DC(I),DET(I)) .GT. .0001) INDX=INDX+1
  110 CONTINUE
      IF(INDX .EQ. 0) GO TO 120
      WRITE(LUN,201)KPROG(4),(KFAIL(I),I=10,12)
      NERR = NERR + 1
  120 CONTINUE
      INDX = 0
      DO 140 I=1,10
          IF(DELX(AINV(I),AT(I)) .GT. .0001) INDX=INDX+1
  140 CONTINUE
      IF(INDX .EQ. 0) GO TO 150
      WRITE(LUN,201)KPROG(4),(KFAIL(I),I=13,15)
      NERR = NERR + 1
  150 CONTINUE
      IF(KPRINT.GE.2.OR.NERR.NE.0)WRITE(LUN,200) NERR
  200 FORMAT(/,'* CSPQC - TEST FOR CSPFA, CSPCO, CSPSL AND CSPDI FOUND',
     1  I1,' ERRORS.',/)
  201 FORMAT(/,'*** C',A4,' FAILURE-  ERROR IN ',3A4)
      RETURN
      END
      SUBROUTINE CTRQC(NERR,KPRINT,LUN)
C
C    QUICK CHECK FOR LINPACK SUBROUTINES CTRFA, CTRCO, CTRSL AND CTRDI.
C
C    LET  A*X=B  BE A COMPLEX LINEAR SYSTEM WHERE THE MATRIX  A  IS
C    OF THE PROPER TYPE FOR THE LINPACK SUBROUTINES BEING TESTED.
C    THE VALUES OF  A  AND  B  AND THE PRE-COMPUTED VALUES OF  C
C    (THE SOLUTION VECTOR),  AINV  (INVERSE OF MATRIX  A ),  DC
C    (DETERMINANT OF  A ), AND  RCND  ( RCOND ) ARE ENTERED
C    WITH DATA STATEMENTS.
C
C    THE COMPUTED TEST RESULTS FOR  X, RCOND, THE DETERMINANT, AND
C    THE INVERSE ARE COMPARED TO THE STORED PRE-COMPUTED VALUES.
C    FAILURE OF THE TEST OCCURS WHEN AGREEMENT TO 3 SIGNIFICANT
C    DIGITS IS NOT ACHIEVED AND AN ERROR MESSAGE INDICATING WHICH
C    LINPACK SUBROUTINE FAILED AND WHICH QUANTITY WAS INVOLVED IS
C    PRINTED.  A SUMMARY LINE IS ALWAYS PRINTED.
C
C    NO INPUT ARGUMENTS ARE REQUIRED.
C    ON RETURN,  NERR  (INTEGER TYPE) CONTAINS THE TOTAL COUNT OF
C    ALL FAILURES DETECTED BY CTRQC.
C
C    THE LINPACK ROUTINES LISTED ABOVE ARE CALLED.  (LINPACK ROUTINES
C    CALL BLAS ROUTINES.)
C
C    MESSAGE STATEMENTS ASSUME THAT 4 CHARACTERS MAY BE ACCOMMODATED
C    BY A SINGLE MACHINE WORD.
C
C    OCTOBER 23, 1980             E. A. VOORHEES, GROUP C-3
C                                 LOS ALAMOS SCIENTIFIC LABORATORY
C                                 LOS ALAMOS, NM   87545
C
C
      COMPLEX A(4,4),AT(5,4),B(4,2),BT(4),C(4),AINV(4,4,2),DET(2),
     1 DC(2),Z(4),XA,XB
      REAL R,RCOND,RCND(2),DELX
      INTEGER LDA,N,INFO,I,J,INDX,KPROG(4),KFAIL(15),NERR
      INTEGER JOB,K,KK
      DATA A/(2.E0,0.E0),(0.E0,1.E0),(0.E0,0.E0),(0.E0,0.E0),
     1 (0.E0,-1.E0),(2.E0,0.E0),(0.E0,0.E0),(0.E0,0.E0),
     2 (0.E0,0.E0),(0.E0,0.E0),(3.E0,0.E0),(0.E0,1.E0),
     3 (0.E0,0.E0),(0.E0,0.E0),(0.E0,-1.E0),(4.E0,0.E0)/
      DATA B/(2.E0,2.E0),(-1.E0,3.E0),(0.E0,-3.E0),(5.E0,0.E0),
     1 (3.E0,2.E0),(0.E0,2.E0),(0.E0,-4.E0),(4.E0,0.E0)/
      DATA C/(1.E0,1.E0),(0.E0,1.E0),(0.E0,-1.E0),(1.E0,0.E0)/
      DATA AINV/(.50000E0,0.E0),(0.E0,-.25000E0),(0.E0,0.E0),(0.E0,0.E0)
     1,
     2 (0.E0,-1.00000E0),(.50000E0,0.E0),(0.E0,0.E0),(0.E0,0.E0),
     3 (0.E0,0.E0),(0.E0,0.E0),(.33333E0,0.E0),(0.E0,-.083333E0),
     4 (0.E0,0.E0),(0.E0,0.E0),(0.E0,-1.00000E0),(.25000E0,0.E0),
     5 (.50000E0,0.E0),(0.E0,1.00000E0),(0.E0,0.E0),(0.E0,0.E0),
     6 (0.E0,.25000E0),(.50000E0,0.E0),(0.E0,0.E0),(0.E0,0.E0),
     7 (0.E0,0.E0),(0.E0,0.E0),(.33333E0,0.E0),(0.E0,1.00000E0),
     8 (0.E0,0.E0),(0.E0,0.E0),(0.E0,.083333E0),(.25000E0,0.E0)/
      DATA DC/(4.8E0,0.E0),(1.0E0,0.E0)/
      DATA KPROG/4HTRFA,4HTRCO,4HTRSL,4HTRDI/
      DATA KFAIL/4HINFO,4H    ,4H    ,4HRCON,4HD   ,4H    ,4HSOLU,
     1 4HTION,4H    ,4HDETE,4HRMIN,4HANT ,4HINVE,4HRSE ,4H    /
      DATA RCND/.45695E0,.37047E0/
C
      DELX(XA,XB)=ABS(REAL(XA-XB))+ABS(AIMAG(XA-XB))
      LDA = 5
      N = 4
      NERR = 0
C
C     K=1 FOR LOWER, K=2 FOR UPPER
      DO 160 K=1,2
C
C     FORM AT FOR CTRCO AND BT FOR CTRSL, TEST CTRCO
      DO 20 J=1,N
        BT(J) = B(J,K)
        DO 10 I=1,N
          AT(I,J) = A(I,J)
   10   CONTINUE
   20 CONTINUE
      JOB = K - 1
      CALL CTRCO(AT,LDA,N,RCOND,Z,JOB)
      R = ABS(RCND(K)-RCOND)
      IF(R .LT. .0001)GO TO 30
      WRITE(LUN,201)KPROG(2),(KFAIL(I),I=4,6)
      NERR = NERR + 1
C
   30 CONTINUE
C     TEST CTRSL FOR JOB= 0 OR 1
      CALL CTRSL(AT,LDA,N,BT,JOB,INFO)
      IF(INFO .EQ. 0) GO TO 40
      WRITE(LUN,201)KPROG(3),(KFAIL(I),I=1,3)
      NERR = NERR + 1
   40 CONTINUE
      INDX = 0
      DO 50 I=1,N
        IF(DELX(C(I),BT(I)) .GT. .0001) INDX=INDX+1
   50 CONTINUE
      IF(INDX .EQ. 0) GO TO 60
      WRITE(LUN,201)KPROG(3),(KFAIL(I),I=7,9)
      NERR = NERR + 1
C
   60 CONTINUE
C     FORM BT FOR CTRSL
      KK = 3 - K
      DO 70 J=1,N
        BT(J) = B(J,KK)
   70 CONTINUE
C
C     TEST CTRSL FOR JOB EQUAL TO 10 OR 11
      JOB = 9 + K
      CALL CTRSL(AT,LDA,N,BT,JOB,INFO)
      IF(INFO .EQ. 0) GO TO 80
      WRITE(LUN,201)KPROG(3),(KFAIL(I),I=1,3)
      NERR = NERR + 1
   80 CONTINUE
      INDX = 0
      DO 90 I=1,N
        IF(DELX(C(I),BT(I)) .GT. .0001) INDX=INDX+1
   90 CONTINUE
      IF(INDX .EQ. 0) GO TO 100
      WRITE(LUN,201)KPROG(3),(KFAIL(I),I=7,9)
      NERR = NERR + 1
C
  100 CONTINUE
C     TEST CTRDI FOR JOB= 110 OR 111
      JOB = 109 + K
      CALL CTRDI(AT,LDA,N,DET,JOB,INFO)
      IF(INFO .EQ. 0) GO TO 105
      WRITE(LUN,201)KPROG(4),(KFAIL(I),I=1,3)
      NERR = NERR + 1
  105 CONTINUE
      INDX = 0
      DO 110 I=1,2
        IF(DELX(DC(I),DET(I)) .GT. .0001) INDX=INDX+1
  110 CONTINUE
      IF(INDX .EQ. 0) GO TO 120
      WRITE(LUN,201)KPROG(4),(KFAIL(I),I=10,12)
      NERR = NERR + 1
  120 CONTINUE
      INDX = 0
      DO 140 I=1,N
        DO 130 J=1,N
          IF(DELX(AINV(I,J,K),AT(I,J)) .GT. .0001) INDX=INDX+1
  130   CONTINUE
  140 CONTINUE
      IF(INDX .EQ. 0) GO TO 150
      WRITE(LUN,201)KPROG(4),(KFAIL(I),I=13,15)
      NERR = NERR + 1
  150 CONTINUE
  160 CONTINUE
      IF(KPRINT.GE.2.OR.NERR.NE.0)WRITE(LUN,200) NERR
  200 FORMAT(/,'* CTRQC - TEST FOR CTRCO, CTRSL AND CTRDI FOUND',
     1  I2,' ERRORS.',/)
  201 FORMAT(/,'*** C',A4,' FAILURE-  ERROR IN ',3A4)
      RETURN
      END
      SUBROUTINE CQRQC(NERR,KPRINT,LUN)
C
C    QUICK CHECK FOR LINPACK SUBROUTINES CQRDC AND CQRSL.
C
C    THE RETURNED FLOATING POINT VALUES FROM CQRDC AND CQRSL FOR
C    FACTORED X, QRAUX, QY, QTY, B, RSD, AND XB ARE COMPARED TO
C    THEIR CORRESPONDING STORED PRE-COMPUTED VALUES (ENTERED
C    WITH DATA STATEMENTS).  FAILURE OF THE TEST OCCURS WHEN
C    AGREEMENT TO 3 SIGNIFICANT DIGITS IS NOT ACHIEVED AND AN
C    ERROR MESSAGE IS THEN PRINTED.
C
C    THE RETURNED INTEGER VALUES OF JPVT AND INFO ARE ALSO CHECKED.
C    LACK OF AGREEMENT RESULTS IN AN ERROR MESSAGE.  A SUMMARY
C    LINE IS ALWAYS PRINTED.
C
C    NO INPUT ARGUMENTS ARE REQUIRED.  ON RETURN, NERR (INTEGER
C    TYPE) CONTAINS THE TOTAL COUNT OF ALL FAILURES DETECTED.
C
C    LINPACK SUBROUTINES  CQRDC  AND CQRSL  ARE CALLED.  (LINPACK
C    SUBROUTINES CALL  BLAS  ROUTINES.)
C
C    MESSAGE STATEMENTS ASSUME THAT 4 CHARACTERS MAY BE ACCOMMO-
C    DATED BY A SINGLE MACHINE WORD.
C
C    OCTOBER 29, 1980               E. A. VOORHEES, GROUP C-3
C                                   LOS ALAMOS SCIENTIFIC LABORATORY
C                                   LOS ALAMOS,  NM   87545
C
C
      COMPLEX A(4,4),QRAUX(4),WORK(4),Y(4),QY(4),QTY(4),B(4),RSD(4),XB(4
     1)
      COMPLEX AT(5,4),AC(4,4),QRAUXC(4),QYC(4),QTYC(4),BC(4),RSDC(4),XBC
     1(4),X1,X2
      INTEGER LDX,N,P,JPVT(4),JOB,K,INFO
      INTEGER JPVTT(4),JPVTC(4),KPROG(2),KFAIL(18),I,J,INDX(5),NERR,L,LP
      REAL DELX
      DATA A/(2.E0,0.E0),(0.E0,1.E0),(0.E0,0.E0),(0.E0,0.E0),
     1 (0.E0,-1.E0),(2.E0,0.E0),(0.E0,0.E0),(0.E0,0.E0),
     2 (0.E0,0.E0),(0.E0,0.E0),(3.E0,0.E0),(0.E0,1.E0),
     3 (0.E0,0.E0),(0.E0,0.E0),(0.E0,-1.E0),(4.E0,0.E0)/
      DATA JPVT/0,-1,1,0/
      DATA Y/(3.E0,2.E0),(-1.E0,3.E0),(0.E0,-4.E0),(5.E0,0.E0)/
      DATA AC/(-3.16228E0,0.E0),(0.E0,0.E0),(.94868E0,0.E0),
     1 (0.E0,.31623E0),(0.E0,2.21359E0),(-3.47851E0,0.E0),
     2 (0.E0,.31623E0),(.94868E0,0.E0),(0.E0,0.E0),(0.E0,0.E0),
     3 (2.23607E0,0.E0),(0.E0,.70711E0),(0.E0,0.E0),(0.E0,0.E0),
     4 (0.E0,-1.78885E0),(-1.34164E0,0.E0)/
      DATA QRAUXC/(1.E0,0.E0),(1.E0,0.E0),(1.70711E0,0.E0),(0.E0,0.E0)/
      DATA JPVTC/3,4,1,2/
      DATA QYC/(0.E0,-5.81378E0),(-2.68328E0,0.E0),(-1.89737E0,-1.58114E
     10),
     2 (1.58114E0,-3.79473E0)/
      DATA QTYC/(0.E0,5.37587E0),(-3.47851E0,0.E0),(4.02492E0,2.23607E0)
     1,
     2 (0.E0,-1.34164E0)/
      DATA BC/(0.E0,-1.E0),(1.E0,0.E0),(1.E0,1.E0),(0.E0,1.E0)/
      DATA RSDC/(0.E0,0.E0),(0.E0,0.E0),(0.E0,0.E0),(0.E0,0.E0)/
      DATA XBC/(3.E0,2.E0),(-1.E0,3.E0),(0.E0,-4.E0),(5.E0,0.E0)/
      DATA KPROG/4HQRDC,4HQRSL/
      DATA KFAIL/4HFACT,4HOR  ,4HQRAU,4HX   ,4HJPVT,4H    ,4HQY  ,
     1 4H    ,4HQTY ,4H    ,4HSOLU,4HTION,4HRSD ,4H    ,4HXB  ,4H    ,
     2 4HINFO,4H    /
C
      DELX(X1,X2) = ABS(REAL(X1-X2))+ABS(AIMAG(X1-X2))
C
      LDX = 5
      N = 4
      P = 4
      K = 4
      NERR = 0
C
C     FORM AT AND JPVTT
      DO 20 J=1,N
        JPVTT(J) = JPVT(J)
        DO 10 I=1,N
          AT(I,J) = A(I,J)
   10   CONTINUE
   20 CONTINUE
C
C     TEST CQRDC (FACTOR, QRAUX, JPVT)
      JOB = 1
      CALL CQRDC(AT,LDX,N,P,QRAUX,JPVTT,WORK,JOB)
      INDX(1) = 0
      DO 40 J=1,N
        DO 30 I=1,N
          IF(DELX(AT(I,J),AC(I,J)) .GT. .0001) INDX(1) = INDX(1)+1
   30   CONTINUE
   40 CONTINUE
      IF(INDX(1) .EQ. 0) GO TO 50
        WRITE(LUN, 501) KPROG(1),(KFAIL(I),I=1,2)
      NERR = NERR + 1
C
   50 CONTINUE
      DO 60 I=1,2
      INDX(I) = 0
   60 CONTINUE
      DO 70 I=1,N
        IF(DELX(QRAUX(I),QRAUXC(I)) .GT. .0001) INDX(1) = INDX(1)+1
        IF(JPVTT(I) .NE. JPVTC(I)) INDX(2) = INDX(2)+1
   70 CONTINUE
      DO 90 I=1,2
        L = 2*I+1
        LP = L+1
        IF(INDX(I) .EQ. 0) GO TO 80
        WRITE(LUN,501) KPROG(1),(KFAIL(J),J=L,LP)
        NERR = NERR + 1
   80   CONTINUE
   90 CONTINUE
C
C
C     TEST CQRSL (QY, QTY, SOLUTION, RSD, XB, INFO)
      JOB = 11111
      DO 100 I=1,5
        INDX(I) = 0
  100 CONTINUE
      CALL CQRSL(AT,LDX,N,K,QRAUX,Y,QY,QTY,B,RSD,XB,JOB,INFO)
      DO 110 I=1,N
        IF(DELX(QY(I),QYC(I)) .GT. .0001) INDX(1) = INDX(1)+1
        IF(DELX(QTY(I),QTYC(I)) .GT. .0001) INDX(2) = INDX(2)+1
        IF(DELX(B(I),BC(I)) .GT. .0001) INDX(3) = INDX(3)+1
        IF(DELX(RSD(I),RSDC(I)) .GT. .0001) INDX(4) = INDX(4)+1
        IF(DELX(XB(I),XBC(I)) .GT. .0001) INDX(5) = INDX(5)+1
  110 CONTINUE
      DO 130 I=1,5
        L = 2*I+5
        LP = L+1
        IF(INDX(I) .EQ. 0) GO TO 120
        WRITE(LUN,501) KPROG(2),(KFAIL(J),J=L,LP)
        NERR = NERR + 1
  120   CONTINUE
  130 CONTINUE
      IF(INFO .EQ. 0) GO TO 140
      WRITE(LUN,501) KPROG(2),(KFAIL(I),I=17,18)
      NERR = NERR + 1
  140 CONTINUE
      IF(KPRINT.GE.2.OR.NERR.NE.0)WRITE(LUN,500) NERR
  500 FORMAT(/,'* CQRQC - TEST FOR CQRDC AND CQRSL FOUND ',
     1    I1,' ERRORS.',/)
  501 FORMAT(/,'*** C',A4,' FAILURE-  ERROR IN ',2A4)
      RETURN
      END
      SUBROUTINE CSVQC(NERR,KPRINT,LUN)
C
C    QUICK CHECK FOR LINPACK SUBROUTINE CSVDC.
C
C    THE RETURNED FLOATING POINT VALUES FROM CSVDC FOR
C    S, E, U, AND  V  ARE COMPARED TO THEIR
C    CORRESPONDING STORED PRE-COMPUTED VALUES (ENTERED
C    WITH DATA STATEMENTS).  FAILURE OF THE TEST OCCURS WHEN
C    AGREEMENT TO 3 SIGNIFICANT DIGITS IS NOT ACHIEVED AND
C    AN ERROR MESSAGE IS THEN PRINTED.
C
C    THE RETURNED INTEGER VALUE OF INFO IS ALSO CHECKED.
C    LACK OF AGREEMENT RESULTS IN AN ERROR MESSAGE.  A SUMMARY
C    LINE IS ALWAYS PRINTED.
C
C    NO INPUT ARGUMENTS ARE REQUIRED.  ON RETURN, NERR (INTEGER
C    TYPE) CONTAINS THE TOTAL COUNT OF ALL FAILURES DETECTED.
C
C    LINPACK SUBROUTINE  CSVDC  IS CALLED.  (LINPACK
C    SUBROUTINES CALL  BLAS  ROUTINES.)
C
C    MESSAGE STATEMENTS ASSUME THAT 4 CHARACTERS MAY BE ACCOMMO-
C    DATED BY A SINGLE MACHINE WORD.
C
C    OCTOBER 31, 1980               E. A. VOORHEES, GROUP C-3
C                                   LOS ALAMOS SCIENTIFIC LABORATORY
C                                   LOS ALAMOS,  NM   87545
C
C
      COMPLEX A(4,4),WORK(4),S(4),E(4),U(4,4),V(4,4)
      COMPLEX AT(5,4),SC(4),EC(4),UVC(4,4),X1,X2
      INTEGER LDX,N,P,LDU,LDV,JOB,INFO
      INTEGER KFAIL(5),I,J,INDX(4)
      REAL DELX
      DATA A/(2.E0,0.E0),(0.E0,1.E0),(0.E0,0.E0),(0.E0,0.E0),
     1 (0.E0,-1.E0),(2.E0,0.E0),(0.E0,0.E0),(0.E0,0.E0),
     2 (0.E0,0.E0),(0.E0,0.E0),(3.E0,0.E0),(0.E0,1.E0),
     3 (0.E0,0.E0),(0.E0,0.E0),(0.E0,-1.E0),(4.E0,0.E0)/
      DATA KFAIL/4HS   ,4HE   ,4HU   ,4HV   ,4HINFO/
      DATA SC/(4.61803E0,0.E0),(3.0E0,0.E0),(2.38197E0,0.E0),(1.E0,0.E0)
     1/
      DATA EC/(0.E0,0.E0),(0.E0,0.E0),(0.E0,0.E0),(0.E0,0.E0)/
      DATA UVC/(0.E0,0.E0),(0.E0,0.E0),(-.52573E0,0.E0),(0.E0,-.85065E0)
     1,
     2 (.70711E0,0.E0),(0.E0,.70711E0),(0.E0,0.E0),(0.E0,0.E0),
     3 (0.E0,0.E0),(0.E0,0.E0),(-.85065E0,0.E0),(0.E0,.52573E0),
     4 (-.70711E0,0.E0),(0.E0,.70711E0),(0.E0,0.E0),(0.E0,0.E0)/
C
      DELX(X1,X2) = ABS(REAL(X1-X2))+ABS(AIMAG(X1-X2))
C
      N = 4
      P = 4
      LDX = 5
      LDU = 4
      LDV = 4
      NERR = 0
      JOB = 11
C
C     FORM AT
      DO 20 J=1,N
        DO10 I=1,N
          AT(I,J) = A(I,J)
   10   CONTINUE
   20 CONTINUE
C
C     TEST CSVDC  (S, E, U, V, INFO)
      DO 30 I=1,4
        INDX(I) = 0
   30 CONTINUE
      CALL CSVDC(AT,LDX,N,P,S,E,U,LDU,V,LDV,WORK,JOB,INFO)
      DO 50 J=1,N
        IF(DELX(S(J),SC(J)) .GT. .0001) INDX(1) = INDX(1)+1
        IF(DELX(E(J),EC(J)) .GT. .0001) INDX(2) = INDX(2)+1
        DO 40 I=1,N
          IF(DELX(U(I,J),UVC(I,J)) .GT. .0001) INDX(3) = INDX(3)+1
          IF(DELX(V(I,J),UVC(I,J)) .GT. .0001) INDX(4) = INDX(4)+1
   40   CONTINUE
   50 CONTINUE
      DO 70 I=1,4
        IF(INDX(I) .EQ. 0) GO TO 60
        WRITE(LUN,201) KFAIL(I)
        NERR = NERR + 1
   60   CONTINUE
   70 CONTINUE
      IF(INFO .EQ. 0) GO TO 80
      WRITE(LUN,201) KFAIL(5)
      NERR = NERR + 1
   80 CONTINUE
      IF(KPRINT.GE.2.OR.NERR.NE.0)WRITE(LUN,200) NERR
      RETURN
  200 FORMAT(/,'* CSVQC - TEST FOR CSVDC FOUND ',I1,' ERRORS.',/)
  201 FORMAT(/,'*** CSVQC FAILURE-  ERROR IN ',A4)
      END
      DOUBLE PRECISION FUNCTION D2MACH(I)
      DOUBLE PRECISION D1MACH
      COMMON/XXMULT/TIMES
      D2MACH=D1MACH(I)
      IF(I.EQ.1.OR. I.EQ.2) RETURN
      D2MACH = D2MACH * DBLE(TIMES)
      RETURN
      END
      REAL FUNCTION R2MACH(I)
      COMMON/XXMULT/TIMES
      R2MACH=R1MACH(I)
      IF(I.EQ.1.OR. I.EQ.2) RETURN
      R2MACH = R2MACH * TIMES
      RETURN
      END
