C
C   DRIVER FOR TESTING CMLIB ROUTINES
C     LOTPS
C
C    ONE INPUT DATA CARD IS REQUIRED
C         READ(LIN,1) KPRINT,TIMES
C    1    FORMAT(I1,E10.0)
C
C     KPRINT = 0   NO PRINTING
C              1   NO PRINTING FOR PASSED TESTS, SHORT MESSAGE
C                  FOR FAILED TESTS
C              2   PRINT SHORT MESSAGE FOR PASSED TESTS, FULLER
C                  INFORMATION FOR FAILED TESTS
C              3   PRINT COMPLETE QUICK-CHECK RESULTS
C
C                ***IMPORTANT NOTE***
C         ALL QUICK CHECKS USE ROUTINES R2MACH AND D2MACH
C         TO SET THE ERROR TOLERANCES.
C     TIMES IS A CONSTANT MULTIPLIER THAT CAN BE USED TO SCALE THE
C     VALUES OF R1MACH AND D1MACH SO THAT
C               R2MACH(I) = R1MACH(I) * TIMES   FOR I=3,4,5
C               D2MACH(I) = D1MACH(I) * TIMES   FOR I=3,4,5
C     THIS MAKES IT EASILY POSSIBLE TO CHANGE THE ERROR TOLERANCES
C     USED IN THE QUICK CHECKS.
C     IF TIMES .LE. 0.0 THEN TIMES IS DEFAULTED TO 1.0
C
C              ***END NOTE***
C
      COMMON/UNIT/LUN
      COMMON/MSG/ICNT,JTEST(38)
      COMMON/XXMULT/TIMES
      LUN=I1MACH(2)
      LIN=I1MACH(1)
      ITEST=1
C
C     READ KPRINT,TIMES PARAMETERS FROM DATA CARD..
C
      READ(LIN,1) KPRINT,TIMES
1     FORMAT(I1,E10.0)
      IF(TIMES.LE.0.) TIMES=1.
      CALL XSETUN(LUN)
      CALL XSETF(1)
      CALL XERMAX(1000)
C   TEST SGEEV CGEEV
      CALL LOTPQX(KPRINT,IPASS)
      ITEST=ITEST*IPASS
C
      IF(KPRINT.GE.1.AND.ITEST.NE.1) WRITE(LUN,2)
2     FORMAT(/' ***** WARNING -- AT LEAST ONE TEST FOR SUBLIBRARY LOTPS
     1HAS FAILED ***** ')
      IF(KPRINT.GE.1.AND.ITEST.EQ.1) WRITE(LUN,3)
3     FORMAT(/' ----- SUBLIBRARY LOTPS PASSED ALL TESTS ----- ')
      END
      DOUBLE PRECISION FUNCTION D2MACH(I)
      DOUBLE PRECISION D1MACH
      COMMON/XXMULT/TIMES
      D2MACH=D1MACH(I)
      IF(I.EQ.1.OR. I.EQ.2) RETURN
      D2MACH = D2MACH * DBLE(TIMES)
      RETURN
      END
      REAL FUNCTION R2MACH(I)
      COMMON/XXMULT/TIMES
      R2MACH=R1MACH(I)
      IF(I.EQ.1.OR. I.EQ.2) RETURN
      R2MACH = R2MACH * TIMES
      RETURN
      END
      SUBROUTINE LOTPQX(KPRINT,IPASS)
C
C     THIS IS A SIMPLE TEST DRIVER FOR SUBROUTINE LOTPS
C     IT PERFORMS A GROSS CHECK ON WHETHER OR NOT IT APPEARS TO BE
C     WORKING PROPERLY.
C
      COMMON/UNIT/LUN
      INTEGER KPRINT,IPASS
      DIMENSION X(5),Y(5),F(5),XO(2),YO(2),FO(2,2),IWK(100),WK(100)
      DATA X/0.,.2,.5,.6,1./,Y/.2,.7,0.,1.,.5/,XO/.2,.9/,YO/.1,.8/
     1 ,F/.2,.5,.6,.3,0./,NWK/100/,NIWK/100/
      IPASS=1
      CALL LOTPS(1,10,5,X,Y,F,2,XO,2,YO,IWK,NIWK,NIWKU,WK,NWK,NWKU,
     1 FO,KER)
      SMAC = SQRT(R2MACH(4))
      F11 = .37801139668405
      ER = ABS(FO(1,1) - F11)
      IF(KER.NE.0) THEN
       IF(KPRINT.GE.1) WRITE(LUN,2)
       IPASS=2
      ENDIF
      IF(ER.GT.SMAC) THEN
       IF(KPRINT.GE.1) WRITE(LUN,3)
       IPASS=2
      ENDIF
      IF(KER.NE.0.OR.ER.GT.SMAC)RETURN
  100 IF(KPRINT.GT.1) WRITE(LUN,1)
      RETURN
    1 FORMAT(1X,' ** TEST FOR SUBROUTINE LOTPS PASSED ** ',/)
    2 FORMAT(1X,'ERROR.  ERROR RETURN FROM LOTPS')
    3 FORMAT(1X,'ERROR. ACCURACY REQUIREMENTS FROM LOTPS NOT SATISFIED')
      END
