C
C   DRIVER FOR TESTING CMLIB ROUTINES
C     TWODQ
C
C    ONE INPUT DATA CARD IS REQUIRED
C         READ(LIN,1) KPRINT,TIMES
C    1    FORMAT(I1,E10.0)
C
C     KPRINT = 0   NO PRINTING
C              1   NO PRINTING FOR PASSED TESTS, SHORT MESSAGE
C                  FOR FAILED TESTS
C              2   PRINT SHORT MESSAGE FOR PASSED TESTS, FULLER
C                  INFORMATION FOR FAILED TESTS
C              3   PRINT COMPLETE QUICK-CHECK RESULTS
C
C                ***IMPORTANT NOTE***
C         ALL QUICK CHECKS USE ROUTINES R2MACH AND D2MACH
C         TO SET THE ERROR TOLERANCES.
C     TIMES IS A CONSTANT MULTIPLIER THAT CAN BE USED TO SCALE THE
C     VALUES OF R1MACH AND D1MACH SO THAT
C               R2MACH(I) = R1MACH(I) * TIMES   FOR I=3,4,5
C               D2MACH(I) = D1MACH(I) * TIMES   FOR I=3,4,5
C     THIS MAKES IT EASILY POSSIBLE TO CHANGE THE ERROR TOLERANCES
C     USED IN THE QUICK CHECKS.
C     IF TIMES .LE. 0.0 THEN TIMES IS DEFAULTED TO 1.0
C
C              ***END NOTE***
C
      COMMON/UNIT/LUN
      COMMON/MSG/ICNT,JTEST(38)
      COMMON/XXMULT/TIMES
      LUN=I1MACH(2)
      LIN=I1MACH(1)
      ITEST=1
C
C     READ KPRINT,TIMES PARAMETERS FROM DATA CARD..
C
      READ(LIN,1) KPRINT,TIMES
1     FORMAT(I1,E10.0)
      IF(TIMES.LE.0.) TIMES=1.
      CALL XSETUN(LUN)
      CALL XSETF(1)
      CALL XERMAX(1000)
C   TEST TWODQ
      CALL TWOQX1(KPRINT,IPASS)
      ITEST=ITEST*IPASS
C
      IF(KPRINT.GE.1.AND.ITEST.NE.1) WRITE(LUN,2)
2     FORMAT(/' ***** WARNING -- AT LEAST ONE TEST FOR SUBLIBRARY TWODQ
     1HAS FAILED ***** ')
      IF(KPRINT.GE.1.AND.ITEST.EQ.1) WRITE(LUN,3)
3     FORMAT(/' ----- SUBLIBRARY TWODQ PASSED ALL TESTS ----- ')
      END
      DOUBLE PRECISION FUNCTION D2MACH(I)
      DOUBLE PRECISION D1MACH
      COMMON/XXMULT/TIMES
      D2MACH=D1MACH(I)
      IF(I.EQ.1.OR. I.EQ.2) RETURN
      D2MACH = D2MACH * DBLE(TIMES)
      RETURN
      END
      REAL FUNCTION R2MACH(I)
      COMMON/XXMULT/TIMES
      R2MACH=R1MACH(I)
      IF(I.EQ.1.OR. I.EQ.2) RETURN
      R2MACH = R2MACH * TIMES
      RETURN
      END
      SUBROUTINE TWOQX1(KPRINT,IPASS)
C   This program integrates cos((x+y)*3.*pi)*(3.*pi)**2 over the
C   square (0.,0.),(1.,0.),(1.,1.),(0.,1.) to test the
C   subroutine twodq.
      COMMON/UNIT/LUN
      REAL X(3,2),Y(3,2),DATA(450),RES,ERR
      INTEGER IWORK(100),NU,ND,NEVALS,IFLAG,KPRINT,IPASS
      EXTERNAL F
      IPASS=1
      X(1,1)=0.
      Y(1,1)=0.
      X(2,1)=1.
      Y(2,1)=0.
      X(3,1)=1.
      Y(3,1)=1.
      X(1,2)=0.
      Y(1,2)=0.
      X(2,2)=1.
      Y(2,2)=1.
      X(3,2)=0.
      Y(3,2)=1.
      NU=0
      ND=0
      IFLAG=1
      TOL=MAX(SQRT(R2MACH(4)),1.E-5)
      CALL TWODQ(F,2,X,Y,1.E-04,1,50,4000,RES,ERR,NU,ND,
     *  NEVALS,IFLAG,DATA,IWORK)
      IF((IFLAG.EQ.0).AND.(ABS(-4.-RES).LT.TOL)) THEN
        IF(KPRINT.GE.2) WRITE(LUN,888)
  888 FORMAT(/, '** TEST FOR SUBROUTINE TWODQ PASSED ** ')
      ELSE
        IPASS=2
        IF(KPRINT.GE.1) WRITE(LUN,889)
  889 FORMAT(/,' ** TEST FOR SUBROUTINE TWODQ FAILED ** ')
      END IF
      RETURN
      END
      FUNCTION F(X,Y)
      F=COS((X+Y)*9.42477795)*9.42477795**2
      RETURN
      END
